/*  
 *  Copyright (c) 2001 Dan Gudmundsson
 *  See the file "license.terms" for information on usage and redistribution
 *  of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 * 
 *     $Id: esdl_conv.c,v 1.2 2001/11/22 15:09:11 dgud Exp $
 */
/* 
   Conversion functions 
*/
#include "esdl_conv.h"

float readFloat(char * buff) 
{
   float f;
   unsigned char * s; 
   s = (unsigned char *) &f;
   buff -= 4;   
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
   s[0] = buff[0];
   s[1] = buff[1];
   s[2] = buff[2];
   s[3] = buff[3];
#else
   s[0] = buff[3];
   s[1] = buff[2];
   s[2] = buff[1];
   s[3] = buff[0];
#endif
   return f;
}

double readDouble(char * buff) 
{
   double f;
   unsigned char * s; 
   s = (unsigned char *) &f;
   buff -= 8;   
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
   s[0] = buff[0];
   s[1] = buff[1];
   s[2] = buff[2];
   s[3] = buff[3];
   s[4] = buff[4];
   s[5] = buff[5];
   s[6] = buff[6];
   s[7] = buff[7];
#else
   s[0] = buff[7];
   s[1] = buff[6];
   s[2] = buff[5];
   s[3] = buff[4];
   s[4] = buff[3];
   s[5] = buff[2];
   s[6] = buff[1];
   s[7] = buff[0];
#endif
   return f;
}

