/*
 *  Copyright (c) 2001 Dan Gudmundsson
 *  See the file "license.terms" for information on usage and redistribution
 *  of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * 
 *     $Id: esdl_events.h,v 1.2 2001/11/22 15:09:11 dgud Exp $
 */
#ifdef __cplusplus
    extern "C" {
#endif 

#define SDL_PumpEventsFunc (EVENTS_H + 1) 
int es_pumpEvents(sdl_data *, int , char *);
#define SDL_PeepEventsFunc SDL_PumpEventsFunc+1
int es_peepEvents(sdl_data *, int , char *);
#define SDL_PollEventFunc  SDL_PeepEventsFunc+1
int es_pollEvent(sdl_data *, int , char *);
#define SDL_WaitEventFunc  SDL_PollEventFunc +1
int es_waitEvent(sdl_data *, int , char *);
#define SDL_PushEventFunc  SDL_WaitEventFunc +1
int es_pushEvent(sdl_data *, int , char *);
#define SDL_EventStateFunc SDL_PushEventFunc +1
int es_eventState(sdl_data *, int , char *);

#define SDL_GetMouseStateFunc MOUSE_H +1
int es_getMouseState(sdl_data *, int , char *);
#define SDL_GetRelativeMouseStateFunc SDL_GetMouseStateFunc+1
int es_getRelativeMouseState(sdl_data *, int , char *);
#define SDL_WarpMouseFunc SDL_GetRelativeMouseStateFunc +1
int es_warpMouse(sdl_data *, int len, char *buff);
#define  SDL_CreateCursorFunc SDL_WarpMouseFunc +1
int es_createCursor(sdl_data *, int len, char *buff);
#define SDL_SetCursorFunc SDL_CreateCursorFunc+1
int es_setCursor(sdl_data *, int len, char *buff);
#define SDL_GetCursorFunc SDL_SetCursorFunc+1
int es_getCursor(sdl_data *, int len, char *buff);
#define SDL_FreeCursorFunc SDL_GetCursorFunc+1
int es_freeCursor(sdl_data *, int len, char *buff);
#define SDL_ShowCursorFunc SDL_FreeCursorFunc+1
int es_showCursor(sdl_data *, int len, char *buff);

#define SDL_GetWMInfoFunc SDL_ShowCursorFunc+1
int es_getWMInfo(sdl_data *, int , char *);


#define SDL_EnableUNICODEFunc KEYBOARD_H +1
int es_enableUNICODE(sdl_data *, int , char *); 
#define SDL_EnableKeyRepeatFunc SDL_EnableUNICODEFunc+1
int es_enableKeyRepeat(sdl_data *, int , char *);
#define SDL_GetKeyNameFunc SDL_EnableKeyRepeatFunc+1
int es_getKeyName(sdl_data *, int , char *);
#define SDL_GetKeyStateFunc SDL_GetKeyNameFunc+1
int es_getKeyState(sdl_data *, int , char *);
#define SDL_GetModStateFunc SDL_GetKeyStateFunc+1
int es_getModState(sdl_data *, int , char *);
#define SDL_SetModStateFunc SDL_GetModStateFunc+1
int es_setModState(sdl_data *, int , char *);

#define SDL_GetAppStateFunc ACTIVE_H +1
int es_getAppState(sdl_data *, int , char *); 

#define SDL_NumJoysticksFunc JOYSTICK_H +1
int es_numJoysticks(sdl_data *, int , char *);       
#define SDL_JoystickNameFunc SDL_NumJoysticksFunc + 1
int es_joystick_name(sdl_data *, int , char *);
#define SDL_JoystickOpenFunc SDL_JoystickNameFunc + 1
int es_joystick_open(sdl_data *, int , char *);
#define SDL_JoystickOpenedFunc SDL_JoystickOpenFunc + 1
int es_joystick_opened(sdl_data *, int , char *);
#define SDL_JoystickIndexFunc SDL_JoystickOpenedFunc + 1
int es_joystick_index(sdl_data *, int , char *);
#define SDL_JoystickNumAxesFunc SDL_JoystickIndexFunc + 1
int es_joystick_numAxes(sdl_data *, int , char *);
#define SDL_JoystickNumBallsFunc SDL_JoystickNumAxesFunc + 1
int es_joystick_numBalls(sdl_data *, int , char *);
#define SDL_JoystickNumHatsFunc SDL_JoystickNumBallsFunc + 1
int es_joystick_numHats(sdl_data *, int , char *);
#define SDL_JoystickNumButtonsFunc SDL_JoystickNumHatsFunc + 1
int es_joystick_numButtons(sdl_data *, int , char *);
#define SDL_JoystickUpdateFunc SDL_JoystickNumButtonsFunc + 1
int es_joystick_update(sdl_data *, int , char *);
#define SDL_JoystickEventStateFunc SDL_JoystickUpdateFunc + 1
int es_joystick_eventState(sdl_data *, int , char *);
#define SDL_JoystickGetAxisFunc SDL_JoystickEventStateFunc + 1
int es_joystick_getAxis(sdl_data *, int , char *);
#define SDL_JoystickGetHatFunc SDL_JoystickGetAxisFunc + 1
int es_joystick_getHat(sdl_data *, int , char *);
#define SDL_JoystickGetButtonFunc SDL_JoystickGetHatFunc + 1
int es_joystick_getButton(sdl_data *, int , char *);
#define SDL_JoystickGetBallFunc SDL_JoystickGetButtonFunc + 1
int es_joystick_getBall(sdl_data *, int , char *);
#define SDL_JoystickCloseFunc SDL_JoystickGetBallFunc + 1
int es_joystick_close(sdl_data *, int , char *);
