/*
 *  Copyright (c) 2001 Dan Gudmundsson
 *  See the file "license.terms" for information on usage and redistribution
 *  of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 *     $Id: esdl_gen.c,v 1.3 2003/01/13 14:37:12 dgud Exp $
 */
/* 
   Generell sdl functions 
*/
#include "esdl.h"

void setupEventHandler(void);

int es_init(sdl_data *sd, int len, char * buff) 
{
   char * bp;
   Uint32 mode;
   
   bp = ARGS(buff);     /* First byte(s) is the command */  
   mode = get32be(bp);
   
   if(SDL_Init((Uint32) mode) < 0)  {
      char* e = SDL_GetError();
      fprintf(stderr, "Couldn't initialize SDL: %s\n\r",e);
      return(-1);
   }

   if((mode && SDL_INIT_EVENTTHREAD) > 1)
       /* Forward all events to erlang */
       setupEventHandler();
   return 1;
}

int es_quit(sdl_data *sd, int len, char * buff) 
{
    SDL_Quit();
    sdl_getbuff(sd, 0, buff);
    sdl_send(sd, 0, buff);
    return 1;
}

int es_getError(sdl_data *sd, int len, char *buff)
{
   char * err, *bp, *start;  
   int length;
   err = SDL_GetError();
   length = strlen(err);
   bp = start = sdl_getbuff(sd, length, buff);
   while(*err != '\0') {
      put8(bp, *err++);
   }
   return sdl_send(sd, bp - start, buff);
}
