/*  
 *  Copyright (c) 2001 Dan Gudmundsson
 *  See the file "license.terms" for information on usage and redistribution
 *  of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 *     $Id: esdl_glext.c,v 1.2 2003/01/13 15:40:30 bjorng Exp $
 *
 *  
 *  GL version 1.2 and greater with extensions
 *
 */


#include <stdlib.h>
#include <string.h>
#include "esdl.h"
#ifndef APIENTRY
#define APIENTRY
#endif

typedef void (APIENTRY * PFNGLBLENDCOLORPROC)(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
PFNGLBLENDCOLORPROC esdl_glBlendColor = NULL;
void egl_blendColor(sdl_data *, int, char *);
sdl_fun esdl_load_glBlendColor()
{
 esdl_glBlendColor = (PFNGLBLENDCOLORPROC) SDL_GL_GetProcAddress("glBlendColor");
 if(NULL != esdl_glBlendColor )
   return (sdl_fun) egl_blendColor; 
 else return NULL; 
}

void egl_blendColor(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLclampf * red;
 GLclampf * green;
 GLclampf * blue;
 GLclampf * alpha;
 bp = egl_buff;
 red = (GLclampf *) bp; bp += sizeof(GLclampf); 
 green = (GLclampf *) bp; bp += sizeof(GLclampf); 
 blue = (GLclampf *) bp; bp += sizeof(GLclampf); 
 alpha = (GLclampf *) bp; bp += sizeof(GLclampf); 
 esdl_glBlendColor(*red, *green, *blue, *alpha);

}

typedef void (APIENTRY * PFNGLBLENDEQUATIONPROC)(GLenum mode);
PFNGLBLENDEQUATIONPROC esdl_glBlendEquation = NULL;
void egl_blendEquation(sdl_data *, int, char *);
sdl_fun esdl_load_glBlendEquation()
{
 esdl_glBlendEquation = (PFNGLBLENDEQUATIONPROC) SDL_GL_GetProcAddress("glBlendEquation");
 if(NULL != esdl_glBlendEquation )
   return (sdl_fun) egl_blendEquation; 
 else return NULL; 
}

void egl_blendEquation(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * mode;
 bp = egl_buff;
 mode = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glBlendEquation(*mode);

}

typedef void (APIENTRY * PFNGLDRAWRANGEELEMENTSPROC)(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type,  const GLvoid * indices);
PFNGLDRAWRANGEELEMENTSPROC esdl_glDrawRangeElements = NULL;
void egl_drawRangeElements(sdl_data *, int, char *);
sdl_fun esdl_load_glDrawRangeElements()
{
 esdl_glDrawRangeElements = (PFNGLDRAWRANGEELEMENTSPROC) SDL_GL_GetProcAddress("glDrawRangeElements");
 if(NULL != esdl_glDrawRangeElements )
   return (sdl_fun) egl_drawRangeElements; 
 else return NULL; 
}

void egl_drawRangeElements(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * mode;
 GLuint * start;
 GLuint * end;
 GLsizei * count;
 GLenum * type;
 GLvoid * indices = NULL; int * indicesLen;
 bp = egl_buff;
 mode = (GLenum *) bp; bp += sizeof(GLenum); 
 start = (GLuint *) bp; bp += sizeof(GLuint); 
 end = (GLuint *) bp; bp += sizeof(GLuint); 
 count = (GLsizei *) bp; bp += sizeof(GLsizei); 
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 indicesLen = count;
 indices = (GLvoid *) bp; bp += sizeof(type)*(*indicesLen); 
 esdl_glDrawRangeElements(*mode, *start, *end, *count, *type, indices);

}

typedef void (APIENTRY * PFNGLCOLORTABLEPROC)(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type,  const GLvoid * table);
PFNGLCOLORTABLEPROC esdl_glColorTable = NULL;
void egl_colorTable(sdl_data *, int, char *);
sdl_fun esdl_load_glColorTable()
{
 esdl_glColorTable = (PFNGLCOLORTABLEPROC) SDL_GL_GetProcAddress("glColorTable");
 if(NULL != esdl_glColorTable )
   return (sdl_fun) egl_colorTable; 
 else return NULL; 
}

void egl_colorTable(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * internalformat;
 GLsizei * width;
 GLenum * format;
 GLenum * type;
 int * tableMemT = 0;
 int * tableLen = 0;
 GLvoid * table = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 internalformat = (GLenum *) bp; bp += sizeof(GLenum); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 format = (GLenum *) bp; bp += sizeof(GLenum); 
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 tableMemT = (int *)bp; bp += sizeof(int);
 if(*tableMemT == 1) {
  table = (GLvoid *) getPointer(bp);
  table = usePointer((oglmem *)table);} else {
  tableLen = (int *)bp; bp += sizeof(int); 
  table = (GLvoid *) bp; bp += *tableLen;};
 esdl_glColorTable(*target, *internalformat, *width, *format, *type, table);

}

typedef void (APIENTRY * PFNGLCOLORTABLEPARAMETERFVPROC)(GLenum target, GLenum pname,  const GLfloat * params);
PFNGLCOLORTABLEPARAMETERFVPROC esdl_glColorTableParameterfv = NULL;
void egl_colorTableParameterfv(sdl_data *, int, char *);
sdl_fun esdl_load_glColorTableParameterfv()
{
 esdl_glColorTableParameterfv = (PFNGLCOLORTABLEPARAMETERFVPROC) SDL_GL_GetProcAddress("glColorTableParameterfv");
 if(NULL != esdl_glColorTableParameterfv )
   return (sdl_fun) egl_colorTableParameterfv; 
 else return NULL; 
}

void egl_colorTableParameterfv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * pname;
 GLfloat * params;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 params = (GLfloat *) bp; bp += sizeof(GLfloat)*4; 
 esdl_glColorTableParameterfv(*target, *pname, params);

}

typedef void (APIENTRY * PFNGLCOLORTABLEPARAMETERIVPROC)(GLenum target, GLenum pname,  const GLint * params);
PFNGLCOLORTABLEPARAMETERIVPROC esdl_glColorTableParameteriv = NULL;
void egl_colorTableParameteriv(sdl_data *, int, char *);
sdl_fun esdl_load_glColorTableParameteriv()
{
 esdl_glColorTableParameteriv = (PFNGLCOLORTABLEPARAMETERIVPROC) SDL_GL_GetProcAddress("glColorTableParameteriv");
 if(NULL != esdl_glColorTableParameteriv )
   return (sdl_fun) egl_colorTableParameteriv; 
 else return NULL; 
}

void egl_colorTableParameteriv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * pname;
 GLint * params;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 params = (GLint *) bp; bp += sizeof(GLint)*4; 
 esdl_glColorTableParameteriv(*target, *pname, params);

}

typedef void (APIENTRY * PFNGLCOPYCOLORTABLEPROC)(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
PFNGLCOPYCOLORTABLEPROC esdl_glCopyColorTable = NULL;
void egl_copyColorTable(sdl_data *, int, char *);
sdl_fun esdl_load_glCopyColorTable()
{
 esdl_glCopyColorTable = (PFNGLCOPYCOLORTABLEPROC) SDL_GL_GetProcAddress("glCopyColorTable");
 if(NULL != esdl_glCopyColorTable )
   return (sdl_fun) egl_copyColorTable; 
 else return NULL; 
}

void egl_copyColorTable(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * internalformat;
 GLint * x;
 GLint * y;
 GLsizei * width;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 internalformat = (GLenum *) bp; bp += sizeof(GLenum); 
 x = (GLint *) bp; bp += sizeof(GLint); 
 y = (GLint *) bp; bp += sizeof(GLint); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 esdl_glCopyColorTable(*target, *internalformat, *x, *y, *width);

}

typedef void (APIENTRY * PFNGLGETCOLORTABLEPROC)(GLenum target, GLenum format, GLenum type, GLvoid * table);
PFNGLGETCOLORTABLEPROC esdl_glGetColorTable = NULL;
void egl_getColorTable(sdl_data *, int, char *);
sdl_fun esdl_load_glGetColorTable()
{
 esdl_glGetColorTable = (PFNGLGETCOLORTABLEPROC) SDL_GL_GetProcAddress("glGetColorTable");
 if(NULL != esdl_glGetColorTable )
   return (sdl_fun) egl_getColorTable; 
 else return NULL; 
}

void egl_getColorTable(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * format;
 GLenum * type;
 oglmem * table = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 format = (GLenum *) bp; bp += sizeof(GLenum); 
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 table = getPointer(bp); 
 esdl_glGetColorTable(*target, *format, *type, usePointer(table));

}

typedef void (APIENTRY * PFNGLGETCOLORTABLEPARAMETERFVPROC)(GLenum target, GLenum pname, GLfloat * params);
PFNGLGETCOLORTABLEPARAMETERFVPROC esdl_glGetColorTableParameterfv = NULL;
void egl_getColorTableParameterfv(sdl_data *, int, char *);
sdl_fun esdl_load_glGetColorTableParameterfv()
{
 esdl_glGetColorTableParameterfv = (PFNGLGETCOLORTABLEPARAMETERFVPROC) SDL_GL_GetProcAddress("glGetColorTableParameterfv");
 if(NULL != esdl_glGetColorTableParameterfv )
   return (sdl_fun) egl_getColorTableParameterfv; 
 else return NULL; 
}

void egl_getColorTableParameterfv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLenum * target;
 GLenum * pname;
 GLfloat params[4]; 
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glGetColorTableParameterfv(*target, *pname, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLfloat) *4, egl_buff);
 memcpy(bp, params, sizeof(GLfloat)*4);
 bp += sizeof(GLfloat)*4;
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

typedef void (APIENTRY * PFNGLGETCOLORTABLEPARAMETERIVPROC)(GLenum target, GLenum pname, GLint * params);
PFNGLGETCOLORTABLEPARAMETERIVPROC esdl_glGetColorTableParameteriv = NULL;
void egl_getColorTableParameteriv(sdl_data *, int, char *);
sdl_fun esdl_load_glGetColorTableParameteriv()
{
 esdl_glGetColorTableParameteriv = (PFNGLGETCOLORTABLEPARAMETERIVPROC) SDL_GL_GetProcAddress("glGetColorTableParameteriv");
 if(NULL != esdl_glGetColorTableParameteriv )
   return (sdl_fun) egl_getColorTableParameteriv; 
 else return NULL; 
}

void egl_getColorTableParameteriv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLenum * target;
 GLenum * pname;
 GLint params[4]; 
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glGetColorTableParameteriv(*target, *pname, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLint) *4, egl_buff);
 memcpy(bp, params, sizeof(GLint)*4);
 bp += sizeof(GLint)*4;
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

typedef void (APIENTRY * PFNGLCOLORSUBTABLEPROC)(GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type,  const GLvoid * data);
PFNGLCOLORSUBTABLEPROC esdl_glColorSubTable = NULL;
void egl_colorSubTable(sdl_data *, int, char *);
sdl_fun esdl_load_glColorSubTable()
{
 esdl_glColorSubTable = (PFNGLCOLORSUBTABLEPROC) SDL_GL_GetProcAddress("glColorSubTable");
 if(NULL != esdl_glColorSubTable )
   return (sdl_fun) egl_colorSubTable; 
 else return NULL; 
}

void egl_colorSubTable(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLsizei * start;
 GLsizei * count;
 GLenum * format;
 GLenum * type;
 int * dataMemT = 0;
 int * dataLen = 0;
 GLvoid * data = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 start = (GLsizei *) bp; bp += sizeof(GLsizei); 
 count = (GLsizei *) bp; bp += sizeof(GLsizei); 
 format = (GLenum *) bp; bp += sizeof(GLenum); 
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 dataMemT = (int *)bp; bp += sizeof(int);
 if(*dataMemT == 1) {
  data = (GLvoid *) getPointer(bp);
  data = usePointer((oglmem *)data);} else {
  dataLen = (int *)bp; bp += sizeof(int); 
  data = (GLvoid *) bp; bp += *dataLen;};
 esdl_glColorSubTable(*target, *start, *count, *format, *type, data);

}

typedef void (APIENTRY * PFNGLCOPYCOLORSUBTABLEPROC)(GLenum target, GLsizei start, GLint x, GLint y, GLsizei width);
PFNGLCOPYCOLORSUBTABLEPROC esdl_glCopyColorSubTable = NULL;
void egl_copyColorSubTable(sdl_data *, int, char *);
sdl_fun esdl_load_glCopyColorSubTable()
{
 esdl_glCopyColorSubTable = (PFNGLCOPYCOLORSUBTABLEPROC) SDL_GL_GetProcAddress("glCopyColorSubTable");
 if(NULL != esdl_glCopyColorSubTable )
   return (sdl_fun) egl_copyColorSubTable; 
 else return NULL; 
}

void egl_copyColorSubTable(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLsizei * start;
 GLint * x;
 GLint * y;
 GLsizei * width;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 start = (GLsizei *) bp; bp += sizeof(GLsizei); 
 x = (GLint *) bp; bp += sizeof(GLint); 
 y = (GLint *) bp; bp += sizeof(GLint); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 esdl_glCopyColorSubTable(*target, *start, *x, *y, *width);

}

typedef void (APIENTRY * PFNGLCONVOLUTIONFILTER1DPROC)(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type,  const GLvoid * image);
PFNGLCONVOLUTIONFILTER1DPROC esdl_glConvolutionFilter1D = NULL;
void egl_convolutionFilter1D(sdl_data *, int, char *);
sdl_fun esdl_load_glConvolutionFilter1D()
{
 esdl_glConvolutionFilter1D = (PFNGLCONVOLUTIONFILTER1DPROC) SDL_GL_GetProcAddress("glConvolutionFilter1D");
 if(NULL != esdl_glConvolutionFilter1D )
   return (sdl_fun) egl_convolutionFilter1D; 
 else return NULL; 
}

void egl_convolutionFilter1D(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * internalformat;
 GLsizei * width;
 GLenum * format;
 GLenum * type;
 int * imageMemT = 0;
 int * imageLen = 0;
 GLvoid * image = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 internalformat = (GLenum *) bp; bp += sizeof(GLenum); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 format = (GLenum *) bp; bp += sizeof(GLenum); 
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 imageMemT = (int *)bp; bp += sizeof(int);
 if(*imageMemT == 1) {
  image = (GLvoid *) getPointer(bp);
  image = usePointer((oglmem *)image);} else {
  imageLen = (int *)bp; bp += sizeof(int); 
  image = (GLvoid *) bp; bp += *imageLen;};
 esdl_glConvolutionFilter1D(*target, *internalformat, *width, *format, *type, image);

}

typedef void (APIENTRY * PFNGLCONVOLUTIONFILTER2DPROC)(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type,  const GLvoid * image);
PFNGLCONVOLUTIONFILTER2DPROC esdl_glConvolutionFilter2D = NULL;
void egl_convolutionFilter2D(sdl_data *, int, char *);
sdl_fun esdl_load_glConvolutionFilter2D()
{
 esdl_glConvolutionFilter2D = (PFNGLCONVOLUTIONFILTER2DPROC) SDL_GL_GetProcAddress("glConvolutionFilter2D");
 if(NULL != esdl_glConvolutionFilter2D )
   return (sdl_fun) egl_convolutionFilter2D; 
 else return NULL; 
}

void egl_convolutionFilter2D(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * internalformat;
 GLsizei * width;
 GLsizei * height;
 GLenum * format;
 GLenum * type;
 int * imageMemT = 0;
 int * imageLen = 0;
 GLvoid * image = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 internalformat = (GLenum *) bp; bp += sizeof(GLenum); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 height = (GLsizei *) bp; bp += sizeof(GLsizei); 
 format = (GLenum *) bp; bp += sizeof(GLenum); 
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 imageMemT = (int *)bp; bp += sizeof(int);
 if(*imageMemT == 1) {
  image = (GLvoid *) getPointer(bp);
  image = usePointer((oglmem *)image);} else {
  imageLen = (int *)bp; bp += sizeof(int); 
  image = (GLvoid *) bp; bp += *imageLen;};
 esdl_glConvolutionFilter2D(*target, *internalformat, *width, *height, *format, *type, image);

}

typedef void (APIENTRY * PFNGLCONVOLUTIONPARAMETERFPROC)(GLenum target, GLenum pname, GLfloat params);
PFNGLCONVOLUTIONPARAMETERFPROC esdl_glConvolutionParameterf = NULL;
void egl_convolutionParameterf(sdl_data *, int, char *);
sdl_fun esdl_load_glConvolutionParameterf()
{
 esdl_glConvolutionParameterf = (PFNGLCONVOLUTIONPARAMETERFPROC) SDL_GL_GetProcAddress("glConvolutionParameterf");
 if(NULL != esdl_glConvolutionParameterf )
   return (sdl_fun) egl_convolutionParameterf; 
 else return NULL; 
}

void egl_convolutionParameterf(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * pname;
 GLfloat * params;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 params = (GLfloat *) bp; bp += sizeof(GLfloat); 
 esdl_glConvolutionParameterf(*target, *pname, *params);

}

typedef void (APIENTRY * PFNGLCONVOLUTIONPARAMETERFVPROC)(GLenum target, GLenum pname,  const GLfloat * params);
PFNGLCONVOLUTIONPARAMETERFVPROC esdl_glConvolutionParameterfv = NULL;
void egl_convolutionParameterfv(sdl_data *, int, char *);
sdl_fun esdl_load_glConvolutionParameterfv()
{
 esdl_glConvolutionParameterfv = (PFNGLCONVOLUTIONPARAMETERFVPROC) SDL_GL_GetProcAddress("glConvolutionParameterfv");
 if(NULL != esdl_glConvolutionParameterfv )
   return (sdl_fun) egl_convolutionParameterfv; 
 else return NULL; 
}

void egl_convolutionParameterfv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * pname;
 GLfloat * params;int * paramsLen;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 paramsLen  = (int *) bp; bp += sizeof(int); 
 params = (GLfloat *) bp; bp += sizeof(GLfloat)*(*paramsLen); 
 esdl_glConvolutionParameterfv(*target, *pname, params);

}

typedef void (APIENTRY * PFNGLCONVOLUTIONPARAMETERIPROC)(GLenum target, GLenum pname, GLint params);
PFNGLCONVOLUTIONPARAMETERIPROC esdl_glConvolutionParameteri = NULL;
void egl_convolutionParameteri(sdl_data *, int, char *);
sdl_fun esdl_load_glConvolutionParameteri()
{
 esdl_glConvolutionParameteri = (PFNGLCONVOLUTIONPARAMETERIPROC) SDL_GL_GetProcAddress("glConvolutionParameteri");
 if(NULL != esdl_glConvolutionParameteri )
   return (sdl_fun) egl_convolutionParameteri; 
 else return NULL; 
}

void egl_convolutionParameteri(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * pname;
 GLint * params;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 params = (GLint *) bp; bp += sizeof(GLint); 
 esdl_glConvolutionParameteri(*target, *pname, *params);

}

typedef void (APIENTRY * PFNGLCONVOLUTIONPARAMETERIVPROC)(GLenum target, GLenum pname,  const GLint * params);
PFNGLCONVOLUTIONPARAMETERIVPROC esdl_glConvolutionParameteriv = NULL;
void egl_convolutionParameteriv(sdl_data *, int, char *);
sdl_fun esdl_load_glConvolutionParameteriv()
{
 esdl_glConvolutionParameteriv = (PFNGLCONVOLUTIONPARAMETERIVPROC) SDL_GL_GetProcAddress("glConvolutionParameteriv");
 if(NULL != esdl_glConvolutionParameteriv )
   return (sdl_fun) egl_convolutionParameteriv; 
 else return NULL; 
}

void egl_convolutionParameteriv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * pname;
 GLint * params;int * paramsLen;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 paramsLen  = (int *) bp; bp += sizeof(int); 
 params = (GLint *) bp; bp += sizeof(GLint)*(*paramsLen); 
 esdl_glConvolutionParameteriv(*target, *pname, params);

}

typedef void (APIENTRY * PFNGLCOPYCONVOLUTIONFILTER1DPROC)(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
PFNGLCOPYCONVOLUTIONFILTER1DPROC esdl_glCopyConvolutionFilter1D = NULL;
void egl_copyConvolutionFilter1D(sdl_data *, int, char *);
sdl_fun esdl_load_glCopyConvolutionFilter1D()
{
 esdl_glCopyConvolutionFilter1D = (PFNGLCOPYCONVOLUTIONFILTER1DPROC) SDL_GL_GetProcAddress("glCopyConvolutionFilter1D");
 if(NULL != esdl_glCopyConvolutionFilter1D )
   return (sdl_fun) egl_copyConvolutionFilter1D; 
 else return NULL; 
}

void egl_copyConvolutionFilter1D(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * internalformat;
 GLint * x;
 GLint * y;
 GLsizei * width;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 internalformat = (GLenum *) bp; bp += sizeof(GLenum); 
 x = (GLint *) bp; bp += sizeof(GLint); 
 y = (GLint *) bp; bp += sizeof(GLint); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 esdl_glCopyConvolutionFilter1D(*target, *internalformat, *x, *y, *width);

}

typedef void (APIENTRY * PFNGLCOPYCONVOLUTIONFILTER2DPROC)(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height);
PFNGLCOPYCONVOLUTIONFILTER2DPROC esdl_glCopyConvolutionFilter2D = NULL;
void egl_copyConvolutionFilter2D(sdl_data *, int, char *);
sdl_fun esdl_load_glCopyConvolutionFilter2D()
{
 esdl_glCopyConvolutionFilter2D = (PFNGLCOPYCONVOLUTIONFILTER2DPROC) SDL_GL_GetProcAddress("glCopyConvolutionFilter2D");
 if(NULL != esdl_glCopyConvolutionFilter2D )
   return (sdl_fun) egl_copyConvolutionFilter2D; 
 else return NULL; 
}

void egl_copyConvolutionFilter2D(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * internalformat;
 GLint * x;
 GLint * y;
 GLsizei * width;
 GLsizei * height;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 internalformat = (GLenum *) bp; bp += sizeof(GLenum); 
 x = (GLint *) bp; bp += sizeof(GLint); 
 y = (GLint *) bp; bp += sizeof(GLint); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 height = (GLsizei *) bp; bp += sizeof(GLsizei); 
 esdl_glCopyConvolutionFilter2D(*target, *internalformat, *x, *y, *width, *height);

}

typedef void (APIENTRY * PFNGLGETCONVOLUTIONFILTERPROC)(GLenum target, GLenum format, GLenum type, GLvoid * image);
PFNGLGETCONVOLUTIONFILTERPROC esdl_glGetConvolutionFilter = NULL;
void egl_getConvolutionFilter(sdl_data *, int, char *);
sdl_fun esdl_load_glGetConvolutionFilter()
{
 esdl_glGetConvolutionFilter = (PFNGLGETCONVOLUTIONFILTERPROC) SDL_GL_GetProcAddress("glGetConvolutionFilter");
 if(NULL != esdl_glGetConvolutionFilter )
   return (sdl_fun) egl_getConvolutionFilter; 
 else return NULL; 
}

void egl_getConvolutionFilter(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * format;
 GLenum * type;
 oglmem * image = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 format = (GLenum *) bp; bp += sizeof(GLenum); 
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 image = getPointer(bp); 
 esdl_glGetConvolutionFilter(*target, *format, *type, usePointer(image));

}

typedef void (APIENTRY * PFNGLGETCONVOLUTIONPARAMETERFVPROC)(GLenum target, GLenum pname, GLfloat * params);
PFNGLGETCONVOLUTIONPARAMETERFVPROC esdl_glGetConvolutionParameterfv = NULL;
void egl_getConvolutionParameterfv(sdl_data *, int, char *);
sdl_fun esdl_load_glGetConvolutionParameterfv()
{
 esdl_glGetConvolutionParameterfv = (PFNGLGETCONVOLUTIONPARAMETERFVPROC) SDL_GL_GetProcAddress("glGetConvolutionParameterfv");
 if(NULL != esdl_glGetConvolutionParameterfv )
   return (sdl_fun) egl_getConvolutionParameterfv; 
 else return NULL; 
}

void egl_getConvolutionParameterfv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLenum * target;
 GLenum * pname;
 GLfloat params[4];
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glGetConvolutionParameterfv(*target, *pname, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLfloat) *4, egl_buff);
 memcpy(bp, params, sizeof(GLfloat)*4);
 bp += sizeof(GLfloat)*4;
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

typedef void (APIENTRY * PFNGLGETCONVOLUTIONPARAMETERIVPROC)(GLenum target, GLenum pname, GLint * params);
PFNGLGETCONVOLUTIONPARAMETERIVPROC esdl_glGetConvolutionParameteriv = NULL;
void egl_getConvolutionParameteriv(sdl_data *, int, char *);
sdl_fun esdl_load_glGetConvolutionParameteriv()
{
 esdl_glGetConvolutionParameteriv = (PFNGLGETCONVOLUTIONPARAMETERIVPROC) SDL_GL_GetProcAddress("glGetConvolutionParameteriv");
 if(NULL != esdl_glGetConvolutionParameteriv )
   return (sdl_fun) egl_getConvolutionParameteriv; 
 else return NULL; 
}

void egl_getConvolutionParameteriv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLenum * target;
 GLenum * pname;
 GLint params[4];
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glGetConvolutionParameteriv(*target, *pname, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLint) *4, egl_buff);
 memcpy(bp, params, sizeof(GLint)*4);
 bp += sizeof(GLint)*4;
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

typedef void (APIENTRY * PFNGLGETSEPARABLEFILTERPROC)(GLenum target, GLenum format, GLenum type, GLvoid * row, GLvoid * column, GLvoid * span);
PFNGLGETSEPARABLEFILTERPROC esdl_glGetSeparableFilter = NULL;
void egl_getSeparableFilter(sdl_data *, int, char *);
sdl_fun esdl_load_glGetSeparableFilter()
{
 esdl_glGetSeparableFilter = (PFNGLGETSEPARABLEFILTERPROC) SDL_GL_GetProcAddress("glGetSeparableFilter");
 if(NULL != esdl_glGetSeparableFilter )
   return (sdl_fun) egl_getSeparableFilter; 
 else return NULL; 
}

void egl_getSeparableFilter(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * format;
 GLenum * type;
 oglmem * row = NULL;
 oglmem * column = NULL;
 oglmem * span = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 format = (GLenum *) bp; bp += sizeof(GLenum); 
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 row = getPointer(bp); 
 column = getPointer(bp); 
 span = getPointer(bp); 
 esdl_glGetSeparableFilter(*target, *format, *type, usePointer(row), usePointer(column), usePointer(span));

}

typedef void (APIENTRY * PFNGLSEPARABLEFILTER2DPROC)(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type,  const GLvoid * row,  const GLvoid * column);
PFNGLSEPARABLEFILTER2DPROC esdl_glSeparableFilter2D = NULL;
void egl_separableFilter2D(sdl_data *, int, char *);
sdl_fun esdl_load_glSeparableFilter2D()
{
 esdl_glSeparableFilter2D = (PFNGLSEPARABLEFILTER2DPROC) SDL_GL_GetProcAddress("glSeparableFilter2D");
 if(NULL != esdl_glSeparableFilter2D )
   return (sdl_fun) egl_separableFilter2D; 
 else return NULL; 
}

void egl_separableFilter2D(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * internalformat;
 GLsizei * width;
 GLsizei * height;
 GLenum * format;
 GLenum * type;
 int * rowMemT = 0;
 int * rowLen = 0;
 GLvoid * row = NULL;
 int * columnMemT = 0;
 int * columnLen = 0;
 GLvoid * column = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 internalformat = (GLenum *) bp; bp += sizeof(GLenum); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 height = (GLsizei *) bp; bp += sizeof(GLsizei); 
 format = (GLenum *) bp; bp += sizeof(GLenum); 
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 rowMemT = (int *)bp; bp += sizeof(int);
 if(*rowMemT == 1) {
  row = (GLvoid *) getPointer(bp);
  row = usePointer((oglmem *)row);} else {
  rowLen = (int *)bp; bp += sizeof(int); 
  row = (GLvoid *) bp; bp += *rowLen;};
 columnMemT = (int *)bp; bp += sizeof(int);
 if(*columnMemT == 1) {
  column = (GLvoid *) getPointer(bp);
  column = usePointer((oglmem *)column);} else {
  columnLen = (int *)bp; bp += sizeof(int); 
  column = (GLvoid *) bp; bp += *columnLen;};
 esdl_glSeparableFilter2D(*target, *internalformat, *width, *height, *format, *type, row, column);

}

typedef void (APIENTRY * PFNGLGETHISTOGRAMPROC)(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid * values);
PFNGLGETHISTOGRAMPROC esdl_glGetHistogram = NULL;
void egl_getHistogram(sdl_data *, int, char *);
sdl_fun esdl_load_glGetHistogram()
{
 esdl_glGetHistogram = (PFNGLGETHISTOGRAMPROC) SDL_GL_GetProcAddress("glGetHistogram");
 if(NULL != esdl_glGetHistogram )
   return (sdl_fun) egl_getHistogram; 
 else return NULL; 
}

void egl_getHistogram(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLboolean * reset;
 GLenum * format;
 GLenum * type;
 oglmem * values = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 reset = (GLboolean *) bp; bp += sizeof(GLboolean); 
bp += 1;
 format = (GLenum *) bp; bp += sizeof(GLenum); 
bp += 2;
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 values = getPointer(bp); 
 esdl_glGetHistogram(*target, *reset, *format, *type, usePointer(values));

}

typedef void (APIENTRY * PFNGLGETHISTOGRAMPARAMETERFVPROC)(GLenum target, GLenum pname, GLfloat * params);
PFNGLGETHISTOGRAMPARAMETERFVPROC esdl_glGetHistogramParameterfv = NULL;
void egl_getHistogramParameterfv(sdl_data *, int, char *);
sdl_fun esdl_load_glGetHistogramParameterfv()
{
 esdl_glGetHistogramParameterfv = (PFNGLGETHISTOGRAMPARAMETERFVPROC) SDL_GL_GetProcAddress("glGetHistogramParameterfv");
 if(NULL != esdl_glGetHistogramParameterfv )
   return (sdl_fun) egl_getHistogramParameterfv; 
 else return NULL; 
}

void egl_getHistogramParameterfv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLenum * target;
 GLenum * pname;
 GLfloat params[1]; 
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glGetHistogramParameterfv(*target, *pname, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLfloat) *1, egl_buff);
 * (GLfloat *)bp = params[0]; bp += sizeof(GLfloat);
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

typedef void (APIENTRY * PFNGLGETHISTOGRAMPARAMETERIVPROC)(GLenum target, GLenum pname, GLint * params);
PFNGLGETHISTOGRAMPARAMETERIVPROC esdl_glGetHistogramParameteriv = NULL;
void egl_getHistogramParameteriv(sdl_data *, int, char *);
sdl_fun esdl_load_glGetHistogramParameteriv()
{
 esdl_glGetHistogramParameteriv = (PFNGLGETHISTOGRAMPARAMETERIVPROC) SDL_GL_GetProcAddress("glGetHistogramParameteriv");
 if(NULL != esdl_glGetHistogramParameteriv )
   return (sdl_fun) egl_getHistogramParameteriv; 
 else return NULL; 
}

void egl_getHistogramParameteriv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLenum * target;
 GLenum * pname;
 GLint params[1]; 
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glGetHistogramParameteriv(*target, *pname, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLint) *1, egl_buff);
 * (GLint *)bp = params[0]; bp += sizeof(GLint);
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

typedef void (APIENTRY * PFNGLGETMINMAXPROC)(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid * values);
PFNGLGETMINMAXPROC esdl_glGetMinmax = NULL;
void egl_getMinmax(sdl_data *, int, char *);
sdl_fun esdl_load_glGetMinmax()
{
 esdl_glGetMinmax = (PFNGLGETMINMAXPROC) SDL_GL_GetProcAddress("glGetMinmax");
 if(NULL != esdl_glGetMinmax )
   return (sdl_fun) egl_getMinmax; 
 else return NULL; 
}

void egl_getMinmax(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLboolean * reset;
 GLenum * format;
 GLenum * type;
 oglmem * values = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 reset = (GLboolean *) bp; bp += sizeof(GLboolean); 
bp += 1;
 format = (GLenum *) bp; bp += sizeof(GLenum); 
bp += 2;
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 values = getPointer(bp); 
 esdl_glGetMinmax(*target, *reset, *format, *type, usePointer(values));

}

typedef void (APIENTRY * PFNGLGETMINMAXPARAMETERFVPROC)(GLenum target, GLenum pname, GLfloat * params);
PFNGLGETMINMAXPARAMETERFVPROC esdl_glGetMinmaxParameterfv = NULL;
void egl_getMinmaxParameterfv(sdl_data *, int, char *);
sdl_fun esdl_load_glGetMinmaxParameterfv()
{
 esdl_glGetMinmaxParameterfv = (PFNGLGETMINMAXPARAMETERFVPROC) SDL_GL_GetProcAddress("glGetMinmaxParameterfv");
 if(NULL != esdl_glGetMinmaxParameterfv )
   return (sdl_fun) egl_getMinmaxParameterfv; 
 else return NULL; 
}

void egl_getMinmaxParameterfv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLenum * target;
 GLenum * pname;
 GLfloat params[1]; 
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glGetMinmaxParameterfv(*target, *pname, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLfloat) *1, egl_buff);
 * (GLfloat *)bp = params[0]; bp += sizeof(GLfloat);
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

typedef void (APIENTRY * PFNGLGETMINMAXPARAMETERIVPROC)(GLenum target, GLenum pname, GLint * params);
PFNGLGETMINMAXPARAMETERIVPROC esdl_glGetMinmaxParameteriv = NULL;
void egl_getMinmaxParameteriv(sdl_data *, int, char *);
sdl_fun esdl_load_glGetMinmaxParameteriv()
{
 esdl_glGetMinmaxParameteriv = (PFNGLGETMINMAXPARAMETERIVPROC) SDL_GL_GetProcAddress("glGetMinmaxParameteriv");
 if(NULL != esdl_glGetMinmaxParameteriv )
   return (sdl_fun) egl_getMinmaxParameteriv; 
 else return NULL; 
}

void egl_getMinmaxParameteriv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLenum * target;
 GLenum * pname;
 GLint params[1]; 
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glGetMinmaxParameteriv(*target, *pname, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLint) *1, egl_buff);
 * (GLint *)bp = params[0]; bp += sizeof(GLint);
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

typedef void (APIENTRY * PFNGLHISTOGRAMPROC)(GLenum target, GLsizei width, GLenum internalformat, GLboolean sink);
PFNGLHISTOGRAMPROC esdl_glHistogram = NULL;
void egl_histogram(sdl_data *, int, char *);
sdl_fun esdl_load_glHistogram()
{
 esdl_glHistogram = (PFNGLHISTOGRAMPROC) SDL_GL_GetProcAddress("glHistogram");
 if(NULL != esdl_glHistogram )
   return (sdl_fun) egl_histogram; 
 else return NULL; 
}

void egl_histogram(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLsizei * width;
 GLenum * internalformat;
 GLboolean * sink;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 internalformat = (GLenum *) bp; bp += sizeof(GLenum); 
 sink = (GLboolean *) bp; bp += sizeof(GLboolean); 
 esdl_glHistogram(*target, *width, *internalformat, *sink);

}

typedef void (APIENTRY * PFNGLMINMAXPROC)(GLenum target, GLenum internalformat, GLboolean sink);
PFNGLMINMAXPROC esdl_glMinmax = NULL;
void egl_minmax(sdl_data *, int, char *);
sdl_fun esdl_load_glMinmax()
{
 esdl_glMinmax = (PFNGLMINMAXPROC) SDL_GL_GetProcAddress("glMinmax");
 if(NULL != esdl_glMinmax )
   return (sdl_fun) egl_minmax; 
 else return NULL; 
}

void egl_minmax(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * internalformat;
 GLboolean * sink;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 internalformat = (GLenum *) bp; bp += sizeof(GLenum); 
 sink = (GLboolean *) bp; bp += sizeof(GLboolean); 
 esdl_glMinmax(*target, *internalformat, *sink);

}

typedef void (APIENTRY * PFNGLRESETHISTOGRAMPROC)(GLenum target);
PFNGLRESETHISTOGRAMPROC esdl_glResetHistogram = NULL;
void egl_resetHistogram(sdl_data *, int, char *);
sdl_fun esdl_load_glResetHistogram()
{
 esdl_glResetHistogram = (PFNGLRESETHISTOGRAMPROC) SDL_GL_GetProcAddress("glResetHistogram");
 if(NULL != esdl_glResetHistogram )
   return (sdl_fun) egl_resetHistogram; 
 else return NULL; 
}

void egl_resetHistogram(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glResetHistogram(*target);

}

typedef void (APIENTRY * PFNGLRESETMINMAXPROC)(GLenum target);
PFNGLRESETMINMAXPROC esdl_glResetMinmax = NULL;
void egl_resetMinmax(sdl_data *, int, char *);
sdl_fun esdl_load_glResetMinmax()
{
 esdl_glResetMinmax = (PFNGLRESETMINMAXPROC) SDL_GL_GetProcAddress("glResetMinmax");
 if(NULL != esdl_glResetMinmax )
   return (sdl_fun) egl_resetMinmax; 
 else return NULL; 
}

void egl_resetMinmax(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glResetMinmax(*target);

}

typedef void (APIENTRY * PFNGLTEXIMAGE3DPROC)(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type,  const GLvoid * pixels);
PFNGLTEXIMAGE3DPROC esdl_glTexImage3D = NULL;
void egl_texImage3D(sdl_data *, int, char *);
sdl_fun esdl_load_glTexImage3D()
{
 esdl_glTexImage3D = (PFNGLTEXIMAGE3DPROC) SDL_GL_GetProcAddress("glTexImage3D");
 if(NULL != esdl_glTexImage3D )
   return (sdl_fun) egl_texImage3D; 
 else return NULL; 
}

void egl_texImage3D(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLint * level;
 GLint * internalformat;
 GLsizei * width;
 GLsizei * height;
 GLsizei * depth;
 GLint * border;
 GLenum * format;
 GLenum * type;
 int * pixelsMemT = 0;
 int * pixelsLen = 0;
 GLvoid * pixels = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 level = (GLint *) bp; bp += sizeof(GLint); 
 internalformat = (GLint *) bp; bp += sizeof(GLint); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 height = (GLsizei *) bp; bp += sizeof(GLsizei); 
 depth = (GLsizei *) bp; bp += sizeof(GLsizei); 
 border = (GLint *) bp; bp += sizeof(GLint); 
 format = (GLenum *) bp; bp += sizeof(GLenum); 
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 pixelsMemT = (int *)bp; bp += sizeof(int);
 if(*pixelsMemT == 1) {
  pixels = (GLvoid *) getPointer(bp);
  pixels = usePointer((oglmem *)pixels);} else {
  pixelsLen = (int *)bp; bp += sizeof(int); 
  pixels = (GLvoid *) bp; bp += *pixelsLen;};
 esdl_glTexImage3D(*target, *level, *internalformat, *width, *height, *depth, *border, *format, *type, pixels);

}

typedef void (APIENTRY * PFNGLTEXSUBIMAGE3DPROC)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type,  const GLvoid * pixels);
PFNGLTEXSUBIMAGE3DPROC esdl_glTexSubImage3D = NULL;
void egl_texSubImage3D(sdl_data *, int, char *);
sdl_fun esdl_load_glTexSubImage3D()
{
 esdl_glTexSubImage3D = (PFNGLTEXSUBIMAGE3DPROC) SDL_GL_GetProcAddress("glTexSubImage3D");
 if(NULL != esdl_glTexSubImage3D )
   return (sdl_fun) egl_texSubImage3D; 
 else return NULL; 
}

void egl_texSubImage3D(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLint * level;
 GLint * xoffset;
 GLint * yoffset;
 GLint * zoffset;
 GLsizei * width;
 GLsizei * height;
 GLsizei * depth;
 GLenum * format;
 GLenum * type;
 int * pixelsMemT = 0;
 int * pixelsLen = 0;
 GLvoid * pixels = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 level = (GLint *) bp; bp += sizeof(GLint); 
 xoffset = (GLint *) bp; bp += sizeof(GLint); 
 yoffset = (GLint *) bp; bp += sizeof(GLint); 
 zoffset = (GLint *) bp; bp += sizeof(GLint); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 height = (GLsizei *) bp; bp += sizeof(GLsizei); 
 depth = (GLsizei *) bp; bp += sizeof(GLsizei); 
 format = (GLenum *) bp; bp += sizeof(GLenum); 
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 pixelsMemT = (int *)bp; bp += sizeof(int);
 if(*pixelsMemT == 1) {
  pixels = (GLvoid *) getPointer(bp);
  pixels = usePointer((oglmem *)pixels);} else {
  pixelsLen = (int *)bp; bp += sizeof(int); 
  pixels = (GLvoid *) bp; bp += *pixelsLen;};
 esdl_glTexSubImage3D(*target, *level, *xoffset, *yoffset, *zoffset, *width, *height, *depth, *format, *type, pixels);

}

typedef void (APIENTRY * PFNGLCOPYTEXSUBIMAGE3DPROC)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height);
PFNGLCOPYTEXSUBIMAGE3DPROC esdl_glCopyTexSubImage3D = NULL;
void egl_copyTexSubImage3D(sdl_data *, int, char *);
sdl_fun esdl_load_glCopyTexSubImage3D()
{
 esdl_glCopyTexSubImage3D = (PFNGLCOPYTEXSUBIMAGE3DPROC) SDL_GL_GetProcAddress("glCopyTexSubImage3D");
 if(NULL != esdl_glCopyTexSubImage3D )
   return (sdl_fun) egl_copyTexSubImage3D; 
 else return NULL; 
}

void egl_copyTexSubImage3D(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLint * level;
 GLint * xoffset;
 GLint * yoffset;
 GLint * zoffset;
 GLint * x;
 GLint * y;
 GLsizei * width;
 GLsizei * height;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 level = (GLint *) bp; bp += sizeof(GLint); 
 xoffset = (GLint *) bp; bp += sizeof(GLint); 
 yoffset = (GLint *) bp; bp += sizeof(GLint); 
 zoffset = (GLint *) bp; bp += sizeof(GLint); 
 x = (GLint *) bp; bp += sizeof(GLint); 
 y = (GLint *) bp; bp += sizeof(GLint); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 height = (GLsizei *) bp; bp += sizeof(GLsizei); 
 esdl_glCopyTexSubImage3D(*target, *level, *xoffset, *yoffset, *zoffset, *x, *y, *width, *height);

}

typedef void (APIENTRY * PFNGLACTIVETEXTUREPROC)(GLenum texture);
PFNGLACTIVETEXTUREPROC esdl_glActiveTexture = NULL;
void egl_activeTexture(sdl_data *, int, char *);
sdl_fun esdl_load_glActiveTexture()
{
 esdl_glActiveTexture = (PFNGLACTIVETEXTUREPROC) SDL_GL_GetProcAddress("glActiveTexture");
 if(NULL != esdl_glActiveTexture )
   return (sdl_fun) egl_activeTexture; 
 else return NULL; 
}

void egl_activeTexture(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * texture;
 bp = egl_buff;
 texture = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glActiveTexture(*texture);

}

typedef void (APIENTRY * PFNGLCLIENTACTIVETEXTUREPROC)(GLenum texture);
PFNGLCLIENTACTIVETEXTUREPROC esdl_glClientActiveTexture = NULL;
void egl_clientActiveTexture(sdl_data *, int, char *);
sdl_fun esdl_load_glClientActiveTexture()
{
 esdl_glClientActiveTexture = (PFNGLCLIENTACTIVETEXTUREPROC) SDL_GL_GetProcAddress("glClientActiveTexture");
 if(NULL != esdl_glClientActiveTexture )
   return (sdl_fun) egl_clientActiveTexture; 
 else return NULL; 
}

void egl_clientActiveTexture(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * texture;
 bp = egl_buff;
 texture = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glClientActiveTexture(*texture);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD1DVPROC)(GLenum target,  const GLdouble * v);
PFNGLMULTITEXCOORD1DVPROC esdl_glMultiTexCoord1dv = NULL;
void egl_multiTexCoord1dv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord1dv()
{
 esdl_glMultiTexCoord1dv = (PFNGLMULTITEXCOORD1DVPROC) SDL_GL_GetProcAddress("glMultiTexCoord1dv");
 if(NULL != esdl_glMultiTexCoord1dv )
   return (sdl_fun) egl_multiTexCoord1dv; 
 else return NULL; 
}

void egl_multiTexCoord1dv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLdouble v[1];
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 memcpy(v,bp,sizeof(GLdouble)*1); bp += sizeof(GLdouble)*1; 
 esdl_glMultiTexCoord1dv(*target, v);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD1FVPROC)(GLenum target,  const GLfloat * v);
PFNGLMULTITEXCOORD1FVPROC esdl_glMultiTexCoord1fv = NULL;
void egl_multiTexCoord1fv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord1fv()
{
 esdl_glMultiTexCoord1fv = (PFNGLMULTITEXCOORD1FVPROC) SDL_GL_GetProcAddress("glMultiTexCoord1fv");
 if(NULL != esdl_glMultiTexCoord1fv )
   return (sdl_fun) egl_multiTexCoord1fv; 
 else return NULL; 
}

void egl_multiTexCoord1fv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLfloat * v;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 v = (GLfloat *) bp; bp += sizeof(GLfloat)*1; 
 esdl_glMultiTexCoord1fv(*target, v);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD1IVPROC)(GLenum target,  const GLint * v);
PFNGLMULTITEXCOORD1IVPROC esdl_glMultiTexCoord1iv = NULL;
void egl_multiTexCoord1iv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord1iv()
{
 esdl_glMultiTexCoord1iv = (PFNGLMULTITEXCOORD1IVPROC) SDL_GL_GetProcAddress("glMultiTexCoord1iv");
 if(NULL != esdl_glMultiTexCoord1iv )
   return (sdl_fun) egl_multiTexCoord1iv; 
 else return NULL; 
}

void egl_multiTexCoord1iv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLint * v;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 v = (GLint *) bp; bp += sizeof(GLint)*1; 
 esdl_glMultiTexCoord1iv(*target, v);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD1SVPROC)(GLenum target,  const GLshort * v);
PFNGLMULTITEXCOORD1SVPROC esdl_glMultiTexCoord1sv = NULL;
void egl_multiTexCoord1sv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord1sv()
{
 esdl_glMultiTexCoord1sv = (PFNGLMULTITEXCOORD1SVPROC) SDL_GL_GetProcAddress("glMultiTexCoord1sv");
 if(NULL != esdl_glMultiTexCoord1sv )
   return (sdl_fun) egl_multiTexCoord1sv; 
 else return NULL; 
}

void egl_multiTexCoord1sv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLshort * v;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 v = (GLshort *) bp; bp += sizeof(GLshort)*1; 
 esdl_glMultiTexCoord1sv(*target, v);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD2DVPROC)(GLenum target,  const GLdouble * v);
PFNGLMULTITEXCOORD2DVPROC esdl_glMultiTexCoord2dv = NULL;
void egl_multiTexCoord2dv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord2dv()
{
 esdl_glMultiTexCoord2dv = (PFNGLMULTITEXCOORD2DVPROC) SDL_GL_GetProcAddress("glMultiTexCoord2dv");
 if(NULL != esdl_glMultiTexCoord2dv )
   return (sdl_fun) egl_multiTexCoord2dv; 
 else return NULL; 
}

void egl_multiTexCoord2dv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLdouble v[2];
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 memcpy(v,bp,sizeof(GLdouble)*2); bp += sizeof(GLdouble)*2; 
 esdl_glMultiTexCoord2dv(*target, v);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD2FVPROC)(GLenum target,  const GLfloat * v);
PFNGLMULTITEXCOORD2FVPROC esdl_glMultiTexCoord2fv = NULL;
void egl_multiTexCoord2fv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord2fv()
{
 esdl_glMultiTexCoord2fv = (PFNGLMULTITEXCOORD2FVPROC) SDL_GL_GetProcAddress("glMultiTexCoord2fv");
 if(NULL != esdl_glMultiTexCoord2fv )
   return (sdl_fun) egl_multiTexCoord2fv; 
 else return NULL; 
}

void egl_multiTexCoord2fv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLfloat * v;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 v = (GLfloat *) bp; bp += sizeof(GLfloat)*2; 
 esdl_glMultiTexCoord2fv(*target, v);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD2IVPROC)(GLenum target,  const GLint * v);
PFNGLMULTITEXCOORD2IVPROC esdl_glMultiTexCoord2iv = NULL;
void egl_multiTexCoord2iv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord2iv()
{
 esdl_glMultiTexCoord2iv = (PFNGLMULTITEXCOORD2IVPROC) SDL_GL_GetProcAddress("glMultiTexCoord2iv");
 if(NULL != esdl_glMultiTexCoord2iv )
   return (sdl_fun) egl_multiTexCoord2iv; 
 else return NULL; 
}

void egl_multiTexCoord2iv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLint * v;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 v = (GLint *) bp; bp += sizeof(GLint)*2; 
 esdl_glMultiTexCoord2iv(*target, v);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD2SVPROC)(GLenum target,  const GLshort * v);
PFNGLMULTITEXCOORD2SVPROC esdl_glMultiTexCoord2sv = NULL;
void egl_multiTexCoord2sv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord2sv()
{
 esdl_glMultiTexCoord2sv = (PFNGLMULTITEXCOORD2SVPROC) SDL_GL_GetProcAddress("glMultiTexCoord2sv");
 if(NULL != esdl_glMultiTexCoord2sv )
   return (sdl_fun) egl_multiTexCoord2sv; 
 else return NULL; 
}

void egl_multiTexCoord2sv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLshort * v;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 v = (GLshort *) bp; bp += sizeof(GLshort)*2; 
 esdl_glMultiTexCoord2sv(*target, v);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD3DVPROC)(GLenum target,  const GLdouble * v);
PFNGLMULTITEXCOORD3DVPROC esdl_glMultiTexCoord3dv = NULL;
void egl_multiTexCoord3dv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord3dv()
{
 esdl_glMultiTexCoord3dv = (PFNGLMULTITEXCOORD3DVPROC) SDL_GL_GetProcAddress("glMultiTexCoord3dv");
 if(NULL != esdl_glMultiTexCoord3dv )
   return (sdl_fun) egl_multiTexCoord3dv; 
 else return NULL; 
}

void egl_multiTexCoord3dv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLdouble v[3];
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 memcpy(v,bp,sizeof(GLdouble)*3); bp += sizeof(GLdouble)*3; 
 esdl_glMultiTexCoord3dv(*target, v);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD3FVPROC)(GLenum target,  const GLfloat * v);
PFNGLMULTITEXCOORD3FVPROC esdl_glMultiTexCoord3fv = NULL;
void egl_multiTexCoord3fv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord3fv()
{
 esdl_glMultiTexCoord3fv = (PFNGLMULTITEXCOORD3FVPROC) SDL_GL_GetProcAddress("glMultiTexCoord3fv");
 if(NULL != esdl_glMultiTexCoord3fv )
   return (sdl_fun) egl_multiTexCoord3fv; 
 else return NULL; 
}

void egl_multiTexCoord3fv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLfloat * v;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 v = (GLfloat *) bp; bp += sizeof(GLfloat)*3; 
 esdl_glMultiTexCoord3fv(*target, v);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD3IVPROC)(GLenum target,  const GLint * v);
PFNGLMULTITEXCOORD3IVPROC esdl_glMultiTexCoord3iv = NULL;
void egl_multiTexCoord3iv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord3iv()
{
 esdl_glMultiTexCoord3iv = (PFNGLMULTITEXCOORD3IVPROC) SDL_GL_GetProcAddress("glMultiTexCoord3iv");
 if(NULL != esdl_glMultiTexCoord3iv )
   return (sdl_fun) egl_multiTexCoord3iv; 
 else return NULL; 
}

void egl_multiTexCoord3iv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLint * v;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 v = (GLint *) bp; bp += sizeof(GLint)*3; 
 esdl_glMultiTexCoord3iv(*target, v);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD3SVPROC)(GLenum target,  const GLshort * v);
PFNGLMULTITEXCOORD3SVPROC esdl_glMultiTexCoord3sv = NULL;
void egl_multiTexCoord3sv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord3sv()
{
 esdl_glMultiTexCoord3sv = (PFNGLMULTITEXCOORD3SVPROC) SDL_GL_GetProcAddress("glMultiTexCoord3sv");
 if(NULL != esdl_glMultiTexCoord3sv )
   return (sdl_fun) egl_multiTexCoord3sv; 
 else return NULL; 
}

void egl_multiTexCoord3sv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLshort * v;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 v = (GLshort *) bp; bp += sizeof(GLshort)*3; 
 esdl_glMultiTexCoord3sv(*target, v);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD4DVPROC)(GLenum target,  const GLdouble * v);
PFNGLMULTITEXCOORD4DVPROC esdl_glMultiTexCoord4dv = NULL;
void egl_multiTexCoord4dv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord4dv()
{
 esdl_glMultiTexCoord4dv = (PFNGLMULTITEXCOORD4DVPROC) SDL_GL_GetProcAddress("glMultiTexCoord4dv");
 if(NULL != esdl_glMultiTexCoord4dv )
   return (sdl_fun) egl_multiTexCoord4dv; 
 else return NULL; 
}

void egl_multiTexCoord4dv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLdouble v[4];
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 memcpy(v,bp,sizeof(GLdouble)*4); bp += sizeof(GLdouble)*4; 
 esdl_glMultiTexCoord4dv(*target, v);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD4FVPROC)(GLenum target,  const GLfloat * v);
PFNGLMULTITEXCOORD4FVPROC esdl_glMultiTexCoord4fv = NULL;
void egl_multiTexCoord4fv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord4fv()
{
 esdl_glMultiTexCoord4fv = (PFNGLMULTITEXCOORD4FVPROC) SDL_GL_GetProcAddress("glMultiTexCoord4fv");
 if(NULL != esdl_glMultiTexCoord4fv )
   return (sdl_fun) egl_multiTexCoord4fv; 
 else return NULL; 
}

void egl_multiTexCoord4fv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLfloat * v;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 v = (GLfloat *) bp; bp += sizeof(GLfloat)*4; 
 esdl_glMultiTexCoord4fv(*target, v);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD4IVPROC)(GLenum target,  const GLint * v);
PFNGLMULTITEXCOORD4IVPROC esdl_glMultiTexCoord4iv = NULL;
void egl_multiTexCoord4iv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord4iv()
{
 esdl_glMultiTexCoord4iv = (PFNGLMULTITEXCOORD4IVPROC) SDL_GL_GetProcAddress("glMultiTexCoord4iv");
 if(NULL != esdl_glMultiTexCoord4iv )
   return (sdl_fun) egl_multiTexCoord4iv; 
 else return NULL; 
}

void egl_multiTexCoord4iv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLint * v;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 v = (GLint *) bp; bp += sizeof(GLint)*4; 
 esdl_glMultiTexCoord4iv(*target, v);

}

typedef void (APIENTRY * PFNGLMULTITEXCOORD4SVPROC)(GLenum target,  const GLshort * v);
PFNGLMULTITEXCOORD4SVPROC esdl_glMultiTexCoord4sv = NULL;
void egl_multiTexCoord4sv(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiTexCoord4sv()
{
 esdl_glMultiTexCoord4sv = (PFNGLMULTITEXCOORD4SVPROC) SDL_GL_GetProcAddress("glMultiTexCoord4sv");
 if(NULL != esdl_glMultiTexCoord4sv )
   return (sdl_fun) egl_multiTexCoord4sv; 
 else return NULL; 
}

void egl_multiTexCoord4sv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLshort * v;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 v = (GLshort *) bp; bp += sizeof(GLshort)*4; 
 esdl_glMultiTexCoord4sv(*target, v);

}

typedef void (APIENTRY * PFNGLLOADTRANSPOSEMATRIXFPROC)( const GLfloat * m);
PFNGLLOADTRANSPOSEMATRIXFPROC esdl_glLoadTransposeMatrixf = NULL;
void egl_loadTransposeMatrixf(sdl_data *, int, char *);
sdl_fun esdl_load_glLoadTransposeMatrixf()
{
 esdl_glLoadTransposeMatrixf = (PFNGLLOADTRANSPOSEMATRIXFPROC) SDL_GL_GetProcAddress("glLoadTransposeMatrixf");
 if(NULL != esdl_glLoadTransposeMatrixf )
   return (sdl_fun) egl_loadTransposeMatrixf; 
 else return NULL; 
}

void egl_loadTransposeMatrixf(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLfloat * m;
 bp = egl_buff;
 m = (GLfloat *) bp; bp += sizeof(GLfloat)*16; 
 esdl_glLoadTransposeMatrixf(m);

}

typedef void (APIENTRY * PFNGLLOADTRANSPOSEMATRIXDPROC)( const GLdouble * m);
PFNGLLOADTRANSPOSEMATRIXDPROC esdl_glLoadTransposeMatrixd = NULL;
void egl_loadTransposeMatrixd(sdl_data *, int, char *);
sdl_fun esdl_load_glLoadTransposeMatrixd()
{
 esdl_glLoadTransposeMatrixd = (PFNGLLOADTRANSPOSEMATRIXDPROC) SDL_GL_GetProcAddress("glLoadTransposeMatrixd");
 if(NULL != esdl_glLoadTransposeMatrixd )
   return (sdl_fun) egl_loadTransposeMatrixd; 
 else return NULL; 
}

void egl_loadTransposeMatrixd(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLdouble m[16];
 bp = egl_buff;
 memcpy(m,bp,sizeof(GLdouble)*16); bp += sizeof(GLdouble)*16; 
 esdl_glLoadTransposeMatrixd(m);

}

typedef void (APIENTRY * PFNGLMULTTRANSPOSEMATRIXFPROC)( const GLfloat * m);
PFNGLMULTTRANSPOSEMATRIXFPROC esdl_glMultTransposeMatrixf = NULL;
void egl_multTransposeMatrixf(sdl_data *, int, char *);
sdl_fun esdl_load_glMultTransposeMatrixf()
{
 esdl_glMultTransposeMatrixf = (PFNGLMULTTRANSPOSEMATRIXFPROC) SDL_GL_GetProcAddress("glMultTransposeMatrixf");
 if(NULL != esdl_glMultTransposeMatrixf )
   return (sdl_fun) egl_multTransposeMatrixf; 
 else return NULL; 
}

void egl_multTransposeMatrixf(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLfloat * m;
 bp = egl_buff;
 m = (GLfloat *) bp; bp += sizeof(GLfloat)*16; 
 esdl_glMultTransposeMatrixf(m);

}

typedef void (APIENTRY * PFNGLMULTTRANSPOSEMATRIXDPROC)( const GLdouble * m);
PFNGLMULTTRANSPOSEMATRIXDPROC esdl_glMultTransposeMatrixd = NULL;
void egl_multTransposeMatrixd(sdl_data *, int, char *);
sdl_fun esdl_load_glMultTransposeMatrixd()
{
 esdl_glMultTransposeMatrixd = (PFNGLMULTTRANSPOSEMATRIXDPROC) SDL_GL_GetProcAddress("glMultTransposeMatrixd");
 if(NULL != esdl_glMultTransposeMatrixd )
   return (sdl_fun) egl_multTransposeMatrixd; 
 else return NULL; 
}

void egl_multTransposeMatrixd(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLdouble m[16];
 bp = egl_buff;
 memcpy(m,bp,sizeof(GLdouble)*16); bp += sizeof(GLdouble)*16; 
 esdl_glMultTransposeMatrixd(m);

}

typedef void (APIENTRY * PFNGLSAMPLECOVERAGEPROC)(GLclampf value, GLboolean invert);
PFNGLSAMPLECOVERAGEPROC esdl_glSampleCoverage = NULL;
void egl_sampleCoverage(sdl_data *, int, char *);
sdl_fun esdl_load_glSampleCoverage()
{
 esdl_glSampleCoverage = (PFNGLSAMPLECOVERAGEPROC) SDL_GL_GetProcAddress("glSampleCoverage");
 if(NULL != esdl_glSampleCoverage )
   return (sdl_fun) egl_sampleCoverage; 
 else return NULL; 
}

void egl_sampleCoverage(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLclampf * value;
 GLboolean * invert;
 bp = egl_buff;
 value = (GLclampf *) bp; bp += sizeof(GLclampf); 
 invert = (GLboolean *) bp; bp += sizeof(GLboolean); 
 esdl_glSampleCoverage(*value, *invert);

}

typedef void (APIENTRY * PFNGLCOMPRESSEDTEXIMAGE3DPROC)(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize,  const GLvoid * data);
PFNGLCOMPRESSEDTEXIMAGE3DPROC esdl_glCompressedTexImage3D = NULL;
void egl_compressedTexImage3D(sdl_data *, int, char *);
sdl_fun esdl_load_glCompressedTexImage3D()
{
 esdl_glCompressedTexImage3D = (PFNGLCOMPRESSEDTEXIMAGE3DPROC) SDL_GL_GetProcAddress("glCompressedTexImage3D");
 if(NULL != esdl_glCompressedTexImage3D )
   return (sdl_fun) egl_compressedTexImage3D; 
 else return NULL; 
}

void egl_compressedTexImage3D(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLint * level;
 GLenum * internalformat;
 GLsizei * width;
 GLsizei * height;
 GLsizei * depth;
 GLint * border;
 GLsizei * imageSize;
 int * dataMemT = 0;
 int * dataLen = 0;
 GLvoid * data = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 level = (GLint *) bp; bp += sizeof(GLint); 
 internalformat = (GLenum *) bp; bp += sizeof(GLenum); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 height = (GLsizei *) bp; bp += sizeof(GLsizei); 
 depth = (GLsizei *) bp; bp += sizeof(GLsizei); 
 border = (GLint *) bp; bp += sizeof(GLint); 
 imageSize = (GLsizei *) bp; bp += sizeof(GLsizei); 
 dataMemT = (int *)bp; bp += sizeof(int);
 if(*dataMemT == 1) {
  data = (GLvoid *) getPointer(bp);
  data = usePointer((oglmem *)data);} else {
  dataLen = (int *)bp; bp += sizeof(int); 
  data = (GLvoid *) bp; bp += *dataLen;};
 esdl_glCompressedTexImage3D(*target, *level, *internalformat, *width, *height, *depth, *border, *imageSize, data);

}

typedef void (APIENTRY * PFNGLCOMPRESSEDTEXIMAGE2DPROC)(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize,  const GLvoid * data);
PFNGLCOMPRESSEDTEXIMAGE2DPROC esdl_glCompressedTexImage2D = NULL;
void egl_compressedTexImage2D(sdl_data *, int, char *);
sdl_fun esdl_load_glCompressedTexImage2D()
{
 esdl_glCompressedTexImage2D = (PFNGLCOMPRESSEDTEXIMAGE2DPROC) SDL_GL_GetProcAddress("glCompressedTexImage2D");
 if(NULL != esdl_glCompressedTexImage2D )
   return (sdl_fun) egl_compressedTexImage2D; 
 else return NULL; 
}

void egl_compressedTexImage2D(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLint * level;
 GLenum * internalformat;
 GLsizei * width;
 GLsizei * height;
 GLint * border;
 GLsizei * imageSize;
 int * dataMemT = 0;
 int * dataLen = 0;
 GLvoid * data = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 level = (GLint *) bp; bp += sizeof(GLint); 
 internalformat = (GLenum *) bp; bp += sizeof(GLenum); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 height = (GLsizei *) bp; bp += sizeof(GLsizei); 
 border = (GLint *) bp; bp += sizeof(GLint); 
 imageSize = (GLsizei *) bp; bp += sizeof(GLsizei); 
 dataMemT = (int *)bp; bp += sizeof(int);
 if(*dataMemT == 1) {
  data = (GLvoid *) getPointer(bp);
  data = usePointer((oglmem *)data);} else {
  dataLen = (int *)bp; bp += sizeof(int); 
  data = (GLvoid *) bp; bp += *dataLen;};
 esdl_glCompressedTexImage2D(*target, *level, *internalformat, *width, *height, *border, *imageSize, data);

}

typedef void (APIENTRY * PFNGLCOMPRESSEDTEXIMAGE1DPROC)(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize,  const GLvoid * data);
PFNGLCOMPRESSEDTEXIMAGE1DPROC esdl_glCompressedTexImage1D = NULL;
void egl_compressedTexImage1D(sdl_data *, int, char *);
sdl_fun esdl_load_glCompressedTexImage1D()
{
 esdl_glCompressedTexImage1D = (PFNGLCOMPRESSEDTEXIMAGE1DPROC) SDL_GL_GetProcAddress("glCompressedTexImage1D");
 if(NULL != esdl_glCompressedTexImage1D )
   return (sdl_fun) egl_compressedTexImage1D; 
 else return NULL; 
}

void egl_compressedTexImage1D(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLint * level;
 GLenum * internalformat;
 GLsizei * width;
 GLint * border;
 GLsizei * imageSize;
 int * dataMemT = 0;
 int * dataLen = 0;
 GLvoid * data = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 level = (GLint *) bp; bp += sizeof(GLint); 
 internalformat = (GLenum *) bp; bp += sizeof(GLenum); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 border = (GLint *) bp; bp += sizeof(GLint); 
 imageSize = (GLsizei *) bp; bp += sizeof(GLsizei); 
 dataMemT = (int *)bp; bp += sizeof(int);
 if(*dataMemT == 1) {
  data = (GLvoid *) getPointer(bp);
  data = usePointer((oglmem *)data);} else {
  dataLen = (int *)bp; bp += sizeof(int); 
  data = (GLvoid *) bp; bp += *dataLen;};
 esdl_glCompressedTexImage1D(*target, *level, *internalformat, *width, *border, *imageSize, data);

}

typedef void (APIENTRY * PFNGLCOMPRESSEDTEXSUBIMAGE3DPROC)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize,  const GLvoid * data);
PFNGLCOMPRESSEDTEXSUBIMAGE3DPROC esdl_glCompressedTexSubImage3D = NULL;
void egl_compressedTexSubImage3D(sdl_data *, int, char *);
sdl_fun esdl_load_glCompressedTexSubImage3D()
{
 esdl_glCompressedTexSubImage3D = (PFNGLCOMPRESSEDTEXSUBIMAGE3DPROC) SDL_GL_GetProcAddress("glCompressedTexSubImage3D");
 if(NULL != esdl_glCompressedTexSubImage3D )
   return (sdl_fun) egl_compressedTexSubImage3D; 
 else return NULL; 
}

void egl_compressedTexSubImage3D(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLint * level;
 GLint * xoffset;
 GLint * yoffset;
 GLint * zoffset;
 GLsizei * width;
 GLsizei * height;
 GLsizei * depth;
 GLenum * format;
 GLsizei * imageSize;
 int * dataMemT = 0;
 int * dataLen = 0;
 GLvoid * data = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 level = (GLint *) bp; bp += sizeof(GLint); 
 xoffset = (GLint *) bp; bp += sizeof(GLint); 
 yoffset = (GLint *) bp; bp += sizeof(GLint); 
 zoffset = (GLint *) bp; bp += sizeof(GLint); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 height = (GLsizei *) bp; bp += sizeof(GLsizei); 
 depth = (GLsizei *) bp; bp += sizeof(GLsizei); 
 format = (GLenum *) bp; bp += sizeof(GLenum); 
 imageSize = (GLsizei *) bp; bp += sizeof(GLsizei); 
 dataMemT = (int *)bp; bp += sizeof(int);
 if(*dataMemT == 1) {
  data = (GLvoid *) getPointer(bp);
  data = usePointer((oglmem *)data);} else {
  dataLen = (int *)bp; bp += sizeof(int); 
  data = (GLvoid *) bp; bp += *dataLen;};
 esdl_glCompressedTexSubImage3D(*target, *level, *xoffset, *yoffset, *zoffset, *width, *height, *depth, *format, *imageSize, data);

}

typedef void (APIENTRY * PFNGLCOMPRESSEDTEXSUBIMAGE2DPROC)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize,  const GLvoid * data);
PFNGLCOMPRESSEDTEXSUBIMAGE2DPROC esdl_glCompressedTexSubImage2D = NULL;
void egl_compressedTexSubImage2D(sdl_data *, int, char *);
sdl_fun esdl_load_glCompressedTexSubImage2D()
{
 esdl_glCompressedTexSubImage2D = (PFNGLCOMPRESSEDTEXSUBIMAGE2DPROC) SDL_GL_GetProcAddress("glCompressedTexSubImage2D");
 if(NULL != esdl_glCompressedTexSubImage2D )
   return (sdl_fun) egl_compressedTexSubImage2D; 
 else return NULL; 
}

void egl_compressedTexSubImage2D(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLint * level;
 GLint * xoffset;
 GLint * yoffset;
 GLsizei * width;
 GLsizei * height;
 GLenum * format;
 GLsizei * imageSize;
 int * dataMemT = 0;
 int * dataLen = 0;
 GLvoid * data = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 level = (GLint *) bp; bp += sizeof(GLint); 
 xoffset = (GLint *) bp; bp += sizeof(GLint); 
 yoffset = (GLint *) bp; bp += sizeof(GLint); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 height = (GLsizei *) bp; bp += sizeof(GLsizei); 
 format = (GLenum *) bp; bp += sizeof(GLenum); 
 imageSize = (GLsizei *) bp; bp += sizeof(GLsizei); 
 dataMemT = (int *)bp; bp += sizeof(int);
 if(*dataMemT == 1) {
  data = (GLvoid *) getPointer(bp);
  data = usePointer((oglmem *)data);} else {
  dataLen = (int *)bp; bp += sizeof(int); 
  data = (GLvoid *) bp; bp += *dataLen;};
 esdl_glCompressedTexSubImage2D(*target, *level, *xoffset, *yoffset, *width, *height, *format, *imageSize, data);

}

typedef void (APIENTRY * PFNGLCOMPRESSEDTEXSUBIMAGE1DPROC)(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize,  const GLvoid * data);
PFNGLCOMPRESSEDTEXSUBIMAGE1DPROC esdl_glCompressedTexSubImage1D = NULL;
void egl_compressedTexSubImage1D(sdl_data *, int, char *);
sdl_fun esdl_load_glCompressedTexSubImage1D()
{
 esdl_glCompressedTexSubImage1D = (PFNGLCOMPRESSEDTEXSUBIMAGE1DPROC) SDL_GL_GetProcAddress("glCompressedTexSubImage1D");
 if(NULL != esdl_glCompressedTexSubImage1D )
   return (sdl_fun) egl_compressedTexSubImage1D; 
 else return NULL; 
}

void egl_compressedTexSubImage1D(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLint * level;
 GLint * xoffset;
 GLsizei * width;
 GLenum * format;
 GLsizei * imageSize;
 int * dataMemT = 0;
 int * dataLen = 0;
 GLvoid * data = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 level = (GLint *) bp; bp += sizeof(GLint); 
 xoffset = (GLint *) bp; bp += sizeof(GLint); 
 width = (GLsizei *) bp; bp += sizeof(GLsizei); 
 format = (GLenum *) bp; bp += sizeof(GLenum); 
 imageSize = (GLsizei *) bp; bp += sizeof(GLsizei); 
 dataMemT = (int *)bp; bp += sizeof(int);
 if(*dataMemT == 1) {
  data = (GLvoid *) getPointer(bp);
  data = usePointer((oglmem *)data);} else {
  dataLen = (int *)bp; bp += sizeof(int); 
  data = (GLvoid *) bp; bp += *dataLen;};
 esdl_glCompressedTexSubImage1D(*target, *level, *xoffset, *width, *format, *imageSize, data);

}

typedef void (APIENTRY * PFNGLGETCOMPRESSEDTEXIMAGEPROC)(GLenum target, GLint level, void * img);
PFNGLGETCOMPRESSEDTEXIMAGEPROC esdl_glGetCompressedTexImage = NULL;
void egl_getCompressedTexImage(sdl_data *, int, char *);
sdl_fun esdl_load_glGetCompressedTexImage()
{
 esdl_glGetCompressedTexImage = (PFNGLGETCOMPRESSEDTEXIMAGEPROC) SDL_GL_GetProcAddress("glGetCompressedTexImage");
 if(NULL != esdl_glGetCompressedTexImage )
   return (sdl_fun) egl_getCompressedTexImage; 
 else return NULL; 
}

void egl_getCompressedTexImage(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLint * level;
 oglmem * img = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 level = (GLint *) bp; bp += sizeof(GLint); 
 img = getPointer(bp); 
 esdl_glGetCompressedTexImage(*target, *level, usePointer(img));

}

//typedef void (APIENTRY * PFNGLBLENDFUNCSEPARATEPROC)(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha);
PFNGLBLENDFUNCSEPARATEPROC esdl_glBlendFuncSeparate = NULL;
void egl_blendFuncSeparate(sdl_data *, int, char *);
sdl_fun esdl_load_glBlendFuncSeparate()
{
 esdl_glBlendFuncSeparate = (PFNGLBLENDFUNCSEPARATEPROC) SDL_GL_GetProcAddress("glBlendFuncSeparate");
 if(NULL != esdl_glBlendFuncSeparate )
   return (sdl_fun) egl_blendFuncSeparate; 
 else return NULL; 
}

void egl_blendFuncSeparate(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * sfactorRGB;
 GLenum * dfactorRGB;
 GLenum * sfactorAlpha;
 GLenum * dfactorAlpha;
 bp = egl_buff;
 sfactorRGB = (GLenum *) bp; bp += sizeof(GLenum); 
 dfactorRGB = (GLenum *) bp; bp += sizeof(GLenum); 
 sfactorAlpha = (GLenum *) bp; bp += sizeof(GLenum); 
 dfactorAlpha = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glBlendFuncSeparate(*sfactorRGB, *dfactorRGB, *sfactorAlpha, *dfactorAlpha);

}

//typedef void (APIENTRY * PFNGLFOGCOORDFPROC)(GLfloat coord);
PFNGLFOGCOORDFPROC esdl_glFogCoordf = NULL;
void egl_fogCoordf(sdl_data *, int, char *);
sdl_fun esdl_load_glFogCoordf()
{
 esdl_glFogCoordf = (PFNGLFOGCOORDFPROC) SDL_GL_GetProcAddress("glFogCoordf");
 if(NULL != esdl_glFogCoordf )
   return (sdl_fun) egl_fogCoordf; 
 else return NULL; 
}

void egl_fogCoordf(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLfloat * coord;
 bp = egl_buff;
 coord = (GLfloat *) bp; bp += sizeof(GLfloat); 
 esdl_glFogCoordf(*coord);

}

//typedef void (APIENTRY * PFNGLFOGCOORDFVPROC)( const GLfloat * coord);
PFNGLFOGCOORDFVPROC esdl_glFogCoordfv = NULL;
void egl_fogCoordfv(sdl_data *, int, char *);
sdl_fun esdl_load_glFogCoordfv()
{
 esdl_glFogCoordfv = (PFNGLFOGCOORDFVPROC) SDL_GL_GetProcAddress("glFogCoordfv");
 if(NULL != esdl_glFogCoordfv )
   return (sdl_fun) egl_fogCoordfv; 
 else return NULL; 
}

void egl_fogCoordfv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLfloat * coord;
 bp = egl_buff;
 coord = (GLfloat *) bp; bp += sizeof(GLfloat)*1; 
 esdl_glFogCoordfv(coord);

}

//typedef void (APIENTRY * PFNGLFOGCOORDDPROC)(GLdouble coord);
PFNGLFOGCOORDDPROC esdl_glFogCoordd = NULL;
void egl_fogCoordd(sdl_data *, int, char *);
sdl_fun esdl_load_glFogCoordd()
{
 esdl_glFogCoordd = (PFNGLFOGCOORDDPROC) SDL_GL_GetProcAddress("glFogCoordd");
 if(NULL != esdl_glFogCoordd )
   return (sdl_fun) egl_fogCoordd; 
 else return NULL; 
}

void egl_fogCoordd(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLdouble coord;
 bp = egl_buff;
 memcpy(&coord, bp, sizeof(GLdouble)); bp += sizeof(GLdouble); 
 esdl_glFogCoordd(coord);

}

//typedef void (APIENTRY * PFNGLFOGCOORDDVPROC)( const GLdouble * coord);
PFNGLFOGCOORDDVPROC esdl_glFogCoorddv = NULL;
void egl_fogCoorddv(sdl_data *, int, char *);
sdl_fun esdl_load_glFogCoorddv()
{
 esdl_glFogCoorddv = (PFNGLFOGCOORDDVPROC) SDL_GL_GetProcAddress("glFogCoorddv");
 if(NULL != esdl_glFogCoorddv )
   return (sdl_fun) egl_fogCoorddv; 
 else return NULL; 
}

void egl_fogCoorddv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLdouble coord[1];
 bp = egl_buff;
 memcpy(coord,bp,sizeof(GLdouble)*1); bp += sizeof(GLdouble)*1; 
 esdl_glFogCoorddv(coord);

}

//typedef void (APIENTRY * PFNGLFOGCOORDPOINTERPROC)(GLenum type, GLsizei stride,  const GLvoid * pointer);
PFNGLFOGCOORDPOINTERPROC esdl_glFogCoordPointer = NULL;
void egl_fogCoordPointer(sdl_data *, int, char *);
sdl_fun esdl_load_glFogCoordPointer()
{
 esdl_glFogCoordPointer = (PFNGLFOGCOORDPOINTERPROC) SDL_GL_GetProcAddress("glFogCoordPointer");
 if(NULL != esdl_glFogCoordPointer )
   return (sdl_fun) egl_fogCoordPointer; 
 else return NULL; 
}

void egl_fogCoordPointer(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * type;
 GLsizei * stride;
 int * pointerMemT = 0;
 int * pointerLen = 0;
 GLvoid * pointer = NULL;
 bp = egl_buff;
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 stride = (GLsizei *) bp; bp += sizeof(GLsizei); 
 pointerMemT = (int *)bp; bp += sizeof(int);
 if(*pointerMemT == 1) {
  pointer = (GLvoid *) getPointer(bp);
  pointer = usePointer((oglmem *)pointer);} else {
  pointerLen = (int *)bp; bp += sizeof(int); 
  pointer = (GLvoid *) bp; bp += *pointerLen;};
 esdl_glFogCoordPointer(*type, *stride, pointer);

}

//typedef void (APIENTRY * PFNGLMULTIDRAWARRAYSPROC)(GLenum mode,  const GLint * first,  const GLsizei * count, GLsizei primcount);
PFNGLMULTIDRAWARRAYSPROC esdl_glMultiDrawArrays = NULL;
void egl_multiDrawArrays(sdl_data *, int, char *);
sdl_fun esdl_load_glMultiDrawArrays()
{
 esdl_glMultiDrawArrays = (PFNGLMULTIDRAWARRAYSPROC) SDL_GL_GetProcAddress("glMultiDrawArrays");
 if(NULL != esdl_glMultiDrawArrays )
   return (sdl_fun) egl_multiDrawArrays; 
 else return NULL; 
}

void egl_multiDrawArrays(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * mode;
 GLint * first = NULL; int * firstLen;
 GLsizei * count = NULL; int * countLen;
 GLsizei * primcount;
 bp = egl_buff;
 primcount = (GLsizei *) bp; bp += sizeof(GLsizei); 
 mode = (GLenum *) bp; bp += sizeof(GLenum); 
 firstLen = primcount;
 first = (GLint *) bp; bp += sizeof(GLint)*(*firstLen); 
 countLen = primcount;
 count = (GLsizei *) bp; bp += sizeof(GLsizei)*(*countLen); 
 esdl_glMultiDrawArrays(*mode, first, count, *primcount);

}

//typedef void (APIENTRY * PFNGLPOINTPARAMETERFPROC)(GLenum pname, GLfloat param);
PFNGLPOINTPARAMETERFPROC esdl_glPointParameterf = NULL;
void egl_pointParameterf(sdl_data *, int, char *);
sdl_fun esdl_load_glPointParameterf()
{
 esdl_glPointParameterf = (PFNGLPOINTPARAMETERFPROC) SDL_GL_GetProcAddress("glPointParameterf");
 if(NULL != esdl_glPointParameterf )
   return (sdl_fun) egl_pointParameterf; 
 else return NULL; 
}

void egl_pointParameterf(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * pname;
 GLfloat * param;
 bp = egl_buff;
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 param = (GLfloat *) bp; bp += sizeof(GLfloat); 
 esdl_glPointParameterf(*pname, *param);

}

//typedef void (APIENTRY * PFNGLPOINTPARAMETERFVPROC)(GLenum pname,  const GLfloat * params);
PFNGLPOINTPARAMETERFVPROC esdl_glPointParameterfv = NULL;
void egl_pointParameterfv(sdl_data *, int, char *);
sdl_fun esdl_load_glPointParameterfv()
{
 esdl_glPointParameterfv = (PFNGLPOINTPARAMETERFVPROC) SDL_GL_GetProcAddress("glPointParameterfv");
 if(NULL != esdl_glPointParameterfv )
   return (sdl_fun) egl_pointParameterfv; 
 else return NULL; 
}

void egl_pointParameterfv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * pname;
 GLfloat * params;
 bp = egl_buff;
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 params = (GLfloat *) bp; bp += sizeof(GLfloat)*3; 
 esdl_glPointParameterfv(*pname, params);

}

//typedef void (APIENTRY * PFNGLPOINTPARAMETERIPROC)(GLenum pname, GLint param);
PFNGLPOINTPARAMETERIPROC esdl_glPointParameteri = NULL;
void egl_pointParameteri(sdl_data *, int, char *);
sdl_fun esdl_load_glPointParameteri()
{
 esdl_glPointParameteri = (PFNGLPOINTPARAMETERIPROC) SDL_GL_GetProcAddress("glPointParameteri");
 if(NULL != esdl_glPointParameteri )
   return (sdl_fun) egl_pointParameteri; 
 else return NULL; 
}

void egl_pointParameteri(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * pname;
 GLint * param;
 bp = egl_buff;
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 param = (GLint *) bp; bp += sizeof(GLint); 
 esdl_glPointParameteri(*pname, *param);

}

//typedef void (APIENTRY * PFNGLPOINTPARAMETERIVPROC)(GLenum pname,  const GLint * params);
PFNGLPOINTPARAMETERIVPROC esdl_glPointParameteriv = NULL;
void egl_pointParameteriv(sdl_data *, int, char *);
sdl_fun esdl_load_glPointParameteriv()
{
 esdl_glPointParameteriv = (PFNGLPOINTPARAMETERIVPROC) SDL_GL_GetProcAddress("glPointParameteriv");
 if(NULL != esdl_glPointParameteriv )
   return (sdl_fun) egl_pointParameteriv; 
 else return NULL; 
}

void egl_pointParameteriv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * pname;
 GLint * params;
 bp = egl_buff;
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 params = (GLint *) bp; bp += sizeof(GLint)*3; 
 esdl_glPointParameteriv(*pname, params);

}

//typedef void (APIENTRY * PFNGLSECONDARYCOLOR3BVPROC)( const GLbyte * v);
PFNGLSECONDARYCOLOR3BVPROC esdl_glSecondaryColor3bv = NULL;
void egl_secondaryColor3bv(sdl_data *, int, char *);
sdl_fun esdl_load_glSecondaryColor3bv()
{
 esdl_glSecondaryColor3bv = (PFNGLSECONDARYCOLOR3BVPROC) SDL_GL_GetProcAddress("glSecondaryColor3bv");
 if(NULL != esdl_glSecondaryColor3bv )
   return (sdl_fun) egl_secondaryColor3bv; 
 else return NULL; 
}

void egl_secondaryColor3bv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLbyte * v;
 bp = egl_buff;
 v = (GLbyte *) bp; bp += sizeof(GLbyte)*3; 
 esdl_glSecondaryColor3bv(v);

}

//typedef void (APIENTRY * PFNGLSECONDARYCOLOR3DVPROC)( const GLdouble * v);
PFNGLSECONDARYCOLOR3DVPROC esdl_glSecondaryColor3dv = NULL;
void egl_secondaryColor3dv(sdl_data *, int, char *);
sdl_fun esdl_load_glSecondaryColor3dv()
{
 esdl_glSecondaryColor3dv = (PFNGLSECONDARYCOLOR3DVPROC) SDL_GL_GetProcAddress("glSecondaryColor3dv");
 if(NULL != esdl_glSecondaryColor3dv )
   return (sdl_fun) egl_secondaryColor3dv; 
 else return NULL; 
}

void egl_secondaryColor3dv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLdouble v[3];
 bp = egl_buff;
 memcpy(v,bp,sizeof(GLdouble)*3); bp += sizeof(GLdouble)*3; 
 esdl_glSecondaryColor3dv(v);

}

//typedef void (APIENTRY * PFNGLSECONDARYCOLOR3FVPROC)( const GLfloat * v);
PFNGLSECONDARYCOLOR3FVPROC esdl_glSecondaryColor3fv = NULL;
void egl_secondaryColor3fv(sdl_data *, int, char *);
sdl_fun esdl_load_glSecondaryColor3fv()
{
 esdl_glSecondaryColor3fv = (PFNGLSECONDARYCOLOR3FVPROC) SDL_GL_GetProcAddress("glSecondaryColor3fv");
 if(NULL != esdl_glSecondaryColor3fv )
   return (sdl_fun) egl_secondaryColor3fv; 
 else return NULL; 
}

void egl_secondaryColor3fv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLfloat * v;
 bp = egl_buff;
 v = (GLfloat *) bp; bp += sizeof(GLfloat)*3; 
 esdl_glSecondaryColor3fv(v);

}

//typedef void (APIENTRY * PFNGLSECONDARYCOLOR3IVPROC)( const GLint * v);
PFNGLSECONDARYCOLOR3IVPROC esdl_glSecondaryColor3iv = NULL;
void egl_secondaryColor3iv(sdl_data *, int, char *);
sdl_fun esdl_load_glSecondaryColor3iv()
{
 esdl_glSecondaryColor3iv = (PFNGLSECONDARYCOLOR3IVPROC) SDL_GL_GetProcAddress("glSecondaryColor3iv");
 if(NULL != esdl_glSecondaryColor3iv )
   return (sdl_fun) egl_secondaryColor3iv; 
 else return NULL; 
}

void egl_secondaryColor3iv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * v;
 bp = egl_buff;
 v = (GLint *) bp; bp += sizeof(GLint)*3; 
 esdl_glSecondaryColor3iv(v);

}

//typedef void (APIENTRY * PFNGLSECONDARYCOLOR3SVPROC)( const GLshort * v);
PFNGLSECONDARYCOLOR3SVPROC esdl_glSecondaryColor3sv = NULL;
void egl_secondaryColor3sv(sdl_data *, int, char *);
sdl_fun esdl_load_glSecondaryColor3sv()
{
 esdl_glSecondaryColor3sv = (PFNGLSECONDARYCOLOR3SVPROC) SDL_GL_GetProcAddress("glSecondaryColor3sv");
 if(NULL != esdl_glSecondaryColor3sv )
   return (sdl_fun) egl_secondaryColor3sv; 
 else return NULL; 
}

void egl_secondaryColor3sv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLshort * v;
 bp = egl_buff;
 v = (GLshort *) bp; bp += sizeof(GLshort)*3; 
 esdl_glSecondaryColor3sv(v);

}

//typedef void (APIENTRY * PFNGLSECONDARYCOLOR3UBVPROC)( const GLubyte * v);
PFNGLSECONDARYCOLOR3UBVPROC esdl_glSecondaryColor3ubv = NULL;
void egl_secondaryColor3ubv(sdl_data *, int, char *);
sdl_fun esdl_load_glSecondaryColor3ubv()
{
 esdl_glSecondaryColor3ubv = (PFNGLSECONDARYCOLOR3UBVPROC) SDL_GL_GetProcAddress("glSecondaryColor3ubv");
 if(NULL != esdl_glSecondaryColor3ubv )
   return (sdl_fun) egl_secondaryColor3ubv; 
 else return NULL; 
}

void egl_secondaryColor3ubv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLubyte * v;
 bp = egl_buff;
 v = (GLubyte *) bp; bp += sizeof(GLubyte)*3; 
 esdl_glSecondaryColor3ubv(v);

}

//typedef void (APIENTRY * PFNGLSECONDARYCOLOR3UIVPROC)( const GLuint * v);
PFNGLSECONDARYCOLOR3UIVPROC esdl_glSecondaryColor3uiv = NULL;
void egl_secondaryColor3uiv(sdl_data *, int, char *);
sdl_fun esdl_load_glSecondaryColor3uiv()
{
 esdl_glSecondaryColor3uiv = (PFNGLSECONDARYCOLOR3UIVPROC) SDL_GL_GetProcAddress("glSecondaryColor3uiv");
 if(NULL != esdl_glSecondaryColor3uiv )
   return (sdl_fun) egl_secondaryColor3uiv; 
 else return NULL; 
}

void egl_secondaryColor3uiv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * v;
 bp = egl_buff;
 v = (GLuint *) bp; bp += sizeof(GLuint)*3; 
 esdl_glSecondaryColor3uiv(v);

}

//typedef void (APIENTRY * PFNGLSECONDARYCOLOR3USVPROC)( const GLushort * v);
PFNGLSECONDARYCOLOR3USVPROC esdl_glSecondaryColor3usv = NULL;
void egl_secondaryColor3usv(sdl_data *, int, char *);
sdl_fun esdl_load_glSecondaryColor3usv()
{
 esdl_glSecondaryColor3usv = (PFNGLSECONDARYCOLOR3USVPROC) SDL_GL_GetProcAddress("glSecondaryColor3usv");
 if(NULL != esdl_glSecondaryColor3usv )
   return (sdl_fun) egl_secondaryColor3usv; 
 else return NULL; 
}

void egl_secondaryColor3usv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLushort * v;
 bp = egl_buff;
 v = (GLushort *) bp; bp += sizeof(GLushort)*3; 
 esdl_glSecondaryColor3usv(v);

}

//typedef void (APIENTRY * PFNGLSECONDARYCOLORPOINTERPROC)(GLint size, GLenum type, GLsizei stride,  const GLvoid * pointer);
PFNGLSECONDARYCOLORPOINTERPROC esdl_glSecondaryColorPointer = NULL;
void egl_secondaryColorPointer(sdl_data *, int, char *);
sdl_fun esdl_load_glSecondaryColorPointer()
{
 esdl_glSecondaryColorPointer = (PFNGLSECONDARYCOLORPOINTERPROC) SDL_GL_GetProcAddress("glSecondaryColorPointer");
 if(NULL != esdl_glSecondaryColorPointer )
   return (sdl_fun) egl_secondaryColorPointer; 
 else return NULL; 
}

void egl_secondaryColorPointer(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * size;
 GLenum * type;
 GLsizei * stride;
 int * pointerMemT = 0;
 int * pointerLen = 0;
 GLvoid * pointer = NULL;
 bp = egl_buff;
 size = (GLint *) bp; bp += sizeof(GLint); 
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 stride = (GLsizei *) bp; bp += sizeof(GLsizei); 
 pointerMemT = (int *)bp; bp += sizeof(int);
 if(*pointerMemT == 1) {
  pointer = (GLvoid *) getPointer(bp);
  pointer = usePointer((oglmem *)pointer);} else {
  pointerLen = (int *)bp; bp += sizeof(int); 
  pointer = (GLvoid *) bp; bp += *pointerLen;};
 esdl_glSecondaryColorPointer(*size, *type, *stride, pointer);

}

//typedef void (APIENTRY * PFNGLWINDOWPOS2DVPROC)( const GLdouble * v);
PFNGLWINDOWPOS2DVPROC esdl_glWindowPos2dv = NULL;
void egl_windowPos2dv(sdl_data *, int, char *);
sdl_fun esdl_load_glWindowPos2dv()
{
 esdl_glWindowPos2dv = (PFNGLWINDOWPOS2DVPROC) SDL_GL_GetProcAddress("glWindowPos2dv");
 if(NULL != esdl_glWindowPos2dv )
   return (sdl_fun) egl_windowPos2dv; 
 else return NULL; 
}

void egl_windowPos2dv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLdouble v[2];
 bp = egl_buff;
 memcpy(v,bp,sizeof(GLdouble)*2); bp += sizeof(GLdouble)*2; 
 esdl_glWindowPos2dv(v);

}

//typedef void (APIENTRY * PFNGLWINDOWPOS2FVPROC)( const GLfloat * v);
PFNGLWINDOWPOS2FVPROC esdl_glWindowPos2fv = NULL;
void egl_windowPos2fv(sdl_data *, int, char *);
sdl_fun esdl_load_glWindowPos2fv()
{
 esdl_glWindowPos2fv = (PFNGLWINDOWPOS2FVPROC) SDL_GL_GetProcAddress("glWindowPos2fv");
 if(NULL != esdl_glWindowPos2fv )
   return (sdl_fun) egl_windowPos2fv; 
 else return NULL; 
}

void egl_windowPos2fv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLfloat * v;
 bp = egl_buff;
 v = (GLfloat *) bp; bp += sizeof(GLfloat)*2; 
 esdl_glWindowPos2fv(v);

}

//typedef void (APIENTRY * PFNGLWINDOWPOS2IVPROC)( const GLint * v);
PFNGLWINDOWPOS2IVPROC esdl_glWindowPos2iv = NULL;
void egl_windowPos2iv(sdl_data *, int, char *);
sdl_fun esdl_load_glWindowPos2iv()
{
 esdl_glWindowPos2iv = (PFNGLWINDOWPOS2IVPROC) SDL_GL_GetProcAddress("glWindowPos2iv");
 if(NULL != esdl_glWindowPos2iv )
   return (sdl_fun) egl_windowPos2iv; 
 else return NULL; 
}

void egl_windowPos2iv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * v;
 bp = egl_buff;
 v = (GLint *) bp; bp += sizeof(GLint)*2; 
 esdl_glWindowPos2iv(v);

}

//typedef void (APIENTRY * PFNGLWINDOWPOS2SVPROC)( const GLshort * v);
PFNGLWINDOWPOS2SVPROC esdl_glWindowPos2sv = NULL;
void egl_windowPos2sv(sdl_data *, int, char *);
sdl_fun esdl_load_glWindowPos2sv()
{
 esdl_glWindowPos2sv = (PFNGLWINDOWPOS2SVPROC) SDL_GL_GetProcAddress("glWindowPos2sv");
 if(NULL != esdl_glWindowPos2sv )
   return (sdl_fun) egl_windowPos2sv; 
 else return NULL; 
}

void egl_windowPos2sv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLshort * v;
 bp = egl_buff;
 v = (GLshort *) bp; bp += sizeof(GLshort)*2; 
 esdl_glWindowPos2sv(v);

}

//typedef void (APIENTRY * PFNGLWINDOWPOS3DVPROC)( const GLdouble * v);
PFNGLWINDOWPOS3DVPROC esdl_glWindowPos3dv = NULL;
void egl_windowPos3dv(sdl_data *, int, char *);
sdl_fun esdl_load_glWindowPos3dv()
{
 esdl_glWindowPos3dv = (PFNGLWINDOWPOS3DVPROC) SDL_GL_GetProcAddress("glWindowPos3dv");
 if(NULL != esdl_glWindowPos3dv )
   return (sdl_fun) egl_windowPos3dv; 
 else return NULL; 
}

void egl_windowPos3dv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLdouble v[3];
 bp = egl_buff;
 memcpy(v,bp,sizeof(GLdouble)*3); bp += sizeof(GLdouble)*3; 
 esdl_glWindowPos3dv(v);

}

//typedef void (APIENTRY * PFNGLWINDOWPOS3FVPROC)( const GLfloat * v);
PFNGLWINDOWPOS3FVPROC esdl_glWindowPos3fv = NULL;
void egl_windowPos3fv(sdl_data *, int, char *);
sdl_fun esdl_load_glWindowPos3fv()
{
 esdl_glWindowPos3fv = (PFNGLWINDOWPOS3FVPROC) SDL_GL_GetProcAddress("glWindowPos3fv");
 if(NULL != esdl_glWindowPos3fv )
   return (sdl_fun) egl_windowPos3fv; 
 else return NULL; 
}

void egl_windowPos3fv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLfloat * v;
 bp = egl_buff;
 v = (GLfloat *) bp; bp += sizeof(GLfloat)*3; 
 esdl_glWindowPos3fv(v);

}

//typedef void (APIENTRY * PFNGLWINDOWPOS3IVPROC)( const GLint * v);
PFNGLWINDOWPOS3IVPROC esdl_glWindowPos3iv = NULL;
void egl_windowPos3iv(sdl_data *, int, char *);
sdl_fun esdl_load_glWindowPos3iv()
{
 esdl_glWindowPos3iv = (PFNGLWINDOWPOS3IVPROC) SDL_GL_GetProcAddress("glWindowPos3iv");
 if(NULL != esdl_glWindowPos3iv )
   return (sdl_fun) egl_windowPos3iv; 
 else return NULL; 
}

void egl_windowPos3iv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * v;
 bp = egl_buff;
 v = (GLint *) bp; bp += sizeof(GLint)*3; 
 esdl_glWindowPos3iv(v);

}

//typedef void (APIENTRY * PFNGLWINDOWPOS3SVPROC)( const GLshort * v);
PFNGLWINDOWPOS3SVPROC esdl_glWindowPos3sv = NULL;
void egl_windowPos3sv(sdl_data *, int, char *);
sdl_fun esdl_load_glWindowPos3sv()
{
 esdl_glWindowPos3sv = (PFNGLWINDOWPOS3SVPROC) SDL_GL_GetProcAddress("glWindowPos3sv");
 if(NULL != esdl_glWindowPos3sv )
   return (sdl_fun) egl_windowPos3sv; 
 else return NULL; 
}

void egl_windowPos3sv(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLshort * v;
 bp = egl_buff;
 v = (GLshort *) bp; bp += sizeof(GLshort)*3; 
 esdl_glWindowPos3sv(v);

}

//typedef void (APIENTRY * PFNGLWEIGHTBVARBPROC)(GLint size,  const GLbyte * weights);
PFNGLWEIGHTBVARBPROC esdl_glWeightbvARB = NULL;
void egl_weightbvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glWeightbvARB()
{
 esdl_glWeightbvARB = (PFNGLWEIGHTBVARBPROC) SDL_GL_GetProcAddress("glWeightbvARB");
 if(NULL != esdl_glWeightbvARB )
   return (sdl_fun) egl_weightbvARB; 
 else return NULL; 
}

void egl_weightbvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * size;
 GLbyte * weights = NULL; int * weightsLen;
 bp = egl_buff;
 size = (GLint *) bp; bp += sizeof(GLint); 
 weightsLen = size;
 weights = (GLbyte *) bp; bp += sizeof(GLbyte)*(*weightsLen); 
 esdl_glWeightbvARB(*size, weights);

}

//typedef void (APIENTRY * PFNGLWEIGHTSVARBPROC)(GLint size,  const GLshort * weights);
PFNGLWEIGHTSVARBPROC esdl_glWeightsvARB = NULL;
void egl_weightsvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glWeightsvARB()
{
 esdl_glWeightsvARB = (PFNGLWEIGHTSVARBPROC) SDL_GL_GetProcAddress("glWeightsvARB");
 if(NULL != esdl_glWeightsvARB )
   return (sdl_fun) egl_weightsvARB; 
 else return NULL; 
}

void egl_weightsvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * size;
 GLshort * weights = NULL; int * weightsLen;
 bp = egl_buff;
 size = (GLint *) bp; bp += sizeof(GLint); 
 weightsLen = size;
 weights = (GLshort *) bp; bp += sizeof(GLshort)*(*weightsLen); 
 esdl_glWeightsvARB(*size, weights);

}

//typedef void (APIENTRY * PFNGLWEIGHTIVARBPROC)(GLint size,  const GLint * weights);
PFNGLWEIGHTIVARBPROC esdl_glWeightivARB = NULL;
void egl_weightivARB(sdl_data *, int, char *);
sdl_fun esdl_load_glWeightivARB()
{
 esdl_glWeightivARB = (PFNGLWEIGHTIVARBPROC) SDL_GL_GetProcAddress("glWeightivARB");
 if(NULL != esdl_glWeightivARB )
   return (sdl_fun) egl_weightivARB; 
 else return NULL; 
}

void egl_weightivARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * size;
 GLint * weights = NULL; int * weightsLen;
 bp = egl_buff;
 size = (GLint *) bp; bp += sizeof(GLint); 
 weightsLen = size;
 weights = (GLint *) bp; bp += sizeof(GLint)*(*weightsLen); 
 esdl_glWeightivARB(*size, weights);

}

//typedef void (APIENTRY * PFNGLWEIGHTFVARBPROC)(GLint size,  const GLfloat * weights);
PFNGLWEIGHTFVARBPROC esdl_glWeightfvARB = NULL;
void egl_weightfvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glWeightfvARB()
{
 esdl_glWeightfvARB = (PFNGLWEIGHTFVARBPROC) SDL_GL_GetProcAddress("glWeightfvARB");
 if(NULL != esdl_glWeightfvARB )
   return (sdl_fun) egl_weightfvARB; 
 else return NULL; 
}

void egl_weightfvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * size;
 GLfloat * weights = NULL; int * weightsLen;
 bp = egl_buff;
 size = (GLint *) bp; bp += sizeof(GLint); 
 weightsLen = size;
 weights = (GLfloat *) bp; bp += sizeof(GLfloat)*(*weightsLen); 
 esdl_glWeightfvARB(*size, weights);

}

//typedef void (APIENTRY * PFNGLWEIGHTDVARBPROC)(GLint size,  const GLdouble * weights);
PFNGLWEIGHTDVARBPROC esdl_glWeightdvARB = NULL;
void egl_weightdvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glWeightdvARB()
{
 esdl_glWeightdvARB = (PFNGLWEIGHTDVARBPROC) SDL_GL_GetProcAddress("glWeightdvARB");
 if(NULL != esdl_glWeightdvARB )
   return (sdl_fun) egl_weightdvARB; 
 else return NULL; 
}

void egl_weightdvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * size;
 GLdouble * weights = NULL; int * weightsLen;
 bp = egl_buff;
 size = (GLint *) bp; bp += sizeof(GLint); 
 weightsLen = size;
 weights = (GLdouble*) malloc(sizeof(GLdouble)*(*weightsLen));
 memcpy(weights,bp,sizeof(GLdouble)*(*weightsLen));
 bp += sizeof(GLdouble)*(*weightsLen); 
 esdl_glWeightdvARB(*size, weights);
 free(weights);

}

//typedef void (APIENTRY * PFNGLWEIGHTUBVARBPROC)(GLint size,  const GLubyte * weights);
PFNGLWEIGHTUBVARBPROC esdl_glWeightubvARB = NULL;
void egl_weightubvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glWeightubvARB()
{
 esdl_glWeightubvARB = (PFNGLWEIGHTUBVARBPROC) SDL_GL_GetProcAddress("glWeightubvARB");
 if(NULL != esdl_glWeightubvARB )
   return (sdl_fun) egl_weightubvARB; 
 else return NULL; 
}

void egl_weightubvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * size;
 GLubyte * weights = NULL; int * weightsLen;
 bp = egl_buff;
 size = (GLint *) bp; bp += sizeof(GLint); 
 weightsLen = size;
 weights = (GLubyte *) bp; bp += sizeof(GLubyte)*(*weightsLen); 
 esdl_glWeightubvARB(*size, weights);

}

//typedef void (APIENTRY * PFNGLWEIGHTUSVARBPROC)(GLint size,  const GLushort * weights);
PFNGLWEIGHTUSVARBPROC esdl_glWeightusvARB = NULL;
void egl_weightusvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glWeightusvARB()
{
 esdl_glWeightusvARB = (PFNGLWEIGHTUSVARBPROC) SDL_GL_GetProcAddress("glWeightusvARB");
 if(NULL != esdl_glWeightusvARB )
   return (sdl_fun) egl_weightusvARB; 
 else return NULL; 
}

void egl_weightusvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * size;
 GLushort * weights = NULL; int * weightsLen;
 bp = egl_buff;
 size = (GLint *) bp; bp += sizeof(GLint); 
 weightsLen = size;
 weights = (GLushort *) bp; bp += sizeof(GLushort)*(*weightsLen); 
 esdl_glWeightusvARB(*size, weights);

}

//typedef void (APIENTRY * PFNGLWEIGHTUIVARBPROC)(GLint size,  const GLuint * weights);
PFNGLWEIGHTUIVARBPROC esdl_glWeightuivARB = NULL;
void egl_weightuivARB(sdl_data *, int, char *);
sdl_fun esdl_load_glWeightuivARB()
{
 esdl_glWeightuivARB = (PFNGLWEIGHTUIVARBPROC) SDL_GL_GetProcAddress("glWeightuivARB");
 if(NULL != esdl_glWeightuivARB )
   return (sdl_fun) egl_weightuivARB; 
 else return NULL; 
}

void egl_weightuivARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * size;
 GLuint * weights = NULL; int * weightsLen;
 bp = egl_buff;
 size = (GLint *) bp; bp += sizeof(GLint); 
 weightsLen = size;
 weights = (GLuint *) bp; bp += sizeof(GLuint)*(*weightsLen); 
 esdl_glWeightuivARB(*size, weights);

}

//typedef void (APIENTRY * PFNGLWEIGHTPOINTERARBPROC)(GLint size, GLenum type, GLsizei stride,  const GLvoid * pointer);
PFNGLWEIGHTPOINTERARBPROC esdl_glWeightPointerARB = NULL;
void egl_weightPointerARB(sdl_data *, int, char *);
sdl_fun esdl_load_glWeightPointerARB()
{
 esdl_glWeightPointerARB = (PFNGLWEIGHTPOINTERARBPROC) SDL_GL_GetProcAddress("glWeightPointerARB");
 if(NULL != esdl_glWeightPointerARB )
   return (sdl_fun) egl_weightPointerARB; 
 else return NULL; 
}

void egl_weightPointerARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * size;
 GLenum * type;
 GLsizei * stride;
 int * pointerMemT = 0;
 int * pointerLen = 0;
 GLvoid * pointer = NULL;
 bp = egl_buff;
 size = (GLint *) bp; bp += sizeof(GLint); 
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 stride = (GLsizei *) bp; bp += sizeof(GLsizei); 
 pointerMemT = (int *)bp; bp += sizeof(int);
 if(*pointerMemT == 1) {
  pointer = (GLvoid *) getPointer(bp);
  pointer = usePointer((oglmem *)pointer);} else {
  pointerLen = (int *)bp; bp += sizeof(int); 
  pointer = (GLvoid *) bp; bp += *pointerLen;};
 esdl_glWeightPointerARB(*size, *type, *stride, pointer);

}

//typedef void (APIENTRY * PFNGLVERTEXBLENDARBPROC)(GLint count);
PFNGLVERTEXBLENDARBPROC esdl_glVertexBlendARB = NULL;
void egl_vertexBlendARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexBlendARB()
{
 esdl_glVertexBlendARB = (PFNGLVERTEXBLENDARBPROC) SDL_GL_GetProcAddress("glVertexBlendARB");
 if(NULL != esdl_glVertexBlendARB )
   return (sdl_fun) egl_vertexBlendARB; 
 else return NULL; 
}

void egl_vertexBlendARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * count;
 bp = egl_buff;
 count = (GLint *) bp; bp += sizeof(GLint); 
 esdl_glVertexBlendARB(*count);

}

//typedef void (APIENTRY * PFNGLCURRENTPALETTEMATRIXARBPROC)(GLint index);
PFNGLCURRENTPALETTEMATRIXARBPROC esdl_glCurrentPaletteMatrixARB = NULL;
void egl_currentPaletteMatrixARB(sdl_data *, int, char *);
sdl_fun esdl_load_glCurrentPaletteMatrixARB()
{
 esdl_glCurrentPaletteMatrixARB = (PFNGLCURRENTPALETTEMATRIXARBPROC) SDL_GL_GetProcAddress("glCurrentPaletteMatrixARB");
 if(NULL != esdl_glCurrentPaletteMatrixARB )
   return (sdl_fun) egl_currentPaletteMatrixARB; 
 else return NULL; 
}

void egl_currentPaletteMatrixARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * index;
 bp = egl_buff;
 index = (GLint *) bp; bp += sizeof(GLint); 
 esdl_glCurrentPaletteMatrixARB(*index);

}

//typedef void (APIENTRY * PFNGLMATRIXINDEXUBVARBPROC)(GLint size,  const GLubyte * indices);
PFNGLMATRIXINDEXUBVARBPROC esdl_glMatrixIndexubvARB = NULL;
void egl_matrixIndexubvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glMatrixIndexubvARB()
{
 esdl_glMatrixIndexubvARB = (PFNGLMATRIXINDEXUBVARBPROC) SDL_GL_GetProcAddress("glMatrixIndexubvARB");
 if(NULL != esdl_glMatrixIndexubvARB )
   return (sdl_fun) egl_matrixIndexubvARB; 
 else return NULL; 
}

void egl_matrixIndexubvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * size;
 GLubyte * indices = NULL; int * indicesLen;
 bp = egl_buff;
 size = (GLint *) bp; bp += sizeof(GLint); 
 indicesLen = size;
 indices = (GLubyte *) bp; bp += sizeof(GLubyte)*(*indicesLen); 
 esdl_glMatrixIndexubvARB(*size, indices);

}

//typedef void (APIENTRY * PFNGLMATRIXINDEXUSVARBPROC)(GLint size,  const GLushort * indices);
PFNGLMATRIXINDEXUSVARBPROC esdl_glMatrixIndexusvARB = NULL;
void egl_matrixIndexusvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glMatrixIndexusvARB()
{
 esdl_glMatrixIndexusvARB = (PFNGLMATRIXINDEXUSVARBPROC) SDL_GL_GetProcAddress("glMatrixIndexusvARB");
 if(NULL != esdl_glMatrixIndexusvARB )
   return (sdl_fun) egl_matrixIndexusvARB; 
 else return NULL; 
}

void egl_matrixIndexusvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * size;
 GLushort * indices = NULL; int * indicesLen;
 bp = egl_buff;
 size = (GLint *) bp; bp += sizeof(GLint); 
 indicesLen = size;
 indices = (GLushort *) bp; bp += sizeof(GLushort)*(*indicesLen); 
 esdl_glMatrixIndexusvARB(*size, indices);

}

//typedef void (APIENTRY * PFNGLMATRIXINDEXUIVARBPROC)(GLint size,  const GLuint * indices);
PFNGLMATRIXINDEXUIVARBPROC esdl_glMatrixIndexuivARB = NULL;
void egl_matrixIndexuivARB(sdl_data *, int, char *);
sdl_fun esdl_load_glMatrixIndexuivARB()
{
 esdl_glMatrixIndexuivARB = (PFNGLMATRIXINDEXUIVARBPROC) SDL_GL_GetProcAddress("glMatrixIndexuivARB");
 if(NULL != esdl_glMatrixIndexuivARB )
   return (sdl_fun) egl_matrixIndexuivARB; 
 else return NULL; 
}

void egl_matrixIndexuivARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * size;
 GLuint * indices = NULL; int * indicesLen;
 bp = egl_buff;
 size = (GLint *) bp; bp += sizeof(GLint); 
 indicesLen = size;
 indices = (GLuint *) bp; bp += sizeof(GLuint)*(*indicesLen); 
 esdl_glMatrixIndexuivARB(*size, indices);

}

//typedef void (APIENTRY * PFNGLMATRIXINDEXPOINTERARBPROC)(GLint size, GLenum type, GLsizei stride,  const GLvoid * pointer);
PFNGLMATRIXINDEXPOINTERARBPROC esdl_glMatrixIndexPointerARB = NULL;
void egl_matrixIndexPointerARB(sdl_data *, int, char *);
sdl_fun esdl_load_glMatrixIndexPointerARB()
{
 esdl_glMatrixIndexPointerARB = (PFNGLMATRIXINDEXPOINTERARBPROC) SDL_GL_GetProcAddress("glMatrixIndexPointerARB");
 if(NULL != esdl_glMatrixIndexPointerARB )
   return (sdl_fun) egl_matrixIndexPointerARB; 
 else return NULL; 
}

void egl_matrixIndexPointerARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLint * size;
 GLenum * type;
 GLsizei * stride;
 int * pointerMemT = 0;
 int * pointerLen = 0;
 GLvoid * pointer = NULL;
 bp = egl_buff;
 size = (GLint *) bp; bp += sizeof(GLint); 
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 stride = (GLsizei *) bp; bp += sizeof(GLsizei); 
 pointerMemT = (int *)bp; bp += sizeof(int);
 if(*pointerMemT == 1) {
  pointer = (GLvoid *) getPointer(bp);
  pointer = usePointer((oglmem *)pointer);} else {
  pointerLen = (int *)bp; bp += sizeof(int); 
  pointer = (GLvoid *) bp; bp += *pointerLen;};
 esdl_glMatrixIndexPointerARB(*size, *type, *stride, pointer);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB1DVARBPROC)(GLuint index,  const GLdouble * v);
PFNGLVERTEXATTRIB1DVARBPROC esdl_glVertexAttrib1dvARB = NULL;
void egl_vertexAttrib1dvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib1dvARB()
{
 esdl_glVertexAttrib1dvARB = (PFNGLVERTEXATTRIB1DVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib1dvARB");
 if(NULL != esdl_glVertexAttrib1dvARB )
   return (sdl_fun) egl_vertexAttrib1dvARB; 
 else return NULL; 
}

void egl_vertexAttrib1dvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLdouble v[1];
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 memcpy(v,bp,sizeof(GLdouble)*1); bp += sizeof(GLdouble)*1; 
 esdl_glVertexAttrib1dvARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB1FVARBPROC)(GLuint index,  const GLfloat * v);
PFNGLVERTEXATTRIB1FVARBPROC esdl_glVertexAttrib1fvARB = NULL;
void egl_vertexAttrib1fvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib1fvARB()
{
 esdl_glVertexAttrib1fvARB = (PFNGLVERTEXATTRIB1FVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib1fvARB");
 if(NULL != esdl_glVertexAttrib1fvARB )
   return (sdl_fun) egl_vertexAttrib1fvARB; 
 else return NULL; 
}

void egl_vertexAttrib1fvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLfloat * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLfloat *) bp; bp += sizeof(GLfloat)*1; 
 esdl_glVertexAttrib1fvARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB1SVARBPROC)(GLuint index,  const GLshort * v);
PFNGLVERTEXATTRIB1SVARBPROC esdl_glVertexAttrib1svARB = NULL;
void egl_vertexAttrib1svARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib1svARB()
{
 esdl_glVertexAttrib1svARB = (PFNGLVERTEXATTRIB1SVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib1svARB");
 if(NULL != esdl_glVertexAttrib1svARB )
   return (sdl_fun) egl_vertexAttrib1svARB; 
 else return NULL; 
}

void egl_vertexAttrib1svARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLshort * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLshort *) bp; bp += sizeof(GLshort)*1; 
 esdl_glVertexAttrib1svARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB2DVARBPROC)(GLuint index,  const GLdouble * v);
PFNGLVERTEXATTRIB2DVARBPROC esdl_glVertexAttrib2dvARB = NULL;
void egl_vertexAttrib2dvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib2dvARB()
{
 esdl_glVertexAttrib2dvARB = (PFNGLVERTEXATTRIB2DVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib2dvARB");
 if(NULL != esdl_glVertexAttrib2dvARB )
   return (sdl_fun) egl_vertexAttrib2dvARB; 
 else return NULL; 
}

void egl_vertexAttrib2dvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLdouble v[2];
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 memcpy(v,bp,sizeof(GLdouble)*2); bp += sizeof(GLdouble)*2; 
 esdl_glVertexAttrib2dvARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB2FVARBPROC)(GLuint index,  const GLfloat * v);
PFNGLVERTEXATTRIB2FVARBPROC esdl_glVertexAttrib2fvARB = NULL;
void egl_vertexAttrib2fvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib2fvARB()
{
 esdl_glVertexAttrib2fvARB = (PFNGLVERTEXATTRIB2FVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib2fvARB");
 if(NULL != esdl_glVertexAttrib2fvARB )
   return (sdl_fun) egl_vertexAttrib2fvARB; 
 else return NULL; 
}

void egl_vertexAttrib2fvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLfloat * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLfloat *) bp; bp += sizeof(GLfloat)*2; 
 esdl_glVertexAttrib2fvARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB2SVARBPROC)(GLuint index,  const GLshort * v);
PFNGLVERTEXATTRIB2SVARBPROC esdl_glVertexAttrib2svARB = NULL;
void egl_vertexAttrib2svARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib2svARB()
{
 esdl_glVertexAttrib2svARB = (PFNGLVERTEXATTRIB2SVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib2svARB");
 if(NULL != esdl_glVertexAttrib2svARB )
   return (sdl_fun) egl_vertexAttrib2svARB; 
 else return NULL; 
}

void egl_vertexAttrib2svARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLshort * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLshort *) bp; bp += sizeof(GLshort)*2; 
 esdl_glVertexAttrib2svARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB3DVARBPROC)(GLuint index,  const GLdouble * v);
PFNGLVERTEXATTRIB3DVARBPROC esdl_glVertexAttrib3dvARB = NULL;
void egl_vertexAttrib3dvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib3dvARB()
{
 esdl_glVertexAttrib3dvARB = (PFNGLVERTEXATTRIB3DVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib3dvARB");
 if(NULL != esdl_glVertexAttrib3dvARB )
   return (sdl_fun) egl_vertexAttrib3dvARB; 
 else return NULL; 
}

void egl_vertexAttrib3dvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLdouble v[3];
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 memcpy(v,bp,sizeof(GLdouble)*3); bp += sizeof(GLdouble)*3; 
 esdl_glVertexAttrib3dvARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB3FVARBPROC)(GLuint index,  const GLfloat * v);
PFNGLVERTEXATTRIB3FVARBPROC esdl_glVertexAttrib3fvARB = NULL;
void egl_vertexAttrib3fvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib3fvARB()
{
 esdl_glVertexAttrib3fvARB = (PFNGLVERTEXATTRIB3FVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib3fvARB");
 if(NULL != esdl_glVertexAttrib3fvARB )
   return (sdl_fun) egl_vertexAttrib3fvARB; 
 else return NULL; 
}

void egl_vertexAttrib3fvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLfloat * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLfloat *) bp; bp += sizeof(GLfloat)*3; 
 esdl_glVertexAttrib3fvARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB3SVARBPROC)(GLuint index,  const GLshort * v);
PFNGLVERTEXATTRIB3SVARBPROC esdl_glVertexAttrib3svARB = NULL;
void egl_vertexAttrib3svARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib3svARB()
{
 esdl_glVertexAttrib3svARB = (PFNGLVERTEXATTRIB3SVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib3svARB");
 if(NULL != esdl_glVertexAttrib3svARB )
   return (sdl_fun) egl_vertexAttrib3svARB; 
 else return NULL; 
}

void egl_vertexAttrib3svARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLshort * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLshort *) bp; bp += sizeof(GLshort)*3; 
 esdl_glVertexAttrib3svARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB4NBVARBPROC)(GLuint index,  const GLbyte * v);
PFNGLVERTEXATTRIB4NBVARBPROC esdl_glVertexAttrib4NbvARB = NULL;
void egl_vertexAttrib4NbvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib4NbvARB()
{
 esdl_glVertexAttrib4NbvARB = (PFNGLVERTEXATTRIB4NBVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib4NbvARB");
 if(NULL != esdl_glVertexAttrib4NbvARB )
   return (sdl_fun) egl_vertexAttrib4NbvARB; 
 else return NULL; 
}

void egl_vertexAttrib4NbvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLbyte * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLbyte *) bp; bp += sizeof(GLbyte)*4; 
 esdl_glVertexAttrib4NbvARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB4NIVARBPROC)(GLuint index,  const GLint * v);
PFNGLVERTEXATTRIB4NIVARBPROC esdl_glVertexAttrib4NivARB = NULL;
void egl_vertexAttrib4NivARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib4NivARB()
{
 esdl_glVertexAttrib4NivARB = (PFNGLVERTEXATTRIB4NIVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib4NivARB");
 if(NULL != esdl_glVertexAttrib4NivARB )
   return (sdl_fun) egl_vertexAttrib4NivARB; 
 else return NULL; 
}

void egl_vertexAttrib4NivARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLint * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLint *) bp; bp += sizeof(GLint)*4; 
 esdl_glVertexAttrib4NivARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB4NSVARBPROC)(GLuint index,  const GLshort * v);
PFNGLVERTEXATTRIB4NSVARBPROC esdl_glVertexAttrib4NsvARB = NULL;
void egl_vertexAttrib4NsvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib4NsvARB()
{
 esdl_glVertexAttrib4NsvARB = (PFNGLVERTEXATTRIB4NSVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib4NsvARB");
 if(NULL != esdl_glVertexAttrib4NsvARB )
   return (sdl_fun) egl_vertexAttrib4NsvARB; 
 else return NULL; 
}

void egl_vertexAttrib4NsvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLshort * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLshort *) bp; bp += sizeof(GLshort)*4; 
 esdl_glVertexAttrib4NsvARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB4NUBARBPROC)(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);
PFNGLVERTEXATTRIB4NUBARBPROC esdl_glVertexAttrib4NubARB = NULL;
void egl_vertexAttrib4NubARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib4NubARB()
{
 esdl_glVertexAttrib4NubARB = (PFNGLVERTEXATTRIB4NUBARBPROC) SDL_GL_GetProcAddress("glVertexAttrib4NubARB");
 if(NULL != esdl_glVertexAttrib4NubARB )
   return (sdl_fun) egl_vertexAttrib4NubARB; 
 else return NULL; 
}

void egl_vertexAttrib4NubARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLubyte * x;
 GLubyte * y;
 GLubyte * z;
 GLubyte * w;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 x = (GLubyte *) bp; bp += sizeof(GLubyte); 
 y = (GLubyte *) bp; bp += sizeof(GLubyte); 
 z = (GLubyte *) bp; bp += sizeof(GLubyte); 
 w = (GLubyte *) bp; bp += sizeof(GLubyte); 
 esdl_glVertexAttrib4NubARB(*index, *x, *y, *z, *w);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB4NUBVARBPROC)(GLuint index,  const GLubyte * v);
PFNGLVERTEXATTRIB4NUBVARBPROC esdl_glVertexAttrib4NubvARB = NULL;
void egl_vertexAttrib4NubvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib4NubvARB()
{
 esdl_glVertexAttrib4NubvARB = (PFNGLVERTEXATTRIB4NUBVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib4NubvARB");
 if(NULL != esdl_glVertexAttrib4NubvARB )
   return (sdl_fun) egl_vertexAttrib4NubvARB; 
 else return NULL; 
}

void egl_vertexAttrib4NubvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLubyte * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLubyte *) bp; bp += sizeof(GLubyte)*4; 
 esdl_glVertexAttrib4NubvARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB4NUIVARBPROC)(GLuint index,  const GLuint * v);
PFNGLVERTEXATTRIB4NUIVARBPROC esdl_glVertexAttrib4NuivARB = NULL;
void egl_vertexAttrib4NuivARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib4NuivARB()
{
 esdl_glVertexAttrib4NuivARB = (PFNGLVERTEXATTRIB4NUIVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib4NuivARB");
 if(NULL != esdl_glVertexAttrib4NuivARB )
   return (sdl_fun) egl_vertexAttrib4NuivARB; 
 else return NULL; 
}

void egl_vertexAttrib4NuivARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLuint * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLuint *) bp; bp += sizeof(GLuint)*4; 
 esdl_glVertexAttrib4NuivARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB4NUSVARBPROC)(GLuint index,  const GLushort * v);
PFNGLVERTEXATTRIB4NUSVARBPROC esdl_glVertexAttrib4NusvARB = NULL;
void egl_vertexAttrib4NusvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib4NusvARB()
{
 esdl_glVertexAttrib4NusvARB = (PFNGLVERTEXATTRIB4NUSVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib4NusvARB");
 if(NULL != esdl_glVertexAttrib4NusvARB )
   return (sdl_fun) egl_vertexAttrib4NusvARB; 
 else return NULL; 
}

void egl_vertexAttrib4NusvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLushort * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLushort *) bp; bp += sizeof(GLushort)*4; 
 esdl_glVertexAttrib4NusvARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB4BVARBPROC)(GLuint index,  const GLbyte * v);
PFNGLVERTEXATTRIB4BVARBPROC esdl_glVertexAttrib4bvARB = NULL;
void egl_vertexAttrib4bvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib4bvARB()
{
 esdl_glVertexAttrib4bvARB = (PFNGLVERTEXATTRIB4BVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib4bvARB");
 if(NULL != esdl_glVertexAttrib4bvARB )
   return (sdl_fun) egl_vertexAttrib4bvARB; 
 else return NULL; 
}

void egl_vertexAttrib4bvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLbyte * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLbyte *) bp; bp += sizeof(GLbyte)*4; 
 esdl_glVertexAttrib4bvARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB4DVARBPROC)(GLuint index,  const GLdouble * v);
PFNGLVERTEXATTRIB4DVARBPROC esdl_glVertexAttrib4dvARB = NULL;
void egl_vertexAttrib4dvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib4dvARB()
{
 esdl_glVertexAttrib4dvARB = (PFNGLVERTEXATTRIB4DVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib4dvARB");
 if(NULL != esdl_glVertexAttrib4dvARB )
   return (sdl_fun) egl_vertexAttrib4dvARB; 
 else return NULL; 
}

void egl_vertexAttrib4dvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLdouble v[4];
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 memcpy(v,bp,sizeof(GLdouble)*4); bp += sizeof(GLdouble)*4; 
 esdl_glVertexAttrib4dvARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB4FVARBPROC)(GLuint index,  const GLfloat * v);
PFNGLVERTEXATTRIB4FVARBPROC esdl_glVertexAttrib4fvARB = NULL;
void egl_vertexAttrib4fvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib4fvARB()
{
 esdl_glVertexAttrib4fvARB = (PFNGLVERTEXATTRIB4FVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib4fvARB");
 if(NULL != esdl_glVertexAttrib4fvARB )
   return (sdl_fun) egl_vertexAttrib4fvARB; 
 else return NULL; 
}

void egl_vertexAttrib4fvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLfloat * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLfloat *) bp; bp += sizeof(GLfloat)*4; 
 esdl_glVertexAttrib4fvARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB4IVARBPROC)(GLuint index,  const GLint * v);
PFNGLVERTEXATTRIB4IVARBPROC esdl_glVertexAttrib4ivARB = NULL;
void egl_vertexAttrib4ivARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib4ivARB()
{
 esdl_glVertexAttrib4ivARB = (PFNGLVERTEXATTRIB4IVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib4ivARB");
 if(NULL != esdl_glVertexAttrib4ivARB )
   return (sdl_fun) egl_vertexAttrib4ivARB; 
 else return NULL; 
}

void egl_vertexAttrib4ivARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLint * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLint *) bp; bp += sizeof(GLint)*4; 
 esdl_glVertexAttrib4ivARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB4SVARBPROC)(GLuint index,  const GLshort * v);
PFNGLVERTEXATTRIB4SVARBPROC esdl_glVertexAttrib4svARB = NULL;
void egl_vertexAttrib4svARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib4svARB()
{
 esdl_glVertexAttrib4svARB = (PFNGLVERTEXATTRIB4SVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib4svARB");
 if(NULL != esdl_glVertexAttrib4svARB )
   return (sdl_fun) egl_vertexAttrib4svARB; 
 else return NULL; 
}

void egl_vertexAttrib4svARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLshort * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLshort *) bp; bp += sizeof(GLshort)*4; 
 esdl_glVertexAttrib4svARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB4UBVARBPROC)(GLuint index,  const GLubyte * v);
PFNGLVERTEXATTRIB4UBVARBPROC esdl_glVertexAttrib4ubvARB = NULL;
void egl_vertexAttrib4ubvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib4ubvARB()
{
 esdl_glVertexAttrib4ubvARB = (PFNGLVERTEXATTRIB4UBVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib4ubvARB");
 if(NULL != esdl_glVertexAttrib4ubvARB )
   return (sdl_fun) egl_vertexAttrib4ubvARB; 
 else return NULL; 
}

void egl_vertexAttrib4ubvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLubyte * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLubyte *) bp; bp += sizeof(GLubyte)*4; 
 esdl_glVertexAttrib4ubvARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB4UIVARBPROC)(GLuint index,  const GLuint * v);
PFNGLVERTEXATTRIB4UIVARBPROC esdl_glVertexAttrib4uivARB = NULL;
void egl_vertexAttrib4uivARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib4uivARB()
{
 esdl_glVertexAttrib4uivARB = (PFNGLVERTEXATTRIB4UIVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib4uivARB");
 if(NULL != esdl_glVertexAttrib4uivARB )
   return (sdl_fun) egl_vertexAttrib4uivARB; 
 else return NULL; 
}

void egl_vertexAttrib4uivARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLuint * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLuint *) bp; bp += sizeof(GLuint)*4; 
 esdl_glVertexAttrib4uivARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIB4USVARBPROC)(GLuint index,  const GLushort * v);
PFNGLVERTEXATTRIB4USVARBPROC esdl_glVertexAttrib4usvARB = NULL;
void egl_vertexAttrib4usvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttrib4usvARB()
{
 esdl_glVertexAttrib4usvARB = (PFNGLVERTEXATTRIB4USVARBPROC) SDL_GL_GetProcAddress("glVertexAttrib4usvARB");
 if(NULL != esdl_glVertexAttrib4usvARB )
   return (sdl_fun) egl_vertexAttrib4usvARB; 
 else return NULL; 
}

void egl_vertexAttrib4usvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLushort * v;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 v = (GLushort *) bp; bp += sizeof(GLushort)*4; 
 esdl_glVertexAttrib4usvARB(*index, v);

}

//typedef void (APIENTRY * PFNGLVERTEXATTRIBPOINTERARBPROC)(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride,  const GLvoid * pointer);
PFNGLVERTEXATTRIBPOINTERARBPROC esdl_glVertexAttribPointerARB = NULL;
void egl_vertexAttribPointerARB(sdl_data *, int, char *);
sdl_fun esdl_load_glVertexAttribPointerARB()
{
 esdl_glVertexAttribPointerARB = (PFNGLVERTEXATTRIBPOINTERARBPROC) SDL_GL_GetProcAddress("glVertexAttribPointerARB");
 if(NULL != esdl_glVertexAttribPointerARB )
   return (sdl_fun) egl_vertexAttribPointerARB; 
 else return NULL; 
}

void egl_vertexAttribPointerARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 GLint * size;
 GLenum * type;
 GLboolean * normalized;
 GLsizei * stride;
 int * pointerMemT = 0;
 int * pointerLen = 0;
 GLvoid * pointer = NULL;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 size = (GLint *) bp; bp += sizeof(GLint); 
 type = (GLenum *) bp; bp += sizeof(GLenum); 
 normalized = (GLboolean *) bp; bp += sizeof(GLboolean); 
bp += 1;
 stride = (GLsizei *) bp; bp += sizeof(GLsizei); 
bp += 2;
 pointerMemT = (int *)bp; bp += sizeof(int);
 if(*pointerMemT == 1) {
  pointer = (GLvoid *) getPointer(bp);
  pointer = usePointer((oglmem *)pointer);} else {
  pointerLen = (int *)bp; bp += sizeof(int); 
  pointer = (GLvoid *) bp; bp += *pointerLen;};
 esdl_glVertexAttribPointerARB(*index, *size, *type, *normalized, *stride, pointer);

}

//typedef void (APIENTRY * PFNGLENABLEVERTEXATTRIBARRAYARBPROC)(GLuint index);
PFNGLENABLEVERTEXATTRIBARRAYARBPROC esdl_glEnableVertexAttribArrayARB = NULL;
void egl_enableVertexAttribArrayARB(sdl_data *, int, char *);
sdl_fun esdl_load_glEnableVertexAttribArrayARB()
{
 esdl_glEnableVertexAttribArrayARB = (PFNGLENABLEVERTEXATTRIBARRAYARBPROC) SDL_GL_GetProcAddress("glEnableVertexAttribArrayARB");
 if(NULL != esdl_glEnableVertexAttribArrayARB )
   return (sdl_fun) egl_enableVertexAttribArrayARB; 
 else return NULL; 
}

void egl_enableVertexAttribArrayARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 esdl_glEnableVertexAttribArrayARB(*index);

}

//typedef void (APIENTRY * PFNGLDISABLEVERTEXATTRIBARRAYARBPROC)(GLuint index);
PFNGLDISABLEVERTEXATTRIBARRAYARBPROC esdl_glDisableVertexAttribArrayARB = NULL;
void egl_disableVertexAttribArrayARB(sdl_data *, int, char *);
sdl_fun esdl_load_glDisableVertexAttribArrayARB()
{
 esdl_glDisableVertexAttribArrayARB = (PFNGLDISABLEVERTEXATTRIBARRAYARBPROC) SDL_GL_GetProcAddress("glDisableVertexAttribArrayARB");
 if(NULL != esdl_glDisableVertexAttribArrayARB )
   return (sdl_fun) egl_disableVertexAttribArrayARB; 
 else return NULL; 
}

void egl_disableVertexAttribArrayARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLuint * index;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 esdl_glDisableVertexAttribArrayARB(*index);

}

//typedef void (APIENTRY * PFNGLPROGRAMSTRINGARBPROC)(GLenum target, GLenum format, GLsizei len,  const GLvoid * string);
PFNGLPROGRAMSTRINGARBPROC esdl_glProgramStringARB = NULL;
void egl_programStringARB(sdl_data *, int, char *);
sdl_fun esdl_load_glProgramStringARB()
{
 esdl_glProgramStringARB = (PFNGLPROGRAMSTRINGARBPROC) SDL_GL_GetProcAddress("glProgramStringARB");
 if(NULL != esdl_glProgramStringARB )
   return (sdl_fun) egl_programStringARB; 
 else return NULL; 
}

void egl_programStringARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * format;
 GLsizei * len;
 int * stringMemT = 0;
 int * stringLen = 0;
 GLvoid * string = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 format = (GLenum *) bp; bp += sizeof(GLenum); 
 len = (GLsizei *) bp; bp += sizeof(GLsizei); 
 stringMemT = (int *)bp; bp += sizeof(int);
 if(*stringMemT == 1) {
  string = (GLvoid *) getPointer(bp);
  string = usePointer((oglmem *)string);} else {
  stringLen = (int *)bp; bp += sizeof(int); 
  string = (GLvoid *) bp; bp += *stringLen;};
 esdl_glProgramStringARB(*target, *format, *len, string);

}

//typedef void (APIENTRY * PFNGLBINDPROGRAMARBPROC)(GLenum target, GLuint program);
PFNGLBINDPROGRAMARBPROC esdl_glBindProgramARB = NULL;
void egl_bindProgramARB(sdl_data *, int, char *);
sdl_fun esdl_load_glBindProgramARB()
{
 esdl_glBindProgramARB = (PFNGLBINDPROGRAMARBPROC) SDL_GL_GetProcAddress("glBindProgramARB");
 if(NULL != esdl_glBindProgramARB )
   return (sdl_fun) egl_bindProgramARB; 
 else return NULL; 
}

void egl_bindProgramARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLuint * program;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 program = (GLuint *) bp; bp += sizeof(GLuint); 
 esdl_glBindProgramARB(*target, *program);

}

//typedef void (APIENTRY * PFNGLDELETEPROGRAMSARBPROC)(GLsizei n,  const GLuint * programs);
PFNGLDELETEPROGRAMSARBPROC esdl_glDeleteProgramsARB = NULL;
void egl_deleteProgramsARB(sdl_data *, int, char *);
sdl_fun esdl_load_glDeleteProgramsARB()
{
 esdl_glDeleteProgramsARB = (PFNGLDELETEPROGRAMSARBPROC) SDL_GL_GetProcAddress("glDeleteProgramsARB");
 if(NULL != esdl_glDeleteProgramsARB )
   return (sdl_fun) egl_deleteProgramsARB; 
 else return NULL; 
}

void egl_deleteProgramsARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLsizei * n;
 GLuint * programs = NULL; int * programsLen;
 bp = egl_buff;
 n = (GLsizei *) bp; bp += sizeof(GLsizei); 
 programsLen = n;
 programs = (GLuint *) bp; bp += sizeof(GLuint)*(*programsLen); 
 esdl_glDeleteProgramsARB(*n, programs);

}

//typedef void (APIENTRY * PFNGLGENPROGRAMSARBPROC)(GLsizei n, GLuint * programs);
PFNGLGENPROGRAMSARBPROC esdl_glGenProgramsARB = NULL;
void egl_genProgramsARB(sdl_data *, int, char *);
sdl_fun esdl_load_glGenProgramsARB()
{
 esdl_glGenProgramsARB = (PFNGLGENPROGRAMSARBPROC) SDL_GL_GetProcAddress("glGenProgramsARB");
 if(NULL != esdl_glGenProgramsARB )
   return (sdl_fun) egl_genProgramsARB; 
 else return NULL; 
}

void egl_genProgramsARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLsizei * n;
 GLuint * programs = NULL; int *programsLen;
 bp = egl_buff;
 n = (GLsizei *) bp; bp += sizeof(GLsizei); 
 programsLen = n;
 programs = (GLuint*) malloc(sizeof(GLuint)*(*programsLen));
 esdl_glGenProgramsARB(*n, programs);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLuint) * (*programsLen), egl_buff);
 memcpy(bp, programs, sizeof(GLuint)*(*programsLen));
 bp += sizeof(GLuint)*(*programsLen);
 free(programs);
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

//typedef void (APIENTRY * PFNGLPROGRAMENVPARAMETER4DVARBPROC)(GLenum target, GLuint index,  const GLdouble * params);
PFNGLPROGRAMENVPARAMETER4DVARBPROC esdl_glProgramEnvParameter4dvARB = NULL;
void egl_programEnvParameter4dvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glProgramEnvParameter4dvARB()
{
 esdl_glProgramEnvParameter4dvARB = (PFNGLPROGRAMENVPARAMETER4DVARBPROC) SDL_GL_GetProcAddress("glProgramEnvParameter4dvARB");
 if(NULL != esdl_glProgramEnvParameter4dvARB )
   return (sdl_fun) egl_programEnvParameter4dvARB; 
 else return NULL; 
}

void egl_programEnvParameter4dvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLuint * index;
 GLdouble params[4];
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 memcpy(params,bp,sizeof(GLdouble)*4); bp += sizeof(GLdouble)*4; 
 esdl_glProgramEnvParameter4dvARB(*target, *index, params);

}

//typedef void (APIENTRY * PFNGLPROGRAMENVPARAMETER4FVARBPROC)(GLenum target, GLuint index,  const GLfloat * params);
PFNGLPROGRAMENVPARAMETER4FVARBPROC esdl_glProgramEnvParameter4fvARB = NULL;
void egl_programEnvParameter4fvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glProgramEnvParameter4fvARB()
{
 esdl_glProgramEnvParameter4fvARB = (PFNGLPROGRAMENVPARAMETER4FVARBPROC) SDL_GL_GetProcAddress("glProgramEnvParameter4fvARB");
 if(NULL != esdl_glProgramEnvParameter4fvARB )
   return (sdl_fun) egl_programEnvParameter4fvARB; 
 else return NULL; 
}

void egl_programEnvParameter4fvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLuint * index;
 GLfloat * params;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 params = (GLfloat *) bp; bp += sizeof(GLfloat)*4; 
 esdl_glProgramEnvParameter4fvARB(*target, *index, params);

}

//typedef void (APIENTRY * PFNGLPROGRAMLOCALPARAMETER4DVARBPROC)(GLenum target, GLuint index,  const GLdouble * params);
PFNGLPROGRAMLOCALPARAMETER4DVARBPROC esdl_glProgramLocalParameter4dvARB = NULL;
void egl_programLocalParameter4dvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glProgramLocalParameter4dvARB()
{
 esdl_glProgramLocalParameter4dvARB = (PFNGLPROGRAMLOCALPARAMETER4DVARBPROC) SDL_GL_GetProcAddress("glProgramLocalParameter4dvARB");
 if(NULL != esdl_glProgramLocalParameter4dvARB )
   return (sdl_fun) egl_programLocalParameter4dvARB; 
 else return NULL; 
}

void egl_programLocalParameter4dvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLuint * index;
 GLdouble params[4];
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 memcpy(params,bp,sizeof(GLdouble)*4); bp += sizeof(GLdouble)*4; 
 esdl_glProgramLocalParameter4dvARB(*target, *index, params);

}

//typedef void (APIENTRY * PFNGLPROGRAMLOCALPARAMETER4FVARBPROC)(GLenum target, GLuint index,  const GLfloat * params);
PFNGLPROGRAMLOCALPARAMETER4FVARBPROC esdl_glProgramLocalParameter4fvARB = NULL;
void egl_programLocalParameter4fvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glProgramLocalParameter4fvARB()
{
 esdl_glProgramLocalParameter4fvARB = (PFNGLPROGRAMLOCALPARAMETER4FVARBPROC) SDL_GL_GetProcAddress("glProgramLocalParameter4fvARB");
 if(NULL != esdl_glProgramLocalParameter4fvARB )
   return (sdl_fun) egl_programLocalParameter4fvARB; 
 else return NULL; 
}

void egl_programLocalParameter4fvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLuint * index;
 GLfloat * params;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 params = (GLfloat *) bp; bp += sizeof(GLfloat)*4; 
 esdl_glProgramLocalParameter4fvARB(*target, *index, params);

}

//typedef void (APIENTRY * PFNGLGETPROGRAMENVPARAMETERDVARBPROC)(GLenum target, GLuint index, GLdouble * params);
PFNGLGETPROGRAMENVPARAMETERDVARBPROC esdl_glGetProgramEnvParameterdvARB = NULL;
void egl_getProgramEnvParameterdvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glGetProgramEnvParameterdvARB()
{
 esdl_glGetProgramEnvParameterdvARB = (PFNGLGETPROGRAMENVPARAMETERDVARBPROC) SDL_GL_GetProcAddress("glGetProgramEnvParameterdvARB");
 if(NULL != esdl_glGetProgramEnvParameterdvARB )
   return (sdl_fun) egl_getProgramEnvParameterdvARB; 
 else return NULL; 
}

void egl_getProgramEnvParameterdvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLenum * target;
 GLuint * index;
 GLdouble params[4]; 
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 esdl_glGetProgramEnvParameterdvARB(*target, *index, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLdouble) *4, egl_buff);
 memcpy(bp, params, sizeof(GLdouble)*4);
 bp += sizeof(GLdouble)*4;
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

//typedef void (APIENTRY * PFNGLGETPROGRAMENVPARAMETERFVARBPROC)(GLenum target, GLuint index, GLfloat * params);
PFNGLGETPROGRAMENVPARAMETERFVARBPROC esdl_glGetProgramEnvParameterfvARB = NULL;
void egl_getProgramEnvParameterfvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glGetProgramEnvParameterfvARB()
{
 esdl_glGetProgramEnvParameterfvARB = (PFNGLGETPROGRAMENVPARAMETERFVARBPROC) SDL_GL_GetProcAddress("glGetProgramEnvParameterfvARB");
 if(NULL != esdl_glGetProgramEnvParameterfvARB )
   return (sdl_fun) egl_getProgramEnvParameterfvARB; 
 else return NULL; 
}

void egl_getProgramEnvParameterfvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLenum * target;
 GLuint * index;
 GLfloat params[4]; 
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 esdl_glGetProgramEnvParameterfvARB(*target, *index, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLfloat) *4, egl_buff);
 memcpy(bp, params, sizeof(GLfloat)*4);
 bp += sizeof(GLfloat)*4;
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

//typedef void (APIENTRY * PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC)(GLenum target, GLuint index, GLdouble * params);
PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC esdl_glGetProgramLocalParameterdvARB = NULL;
void egl_getProgramLocalParameterdvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glGetProgramLocalParameterdvARB()
{
 esdl_glGetProgramLocalParameterdvARB = (PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC) SDL_GL_GetProcAddress("glGetProgramLocalParameterdvARB");
 if(NULL != esdl_glGetProgramLocalParameterdvARB )
   return (sdl_fun) egl_getProgramLocalParameterdvARB; 
 else return NULL; 
}

void egl_getProgramLocalParameterdvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLenum * target;
 GLuint * index;
 GLdouble params[4]; 
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 esdl_glGetProgramLocalParameterdvARB(*target, *index, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLdouble) *4, egl_buff);
 memcpy(bp, params, sizeof(GLdouble)*4);
 bp += sizeof(GLdouble)*4;
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

//typedef void (APIENTRY * PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC)(GLenum target, GLuint index, GLfloat * params);
PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC esdl_glGetProgramLocalParameterfvARB = NULL;
void egl_getProgramLocalParameterfvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glGetProgramLocalParameterfvARB()
{
 esdl_glGetProgramLocalParameterfvARB = (PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC) SDL_GL_GetProcAddress("glGetProgramLocalParameterfvARB");
 if(NULL != esdl_glGetProgramLocalParameterfvARB )
   return (sdl_fun) egl_getProgramLocalParameterfvARB; 
 else return NULL; 
}

void egl_getProgramLocalParameterfvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLenum * target;
 GLuint * index;
 GLfloat params[4]; 
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 esdl_glGetProgramLocalParameterfvARB(*target, *index, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLfloat) *4, egl_buff);
 memcpy(bp, params, sizeof(GLfloat)*4);
 bp += sizeof(GLfloat)*4;
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

//typedef void (APIENTRY * PFNGLGETPROGRAMIVARBPROC)(GLenum target, GLenum pname, GLint * params);
PFNGLGETPROGRAMIVARBPROC esdl_glGetProgramivARB = NULL;
void egl_getProgramivARB(sdl_data *, int, char *);
sdl_fun esdl_load_glGetProgramivARB()
{
 esdl_glGetProgramivARB = (PFNGLGETPROGRAMIVARBPROC) SDL_GL_GetProcAddress("glGetProgramivARB");
 if(NULL != esdl_glGetProgramivARB )
   return (sdl_fun) egl_getProgramivARB; 
 else return NULL; 
}

void egl_getProgramivARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLenum * target;
 GLenum * pname;
 GLint params[1]; 
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glGetProgramivARB(*target, *pname, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLint) *1, egl_buff);
 * (GLint *)bp = params[0]; bp += sizeof(GLint);
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

//typedef void (APIENTRY * PFNGLGETPROGRAMSTRINGARBPROC)(GLenum target, GLenum pname, GLvoid * string);
PFNGLGETPROGRAMSTRINGARBPROC esdl_glGetProgramStringARB = NULL;
void egl_getProgramStringARB(sdl_data *, int, char *);
sdl_fun esdl_load_glGetProgramStringARB()
{
 esdl_glGetProgramStringARB = (PFNGLGETPROGRAMSTRINGARBPROC) SDL_GL_GetProcAddress("glGetProgramStringARB");
 if(NULL != esdl_glGetProgramStringARB )
   return (sdl_fun) egl_getProgramStringARB; 
 else return NULL; 
}

void egl_getProgramStringARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 GLenum * target;
 GLenum * pname;
 oglmem * string = NULL;
 bp = egl_buff;
 target = (GLenum *) bp; bp += sizeof(GLenum); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 string = getPointer(bp); 
 esdl_glGetProgramStringARB(*target, *pname, usePointer(string));

}

//typedef void (APIENTRY * PFNGLGETVERTEXATTRIBDVARBPROC)(GLuint index, GLenum pname, GLdouble * params);
PFNGLGETVERTEXATTRIBDVARBPROC esdl_glGetVertexAttribdvARB = NULL;
void egl_getVertexAttribdvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glGetVertexAttribdvARB()
{
 esdl_glGetVertexAttribdvARB = (PFNGLGETVERTEXATTRIBDVARBPROC) SDL_GL_GetProcAddress("glGetVertexAttribdvARB");
 if(NULL != esdl_glGetVertexAttribdvARB )
   return (sdl_fun) egl_getVertexAttribdvARB; 
 else return NULL; 
}

void egl_getVertexAttribdvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLuint * index;
 GLenum * pname;
 GLdouble params[4]; 
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glGetVertexAttribdvARB(*index, *pname, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLdouble) *4, egl_buff);
 memcpy(bp, params, sizeof(GLdouble)*4);
 bp += sizeof(GLdouble)*4;
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

//typedef void (APIENTRY * PFNGLGETVERTEXATTRIBFVARBPROC)(GLuint index, GLenum pname, GLfloat * params);
PFNGLGETVERTEXATTRIBFVARBPROC esdl_glGetVertexAttribfvARB = NULL;
void egl_getVertexAttribfvARB(sdl_data *, int, char *);
sdl_fun esdl_load_glGetVertexAttribfvARB()
{
 esdl_glGetVertexAttribfvARB = (PFNGLGETVERTEXATTRIBFVARBPROC) SDL_GL_GetProcAddress("glGetVertexAttribfvARB");
 if(NULL != esdl_glGetVertexAttribfvARB )
   return (sdl_fun) egl_getVertexAttribfvARB; 
 else return NULL; 
}

void egl_getVertexAttribfvARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLuint * index;
 GLenum * pname;
 GLfloat params[4]; 
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glGetVertexAttribfvARB(*index, *pname, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLfloat) *4, egl_buff);
 memcpy(bp, params, sizeof(GLfloat)*4);
 bp += sizeof(GLfloat)*4;
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

//typedef void (APIENTRY * PFNGLGETVERTEXATTRIBIVARBPROC)(GLuint index, GLenum pname, GLint * params);
PFNGLGETVERTEXATTRIBIVARBPROC esdl_glGetVertexAttribivARB = NULL;
void egl_getVertexAttribivARB(sdl_data *, int, char *);
sdl_fun esdl_load_glGetVertexAttribivARB()
{
 esdl_glGetVertexAttribivARB = (PFNGLGETVERTEXATTRIBIVARBPROC) SDL_GL_GetProcAddress("glGetVertexAttribivARB");
 if(NULL != esdl_glGetVertexAttribivARB )
   return (sdl_fun) egl_getVertexAttribivARB; 
 else return NULL; 
}

void egl_getVertexAttribivARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLuint * index;
 GLenum * pname;
 GLint params[4]; 
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glGetVertexAttribivARB(*index, *pname, params);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLint) *4, egl_buff);
 memcpy(bp, params, sizeof(GLint)*4);
 bp += sizeof(GLint)*4;
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

//typedef void (APIENTRY * PFNGLGETVERTEXATTRIBPOINTERVARBPROC)(GLuint index, GLenum pname,  GLvoid* *pointer);
PFNGLGETVERTEXATTRIBPOINTERVARBPROC esdl_glGetVertexAttribPointervARB = NULL;
void egl_getVertexAttribPointervARB(sdl_data *, int, char *);
sdl_fun esdl_load_glGetVertexAttribPointervARB()
{
 esdl_glGetVertexAttribPointervARB = (PFNGLGETVERTEXATTRIBPOINTERVARBPROC) SDL_GL_GetProcAddress("glGetVertexAttribPointervARB");
 if(NULL != esdl_glGetVertexAttribPointervARB )
   return (sdl_fun) egl_getVertexAttribPointervARB; 
 else return NULL; 
}

void egl_getVertexAttribPointervARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLuint * index;
 GLenum * pname;
 GLvoid *pointer = NULL;
 oglmem *pointerRef = NULL;
 bp = egl_buff;
 index = (GLuint *) bp; bp += sizeof(GLuint); 
 pname = (GLenum *) bp; bp += sizeof(GLenum); 
 esdl_glGetVertexAttribPointervARB(*index, *pname, &pointer);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLvoid*), egl_buff);
 pointerRef= (oglmem *) esdl_util_findPointer(egl_sd,pointer); putPointer(bp, pointerRef);
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

//typedef GLboolean (APIENTRY * PFNGLISPROGRAMARBPROC)(GLuint program);
PFNGLISPROGRAMARBPROC esdl_glIsProgramARB = NULL;
void egl_isProgramARB(sdl_data *, int, char *);
sdl_fun esdl_load_glIsProgramARB()
{
 esdl_glIsProgramARB = (PFNGLISPROGRAMARBPROC) SDL_GL_GetProcAddress("glIsProgramARB");
 if(NULL != esdl_glIsProgramARB )
   return (sdl_fun) egl_isProgramARB; 
 else return NULL; 
}

void egl_isProgramARB(sdl_data *egl_sd, int egl_len, char *egl_buff) 
{
 char * bp; 
 char * egl_start; 
 int egl_sendlen; 
 GLboolean egl_res; 
 GLuint * program;
 bp = egl_buff;
 program = (GLuint *) bp; bp += sizeof(GLuint); 
 egl_res =  esdl_glIsProgramARB(*program);
 bp = egl_start = sdl_getbuff(egl_sd, sizeof(GLboolean) , egl_buff);
 * (GLboolean *) bp = egl_res;
 bp += sizeof(GLboolean);
 egl_sendlen = bp - egl_start;
 sdl_send(egl_sd, egl_sendlen, egl_buff);

}

