%%  Copyright (c) 2001 Dan Gudmundsson
%%
%%  See the file "license.terms" for information on usage and redistribution
%%  of this file, and for a DISCLAIMER OF ALL WARRANTIES.
%% 
%%     $Id: gl.hrl,v 1.2 2001/11/22 15:09:11 dgud Exp $
%%
%/*  C type              GL type         storage                            */
%/*-------------------------------------------------------------------------*/
%typedef void            GLvoid;
%typedef unsigned char   GLboolean;
%typedef signed char     GLbyte;         /* 1-byte signed */
%typedef short           GLshort;        /* 2-byte signed */
%typedef int             GLint;          /* 4-byte signed */
%typedef unsigned char   GLubyte;        /* 1-byte unsigned */
%typedef unsigned short  GLushort;       /* 2-byte unsigned */
%typedef unsigned int    GLuint;         /* 4-byte unsigned */
%typedef int             GLsizei;        /* 4-byte signed */
%typedef float           GLfloat;        /* single precision float */
%typedef float           GLclampf;       /* single precision float in [0,1] */
%typedef double          GLdouble;       /* double precision float */
%typedef double          GLclampd;       /* double precision float in [0,1] */
%typedef unsigned int    GLbitfield;     /* 32 bits */

-define(GL_BYTE_SIZE, 8).
-define(GL_UNSIGNED_BYTE_SIZE, 8).
-define(GL_SHORT_SIZE, 16).
-define(GL_UNSIGNED_SHORT_SIZE, 16).
-define(GL_INT_SIZE, 32).
-define(GL_UNSIGNED_INT_SIZE, 32).
-define(GL_FLOAT_SIZE, 32).
-define(GL_DOUBLE_SIZE, 64).
-define(gl_type_size(TYPE), 
	case (TYPE) of 
	    ?GL_BYTE ->           ?GL_BYTE_SIZE;
	    ?GL_UNSIGNED_BYTE->   ?GL_UNSIGNED_BYTE_SIZE;
	    ?GL_SHORT ->          ?GL_SHORT_SIZE;
	    ?GL_UNSIGNED_SHORT -> ?GL_UNSIGNED_SHORT_SIZE;
	    ?GL_INT ->            ?GL_INT_SIZE;
	    ?GL_UNSIGNED_INT ->   ?GL_UNSIGNED_INT_SIZE;
	    ?GL_FLOAT ->          ?GL_FLOAT_SIZE;
	    ?GL_DOUBLE ->         ?GL_DOUBLE_SIZE
	end).		 
	    
% Boolean values 
-define(GL_FALSE, 0).
-define(GL_TRUE, 1).
% Data types 
-define(GL_BYTE, 16#1400).
-define(GL_UNSIGNED_BYTE, 16#1401).
-define(GL_SHORT, 16#1402).
-define(GL_UNSIGNED_SHORT, 16#1403).
-define(GL_INT, 16#1404).
-define(GL_UNSIGNED_INT, 16#1405).
-define(GL_FLOAT, 16#1406).
-define(GL_DOUBLE, 16#140A).
-define(GL_2_BYTES, 16#1407).
-define(GL_3_BYTES, 16#1408).
-define(GL_4_BYTES, 16#1409).
% Primitives 
-define(GL_POINTS, 16#0000).
-define(GL_LINES, 16#0001).
-define(GL_LINE_LOOP, 16#0002).
-define(GL_LINE_STRIP, 16#0003).
-define(GL_TRIANGLES, 16#0004).
-define(GL_TRIANGLE_STRIP, 16#0005).
-define(GL_TRIANGLE_FAN, 16#0006).
-define(GL_QUADS, 16#0007).
-define(GL_QUAD_STRIP, 16#0008).
-define(GL_POLYGON, 16#0009).
% Vertex Arrays 
-define(GL_VERTEX_ARRAY, 16#8074).
-define(GL_NORMAL_ARRAY, 16#8075).
-define(GL_COLOR_ARRAY, 16#8076).
-define(GL_INDEX_ARRAY, 16#8077).
-define(GL_TEXTURE_COORD_ARRAY, 16#8078).
-define(GL_EDGE_FLAG_ARRAY, 16#8079).
-define(GL_VERTEX_ARRAY_SIZE, 16#807A).
-define(GL_VERTEX_ARRAY_TYPE, 16#807B).
-define(GL_VERTEX_ARRAY_STRIDE, 16#807C).
-define(GL_NORMAL_ARRAY_TYPE, 16#807E).
-define(GL_NORMAL_ARRAY_STRIDE, 16#807F).
-define(GL_COLOR_ARRAY_SIZE, 16#8081).
-define(GL_COLOR_ARRAY_TYPE, 16#8082).
-define(GL_COLOR_ARRAY_STRIDE, 16#8083).
-define(GL_INDEX_ARRAY_TYPE, 16#8085).
-define(GL_INDEX_ARRAY_STRIDE, 16#8086).
-define(GL_TEXTURE_COORD_ARRAY_SIZE, 16#8088).
-define(GL_TEXTURE_COORD_ARRAY_TYPE, 16#8089).
-define(GL_TEXTURE_COORD_ARRAY_STRIDE, 16#808A).
-define(GL_EDGE_FLAG_ARRAY_STRIDE, 16#808C).
-define(GL_VERTEX_ARRAY_POINTER, 16#808E).
-define(GL_NORMAL_ARRAY_POINTER, 16#808F).
-define(GL_COLOR_ARRAY_POINTER, 16#8090).
-define(GL_INDEX_ARRAY_POINTER, 16#8091).
-define(GL_TEXTURE_COORD_ARRAY_POINTER, 16#8092).
-define(GL_EDGE_FLAG_ARRAY_POINTER, 16#8093).
-define(GL_V2F, 16#2A20).
-define(GL_V3F, 16#2A21).
-define(GL_C4UB_V2F, 16#2A22).
-define(GL_C4UB_V3F, 16#2A23).
-define(GL_C3F_V3F, 16#2A24).
-define(GL_N3F_V3F, 16#2A25).
-define(GL_C4F_N3F_V3F, 16#2A26).
-define(GL_T2F_V3F, 16#2A27).
-define(GL_T4F_V4F, 16#2A28).
-define(GL_T2F_C4UB_V3F, 16#2A29).
-define(GL_T2F_C3F_V3F, 16#2A2A).
-define(GL_T2F_N3F_V3F, 16#2A2B).
-define(GL_T2F_C4F_N3F_V3F, 16#2A2C).
-define(GL_T4F_C4F_N3F_V4F, 16#2A2D).
% Matrix Mode 
-define(GL_MATRIX_MODE, 16#0BA0).
-define(GL_MODELVIEW, 16#1700).
-define(GL_PROJECTION, 16#1701).
-define(GL_TEXTURE, 16#1702).
% Points 
-define(GL_POINT_SMOOTH, 16#0B10).
-define(GL_POINT_SIZE, 16#0B11).
-define(GL_POINT_SIZE_GRANULARITY, 16#0B13).
-define(GL_POINT_SIZE_RANGE, 16#0B12).
% Lines 
-define(GL_LINE_SMOOTH, 16#0B20).
-define(GL_LINE_STIPPLE, 16#0B24).
-define(GL_LINE_STIPPLE_PATTERN, 16#0B25).
-define(GL_LINE_STIPPLE_REPEAT, 16#0B26).
-define(GL_LINE_WIDTH, 16#0B21).
-define(GL_LINE_WIDTH_GRANULARITY, 16#0B23).
-define(GL_LINE_WIDTH_RANGE, 16#0B22).
% Polygons 
-define(GL_POINT, 16#1B00).
-define(GL_LINE, 16#1B01).
-define(GL_FILL, 16#1B02).
-define(GL_CW, 16#0900).
-define(GL_CCW, 16#0901).
-define(GL_FRONT, 16#0404).
-define(GL_BACK, 16#0405).
-define(GL_POLYGON_MODE, 16#0B40).
-define(GL_POLYGON_SMOOTH, 16#0B41).
-define(GL_POLYGON_STIPPLE, 16#0B42).
-define(GL_EDGE_FLAG, 16#0B43).
-define(GL_CULL_FACE, 16#0B44).
-define(GL_CULL_FACE_MODE, 16#0B45).
-define(GL_FRONT_FACE, 16#0B46).
-define(GL_POLYGON_OFFSET_FACTOR, 16#8038).
-define(GL_POLYGON_OFFSET_UNITS, 16#2A00).
-define(GL_POLYGON_OFFSET_POINT, 16#2A01).
-define(GL_POLYGON_OFFSET_LINE, 16#2A02).
-define(GL_POLYGON_OFFSET_FILL, 16#8037).
% Display Lists 
-define(GL_COMPILE, 16#1300).
-define(GL_COMPILE_AND_EXECUTE, 16#1301).
-define(GL_LIST_BASE, 16#0B32).
-define(GL_LIST_INDEX, 16#0B33).
-define(GL_LIST_MODE, 16#0B30).
% Depth buffer 
-define(GL_NEVER, 16#0200).
-define(GL_LESS, 16#0201).
-define(GL_GEQUAL, 16#0206).
-define(GL_LEQUAL, 16#0203).
-define(GL_GREATER, 16#0204).
-define(GL_NOTEQUAL, 16#0205).
-define(GL_EQUAL, 16#0202).
-define(GL_ALWAYS, 16#0207).
-define(GL_DEPTH_TEST, 16#0B71).
-define(GL_DEPTH_BITS, 16#0D56).
-define(GL_DEPTH_CLEAR_VALUE, 16#0B73).
-define(GL_DEPTH_FUNC, 16#0B74).
-define(GL_DEPTH_RANGE, 16#0B70).
-define(GL_DEPTH_WRITEMASK, 16#0B72).
-define(GL_DEPTH_COMPONENT, 16#1902).
% Lighting 
-define(GL_LIGHTING, 16#0B50).
-define(GL_LIGHT0, 16#4000).
-define(GL_LIGHT1, 16#4001).
-define(GL_LIGHT2, 16#4002).
-define(GL_LIGHT3, 16#4003).
-define(GL_LIGHT4, 16#4004).
-define(GL_LIGHT5, 16#4005).
-define(GL_LIGHT6, 16#4006).
-define(GL_LIGHT7, 16#4007).
-define(GL_SPOT_EXPONENT, 16#1205).
-define(GL_SPOT_CUTOFF, 16#1206).
-define(GL_CONSTANT_ATTENUATION, 16#1207).
-define(GL_LINEAR_ATTENUATION, 16#1208).
-define(GL_QUADRATIC_ATTENUATION, 16#1209).
-define(GL_AMBIENT, 16#1200).
-define(GL_DIFFUSE, 16#1201).
-define(GL_SPECULAR, 16#1202).
-define(GL_SHININESS, 16#1601).
-define(GL_EMISSION, 16#1600).
-define(GL_POSITION, 16#1203).
-define(GL_SPOT_DIRECTION, 16#1204).
-define(GL_AMBIENT_AND_DIFFUSE, 16#1602).
-define(GL_COLOR_INDEXES, 16#1603).
-define(GL_LIGHT_MODEL_TWO_SIDE, 16#0B52).
-define(GL_LIGHT_MODEL_LOCAL_VIEWER, 16#0B51).
-define(GL_LIGHT_MODEL_AMBIENT, 16#0B53).
-define(GL_FRONT_AND_BACK, 16#0408).
-define(GL_SHADE_MODEL, 16#0B54).
-define(GL_FLAT, 16#1D00).
-define(GL_SMOOTH, 16#1D01).
-define(GL_COLOR_MATERIAL, 16#0B57).
-define(GL_COLOR_MATERIAL_FACE, 16#0B55).
-define(GL_COLOR_MATERIAL_PARAMETER, 16#0B56).
-define(GL_NORMALIZE, 16#0BA1).
% User clipping planes 
-define(GL_CLIP_PLANE0, 16#3000).
-define(GL_CLIP_PLANE1, 16#3001).
-define(GL_CLIP_PLANE2, 16#3002).
-define(GL_CLIP_PLANE3, 16#3003).
-define(GL_CLIP_PLANE4, 16#3004).
-define(GL_CLIP_PLANE5, 16#3005).
% Accumulation buffer 
-define(GL_ACCUM_RED_BITS, 16#0D58).
-define(GL_ACCUM_GREEN_BITS, 16#0D59).
-define(GL_ACCUM_BLUE_BITS, 16#0D5A).
-define(GL_ACCUM_ALPHA_BITS, 16#0D5B).
-define(GL_ACCUM_CLEAR_VALUE, 16#0B80).
-define(GL_ACCUM, 16#0100).
-define(GL_ADD, 16#0104).
-define(GL_LOAD, 16#0101).
-define(GL_MULT, 16#0103).
-define(GL_RETURN, 16#0102).
% Alpha testing 
-define(GL_ALPHA_TEST, 16#0BC0).
-define(GL_ALPHA_TEST_REF, 16#0BC2).
-define(GL_ALPHA_TEST_FUNC, 16#0BC1).
% Blending 
-define(GL_BLEND, 16#0BE2).
-define(GL_BLEND_SRC, 16#0BE1).
-define(GL_BLEND_DST, 16#0BE0).
-define(GL_ZERO, 0).
-define(GL_ONE, 1).
-define(GL_SRC_COLOR, 16#0300).
-define(GL_ONE_MINUS_SRC_COLOR, 16#0301).
-define(GL_DST_COLOR, 16#0306).
-define(GL_ONE_MINUS_DST_COLOR, 16#0307).
-define(GL_SRC_ALPHA, 16#0302).
-define(GL_ONE_MINUS_SRC_ALPHA, 16#0303).
-define(GL_DST_ALPHA, 16#0304).
-define(GL_ONE_MINUS_DST_ALPHA, 16#0305).
-define(GL_SRC_ALPHA_SATURATE, 16#0308).
-define(GL_CONSTANT_COLOR, 16#8001).
-define(GL_ONE_MINUS_CONSTANT_COLOR, 16#8002).
-define(GL_CONSTANT_ALPHA, 16#8003).
-define(GL_ONE_MINUS_CONSTANT_ALPHA, 16#8004).
% Render Mode 
-define(GL_FEEDBACK, 16#1C01).
-define(GL_RENDER, 16#1C00).
-define(GL_SELECT, 16#1C02).
% Feedback 
-define(GL_2D, 16#0600).
-define(GL_3D, 16#0601).
-define(GL_3D_COLOR, 16#0602).
-define(GL_3D_COLOR_TEXTURE, 16#0603).
-define(GL_4D_COLOR_TEXTURE, 16#0604).
-define(GL_POINT_TOKEN, 16#0701).
-define(GL_LINE_TOKEN, 16#0702).
-define(GL_LINE_RESET_TOKEN, 16#0707).
-define(GL_POLYGON_TOKEN, 16#0703).
-define(GL_BITMAP_TOKEN, 16#0704).
-define(GL_DRAW_PIXEL_TOKEN, 16#0705).
-define(GL_COPY_PIXEL_TOKEN, 16#0706).
-define(GL_PASS_THROUGH_TOKEN, 16#0700).
-define(GL_FEEDBACK_BUFFER_POINTER, 16#0DF0).
-define(GL_FEEDBACK_BUFFER_SIZE, 16#0DF1).
-define(GL_FEEDBACK_BUFFER_TYPE, 16#0DF2).
% Selection 
-define(GL_SELECTION_BUFFER_POINTER, 16#0DF3).
-define(GL_SELECTION_BUFFER_SIZE, 16#0DF4).
% Fog 
-define(GL_FOG, 16#0B60).
-define(GL_FOG_MODE, 16#0B65).
-define(GL_FOG_DENSITY, 16#0B62).
-define(GL_FOG_COLOR, 16#0B66).
-define(GL_FOG_INDEX, 16#0B61).
-define(GL_FOG_START, 16#0B63).
-define(GL_FOG_END, 16#0B64).
-define(GL_LINEAR, 16#2601).
-define(GL_EXP, 16#0800).
-define(GL_EXP2, 16#0801).
% Logic Ops 
-define(GL_LOGIC_OP, 16#0BF1).
-define(GL_INDEX_LOGIC_OP, 16#0BF1).
-define(GL_COLOR_LOGIC_OP, 16#0BF2).
-define(GL_LOGIC_OP_MODE, 16#0BF0).
-define(GL_CLEAR, 16#1500).
-define(GL_SET, 16#150F).
-define(GL_COPY, 16#1503).
-define(GL_COPY_INVERTED, 16#150C).
-define(GL_NOOP, 16#1505).
-define(GL_INVERT, 16#150A).
-define(GL_AND, 16#1501).
-define(GL_NAND, 16#150E).
-define(GL_OR, 16#1507).
-define(GL_NOR, 16#1508).
-define(GL_XOR, 16#1506).
-define(GL_EQUIV, 16#1509).
-define(GL_AND_REVERSE, 16#1502).
-define(GL_AND_INVERTED, 16#1504).
-define(GL_OR_REVERSE, 16#150B).
-define(GL_OR_INVERTED, 16#150D).
% Stencil 
-define(GL_STENCIL_TEST, 16#0B90).
-define(GL_STENCIL_WRITEMASK, 16#0B98).
-define(GL_STENCIL_BITS, 16#0D57).
-define(GL_STENCIL_FUNC, 16#0B92).
-define(GL_STENCIL_VALUE_MASK, 16#0B93).
-define(GL_STENCIL_REF, 16#0B97).
-define(GL_STENCIL_FAIL, 16#0B94).
-define(GL_STENCIL_PASS_DEPTH_PASS, 16#0B96).
-define(GL_STENCIL_PASS_DEPTH_FAIL, 16#0B95).
-define(GL_STENCIL_CLEAR_VALUE, 16#0B91).
-define(GL_STENCIL_INDEX, 16#1901).
-define(GL_KEEP, 16#1E00).
-define(GL_REPLACE, 16#1E01).
-define(GL_INCR, 16#1E02).
-define(GL_DECR, 16#1E03).
% Buffers Pixel Drawing/Reading 
-define(GL_NONE, 0).
-define(GL_LEFT, 16#0406).
-define(GL_RIGHT, 16#0407).
% GL_FRONT = 0x0404 
% GL_BACK = 0x0405 
% GL_FRONT_AND_BACK = 0x0408 
-define(GL_FRONT_LEFT, 16#0400).
-define(GL_FRONT_RIGHT, 16#0401).
-define(GL_BACK_LEFT, 16#0402).
-define(GL_BACK_RIGHT, 16#0403).
-define(GL_AUX0, 16#0409).
-define(GL_AUX1, 16#040A).
-define(GL_AUX2, 16#040B).
-define(GL_AUX3, 16#040C).
-define(GL_COLOR_INDEX, 16#1900).
-define(GL_RED, 16#1903).
-define(GL_GREEN, 16#1904).
-define(GL_BLUE, 16#1905).
-define(GL_ALPHA, 16#1906).
-define(GL_LUMINANCE, 16#1909).
-define(GL_LUMINANCE_ALPHA, 16#190A).
-define(GL_ALPHA_BITS, 16#0D55).
-define(GL_RED_BITS, 16#0D52).
-define(GL_GREEN_BITS, 16#0D53).
-define(GL_BLUE_BITS, 16#0D54).
-define(GL_INDEX_BITS, 16#0D51).
-define(GL_SUBPIXEL_BITS, 16#0D50).
-define(GL_AUX_BUFFERS, 16#0C00).
-define(GL_READ_BUFFER, 16#0C02).
-define(GL_DRAW_BUFFER, 16#0C01).
-define(GL_DOUBLEBUFFER, 16#0C32).
-define(GL_STEREO, 16#0C33).
-define(GL_BITMAP, 16#1A00).
-define(GL_COLOR, 16#1800).
-define(GL_DEPTH, 16#1801).
-define(GL_STENCIL, 16#1802).
-define(GL_DITHER, 16#0BD0).
-define(GL_RGB, 16#1907).
-define(GL_RGBA, 16#1908).
% Implementation limits 
-define(GL_MAX_LIST_NESTING, 16#0B31).
-define(GL_MAX_ATTRIB_STACK_DEPTH, 16#0D35).
-define(GL_MAX_MODELVIEW_STACK_DEPTH, 16#0D36).
-define(GL_MAX_NAME_STACK_DEPTH, 16#0D37).
-define(GL_MAX_PROJECTION_STACK_DEPTH, 16#0D38).
-define(GL_MAX_TEXTURE_STACK_DEPTH, 16#0D39).
-define(GL_MAX_EVAL_ORDER, 16#0D30).
-define(GL_MAX_LIGHTS, 16#0D31).
-define(GL_MAX_CLIP_PLANES, 16#0D32).
-define(GL_MAX_TEXTURE_SIZE, 16#0D33).
-define(GL_MAX_PIXEL_MAP_TABLE, 16#0D34).
-define(GL_MAX_VIEWPORT_DIMS, 16#0D3A).
-define(GL_MAX_CLIENT_ATTRIB_STACK_DEPTH, 16#0D3B).
% Gets 
-define(GL_ATTRIB_STACK_DEPTH, 16#0BB0).
-define(GL_CLIENT_ATTRIB_STACK_DEPTH, 16#0BB1).
-define(GL_COLOR_CLEAR_VALUE, 16#0C22).
-define(GL_COLOR_WRITEMASK, 16#0C23).
-define(GL_CURRENT_INDEX, 16#0B01).
-define(GL_CURRENT_COLOR, 16#0B00).
-define(GL_CURRENT_NORMAL, 16#0B02).
-define(GL_CURRENT_RASTER_COLOR, 16#0B04).
-define(GL_CURRENT_RASTER_DISTANCE, 16#0B09).
-define(GL_CURRENT_RASTER_INDEX, 16#0B05).
-define(GL_CURRENT_RASTER_POSITION, 16#0B07).
-define(GL_CURRENT_RASTER_TEXTURE_COORDS, 16#0B06).
-define(GL_CURRENT_RASTER_POSITION_VALID, 16#0B08).
-define(GL_CURRENT_TEXTURE_COORDS, 16#0B03).
-define(GL_INDEX_CLEAR_VALUE, 16#0C20).
-define(GL_INDEX_MODE, 16#0C30).
-define(GL_INDEX_WRITEMASK, 16#0C21).
-define(GL_MODELVIEW_MATRIX, 16#0BA6).
-define(GL_MODELVIEW_STACK_DEPTH, 16#0BA3).
-define(GL_NAME_STACK_DEPTH, 16#0D70).
-define(GL_PROJECTION_MATRIX, 16#0BA7).
-define(GL_PROJECTION_STACK_DEPTH, 16#0BA4).
-define(GL_RENDER_MODE, 16#0C40).
-define(GL_RGBA_MODE, 16#0C31).
-define(GL_TEXTURE_MATRIX, 16#0BA8).
-define(GL_TEXTURE_STACK_DEPTH, 16#0BA5).
-define(GL_VIEWPORT, 16#0BA2).
% Evaluators 
-define(GL_AUTO_NORMAL, 16#0D80).
-define(GL_MAP1_COLOR_4, 16#0D90).
-define(GL_MAP1_GRID_DOMAIN, 16#0DD0).
-define(GL_MAP1_GRID_SEGMENTS, 16#0DD1).
-define(GL_MAP1_INDEX, 16#0D91).
-define(GL_MAP1_NORMAL, 16#0D92).
-define(GL_MAP1_TEXTURE_COORD_1, 16#0D93).
-define(GL_MAP1_TEXTURE_COORD_2, 16#0D94).
-define(GL_MAP1_TEXTURE_COORD_3, 16#0D95).
-define(GL_MAP1_TEXTURE_COORD_4, 16#0D96).
-define(GL_MAP1_VERTEX_3, 16#0D97).
-define(GL_MAP1_VERTEX_4, 16#0D98).
-define(GL_MAP2_COLOR_4, 16#0DB0).
-define(GL_MAP2_GRID_DOMAIN, 16#0DD2).
-define(GL_MAP2_GRID_SEGMENTS, 16#0DD3).
-define(GL_MAP2_INDEX, 16#0DB1).
-define(GL_MAP2_NORMAL, 16#0DB2).
-define(GL_MAP2_TEXTURE_COORD_1, 16#0DB3).
-define(GL_MAP2_TEXTURE_COORD_2, 16#0DB4).
-define(GL_MAP2_TEXTURE_COORD_3, 16#0DB5).
-define(GL_MAP2_TEXTURE_COORD_4, 16#0DB6).
-define(GL_MAP2_VERTEX_3, 16#0DB7).
-define(GL_MAP2_VERTEX_4, 16#0DB8).
-define(GL_COEFF, 16#0A00).
-define(GL_DOMAIN, 16#0A02).
-define(GL_ORDER, 16#0A01).
% Hints 
-define(GL_FOG_HINT, 16#0C54).
-define(GL_LINE_SMOOTH_HINT, 16#0C52).
-define(GL_PERSPECTIVE_CORRECTION_HINT, 16#0C50).
-define(GL_POINT_SMOOTH_HINT, 16#0C51).
-define(GL_POLYGON_SMOOTH_HINT, 16#0C53).
-define(GL_DONT_CARE, 16#1100).
-define(GL_FASTEST, 16#1101).
-define(GL_NICEST, 16#1102).
% Scissor box 
-define(GL_SCISSOR_TEST, 16#0C11).
-define(GL_SCISSOR_BOX, 16#0C10).
% Pixel Mode / Transfer 
-define(GL_MAP_COLOR, 16#0D10).
-define(GL_MAP_STENCIL, 16#0D11).
-define(GL_INDEX_SHIFT, 16#0D12).
-define(GL_INDEX_OFFSET, 16#0D13).
-define(GL_RED_SCALE, 16#0D14).
-define(GL_RED_BIAS, 16#0D15).
-define(GL_GREEN_SCALE, 16#0D18).
-define(GL_GREEN_BIAS, 16#0D19).
-define(GL_BLUE_SCALE, 16#0D1A).
-define(GL_BLUE_BIAS, 16#0D1B).
-define(GL_ALPHA_SCALE, 16#0D1C).
-define(GL_ALPHA_BIAS, 16#0D1D).
-define(GL_DEPTH_SCALE, 16#0D1E).
-define(GL_DEPTH_BIAS, 16#0D1F).
-define(GL_PIXEL_MAP_S_TO_S_SIZE, 16#0CB1).
-define(GL_PIXEL_MAP_I_TO_I_SIZE, 16#0CB0).
-define(GL_PIXEL_MAP_I_TO_R_SIZE, 16#0CB2).
-define(GL_PIXEL_MAP_I_TO_G_SIZE, 16#0CB3).
-define(GL_PIXEL_MAP_I_TO_B_SIZE, 16#0CB4).
-define(GL_PIXEL_MAP_I_TO_A_SIZE, 16#0CB5).
-define(GL_PIXEL_MAP_R_TO_R_SIZE, 16#0CB6).
-define(GL_PIXEL_MAP_G_TO_G_SIZE, 16#0CB7).
-define(GL_PIXEL_MAP_B_TO_B_SIZE, 16#0CB8).
-define(GL_PIXEL_MAP_A_TO_A_SIZE, 16#0CB9).
-define(GL_PIXEL_MAP_S_TO_S, 16#0C71).
-define(GL_PIXEL_MAP_I_TO_I, 16#0C70).
-define(GL_PIXEL_MAP_I_TO_R, 16#0C72).
-define(GL_PIXEL_MAP_I_TO_G, 16#0C73).
-define(GL_PIXEL_MAP_I_TO_B, 16#0C74).
-define(GL_PIXEL_MAP_I_TO_A, 16#0C75).
-define(GL_PIXEL_MAP_R_TO_R, 16#0C76).
-define(GL_PIXEL_MAP_G_TO_G, 16#0C77).
-define(GL_PIXEL_MAP_B_TO_B, 16#0C78).
-define(GL_PIXEL_MAP_A_TO_A, 16#0C79).
-define(GL_PACK_ALIGNMENT, 16#0D05).
-define(GL_PACK_LSB_FIRST, 16#0D01).
-define(GL_PACK_ROW_LENGTH, 16#0D02).
-define(GL_PACK_SKIP_PIXELS, 16#0D04).
-define(GL_PACK_SKIP_ROWS, 16#0D03).
-define(GL_PACK_SWAP_BYTES, 16#0D00).
-define(GL_UNPACK_ALIGNMENT, 16#0CF5).
-define(GL_UNPACK_LSB_FIRST, 16#0CF1).
-define(GL_UNPACK_ROW_LENGTH, 16#0CF2).
-define(GL_UNPACK_SKIP_PIXELS, 16#0CF4).
-define(GL_UNPACK_SKIP_ROWS, 16#0CF3).
-define(GL_UNPACK_SWAP_BYTES, 16#0CF0).
-define(GL_ZOOM_X, 16#0D16).
-define(GL_ZOOM_Y, 16#0D17).
% Texture mapping 
-define(GL_TEXTURE_ENV, 16#2300).
-define(GL_TEXTURE_ENV_MODE, 16#2200).
-define(GL_TEXTURE_1D, 16#0DE0).
-define(GL_TEXTURE_2D, 16#0DE1).
-define(GL_TEXTURE_WRAP_S, 16#2802).
-define(GL_TEXTURE_WRAP_T, 16#2803).
-define(GL_TEXTURE_MAG_FILTER, 16#2800).
-define(GL_TEXTURE_MIN_FILTER, 16#2801).
-define(GL_TEXTURE_ENV_COLOR, 16#2201).
-define(GL_TEXTURE_GEN_S, 16#0C60).
-define(GL_TEXTURE_GEN_T, 16#0C61).
-define(GL_TEXTURE_GEN_MODE, 16#2500).
-define(GL_TEXTURE_BORDER_COLOR, 16#1004).
-define(GL_TEXTURE_WIDTH, 16#1000).
-define(GL_TEXTURE_HEIGHT, 16#1001).
-define(GL_TEXTURE_BORDER, 16#1005).
-define(GL_TEXTURE_COMPONENTS, 16#1003).
-define(GL_TEXTURE_RED_SIZE, 16#805C).
-define(GL_TEXTURE_GREEN_SIZE, 16#805D).
-define(GL_TEXTURE_BLUE_SIZE, 16#805E).
-define(GL_TEXTURE_ALPHA_SIZE, 16#805F).
-define(GL_TEXTURE_LUMINANCE_SIZE, 16#8060).
-define(GL_TEXTURE_INTENSITY_SIZE, 16#8061).
-define(GL_NEAREST_MIPMAP_NEAREST, 16#2700).
-define(GL_NEAREST_MIPMAP_LINEAR, 16#2702).
-define(GL_LINEAR_MIPMAP_NEAREST, 16#2701).
-define(GL_LINEAR_MIPMAP_LINEAR, 16#2703).
-define(GL_OBJECT_LINEAR, 16#2401).
-define(GL_OBJECT_PLANE, 16#2501).
-define(GL_EYE_LINEAR, 16#2400).
-define(GL_EYE_PLANE, 16#2502).
-define(GL_SPHERE_MAP, 16#2402).
-define(GL_DECAL, 16#2101).
-define(GL_MODULATE, 16#2100).
-define(GL_NEAREST, 16#2600).
-define(GL_REPEAT, 16#2901).
-define(GL_CLAMP, 16#2900).
-define(GL_S, 16#2000).
-define(GL_T, 16#2001).
-define(GL_R, 16#2002).
-define(GL_Q, 16#2003).
-define(GL_TEXTURE_GEN_R, 16#0C62).
-define(GL_TEXTURE_GEN_Q, 16#0C63).
% GL 1.1 texturing 
-define(GL_PROXY_TEXTURE_1D, 16#8063).
-define(GL_PROXY_TEXTURE_2D, 16#8064).
-define(GL_TEXTURE_PRIORITY, 16#8066).
-define(GL_TEXTURE_RESIDENT, 16#8067).
-define(GL_TEXTURE_BINDING_1D, 16#8068).
-define(GL_TEXTURE_BINDING_2D, 16#8069).
-define(GL_TEXTURE_INTERNAL_FORMAT, 16#1003).
% GL 1.2 texturing 
-define(GL_PACK_SKIP_IMAGES, 16#806B).
-define(GL_PACK_IMAGE_HEIGHT, 16#806C).
-define(GL_UNPACK_SKIP_IMAGES, 16#806D).
-define(GL_UNPACK_IMAGE_HEIGHT, 16#806E).
-define(GL_TEXTURE_3D, 16#806F).
-define(GL_PROXY_TEXTURE_3D, 16#8070).
-define(GL_TEXTURE_DEPTH, 16#8071).
-define(GL_TEXTURE_WRAP_R, 16#8072).
-define(GL_MAX_3D_TEXTURE_SIZE, 16#8073).
-define(GL_TEXTURE_BINDING_3D, 16#806A).
% Internal texture formats (GL 1.1) 
-define(GL_ALPHA4, 16#803B).
-define(GL_ALPHA8, 16#803C).
-define(GL_ALPHA12, 16#803D).
-define(GL_ALPHA16, 16#803E).
-define(GL_LUMINANCE4, 16#803F).
-define(GL_LUMINANCE8, 16#8040).
-define(GL_LUMINANCE12, 16#8041).
-define(GL_LUMINANCE16, 16#8042).
-define(GL_LUMINANCE4_ALPHA4, 16#8043).
-define(GL_LUMINANCE6_ALPHA2, 16#8044).
-define(GL_LUMINANCE8_ALPHA8, 16#8045).
-define(GL_LUMINANCE12_ALPHA4, 16#8046).
-define(GL_LUMINANCE12_ALPHA12, 16#8047).
-define(GL_LUMINANCE16_ALPHA16, 16#8048).
-define(GL_INTENSITY, 16#8049).
-define(GL_INTENSITY4, 16#804A).
-define(GL_INTENSITY8, 16#804B).
-define(GL_INTENSITY12, 16#804C).
-define(GL_INTENSITY16, 16#804D).
-define(GL_R3_G3_B2, 16#2A10).
-define(GL_RGB4, 16#804F).
-define(GL_RGB5, 16#8050).
-define(GL_RGB8, 16#8051).
-define(GL_RGB10, 16#8052).
-define(GL_RGB12, 16#8053).
-define(GL_RGB16, 16#8054).
-define(GL_RGBA2, 16#8055).
-define(GL_RGBA4, 16#8056).
-define(GL_RGB5_A1, 16#8057).
-define(GL_RGBA8, 16#8058).
-define(GL_RGB10_A2, 16#8059).
-define(GL_RGBA12, 16#805A).
-define(GL_RGBA16, 16#805B).
% Utility 
-define(GL_VENDOR, 16#1F00).
-define(GL_RENDERER, 16#1F01).
-define(GL_VERSION, 16#1F02).
-define(GL_EXTENSIONS, 16#1F03).
% Errors 
-define(GL_INVALID_VALUE, 16#0501).
-define(GL_INVALID_ENUM, 16#0500).
-define(GL_INVALID_OPERATION, 16#0502).
-define(GL_STACK_OVERFLOW, 16#0503).
-define(GL_STACK_UNDERFLOW, 16#0504).
-define(GL_OUT_OF_MEMORY, 16#0505).
% * Extensions 
% GL_EXT_blend_minmax and GL_EXT_blend_color 
-define(GL_CONSTANT_COLOR_EXT, 16#8001).
-define(GL_ONE_MINUS_CONSTANT_COLOR_EXT, 16#8002).
-define(GL_CONSTANT_ALPHA_EXT, 16#8003).
-define(GL_ONE_MINUS_CONSTANT_ALPHA_EXT, 16#8004).
-define(GL_BLEND_EQUATION_EXT, 16#8009).
-define(GL_MIN_EXT, 16#8007).
-define(GL_MAX_EXT, 16#8008).
-define(GL_FUNC_ADD_EXT, 16#8006).
-define(GL_FUNC_SUBTRACT_EXT, 16#800A).
-define(GL_FUNC_REVERSE_SUBTRACT_EXT, 16#800B).
-define(GL_BLEND_COLOR_EXT, 16#8005).
% GL_EXT_polygon_offset 
-define(GL_POLYGON_OFFSET_EXT, 16#8037).
-define(GL_POLYGON_OFFSET_FACTOR_EXT, 16#8038).
-define(GL_POLYGON_OFFSET_BIAS_EXT, 16#8039).
% GL_EXT_vertex_array 
-define(GL_VERTEX_ARRAY_EXT, 16#8074).
-define(GL_NORMAL_ARRAY_EXT, 16#8075).
-define(GL_COLOR_ARRAY_EXT, 16#8076).
-define(GL_INDEX_ARRAY_EXT, 16#8077).
-define(GL_TEXTURE_COORD_ARRAY_EXT, 16#8078).
-define(GL_EDGE_FLAG_ARRAY_EXT, 16#8079).
-define(GL_VERTEX_ARRAY_SIZE_EXT, 16#807A).
-define(GL_VERTEX_ARRAY_TYPE_EXT, 16#807B).
-define(GL_VERTEX_ARRAY_STRIDE_EXT, 16#807C).
-define(GL_VERTEX_ARRAY_COUNT_EXT, 16#807D).
-define(GL_NORMAL_ARRAY_TYPE_EXT, 16#807E).
-define(GL_NORMAL_ARRAY_STRIDE_EXT, 16#807F).
-define(GL_NORMAL_ARRAY_COUNT_EXT, 16#8080).
-define(GL_COLOR_ARRAY_SIZE_EXT, 16#8081).
-define(GL_COLOR_ARRAY_TYPE_EXT, 16#8082).
-define(GL_COLOR_ARRAY_STRIDE_EXT, 16#8083).
-define(GL_COLOR_ARRAY_COUNT_EXT, 16#8084).
-define(GL_INDEX_ARRAY_TYPE_EXT, 16#8085).
-define(GL_INDEX_ARRAY_STRIDE_EXT, 16#8086).
-define(GL_INDEX_ARRAY_COUNT_EXT, 16#8087).
-define(GL_TEXTURE_COORD_ARRAY_SIZE_EXT, 16#8088).
-define(GL_TEXTURE_COORD_ARRAY_TYPE_EXT, 16#8089).
-define(GL_TEXTURE_COORD_ARRAY_STRIDE_EXT, 16#808A).
-define(GL_TEXTURE_COORD_ARRAY_COUNT_EXT, 16#808B).
-define(GL_EDGE_FLAG_ARRAY_STRIDE_EXT, 16#808C).
-define(GL_EDGE_FLAG_ARRAY_COUNT_EXT, 16#808D).
-define(GL_VERTEX_ARRAY_POINTER_EXT, 16#808E).
-define(GL_NORMAL_ARRAY_POINTER_EXT, 16#808F).
-define(GL_COLOR_ARRAY_POINTER_EXT, 16#8090).
-define(GL_INDEX_ARRAY_POINTER_EXT, 16#8091).
-define(GL_TEXTURE_COORD_ARRAY_POINTER_EXT, 16#8092).
-define(GL_EDGE_FLAG_ARRAY_POINTER_EXT, 16#8093).
% GL_EXT_texture_object 
-define(GL_TEXTURE_PRIORITY_EXT, 16#8066).
-define(GL_TEXTURE_RESIDENT_EXT, 16#8067).
-define(GL_TEXTURE_1D_BINDING_EXT, 16#8068).
-define(GL_TEXTURE_2D_BINDING_EXT, 16#8069).
% GL_EXT_texture3D 
-define(GL_PACK_SKIP_IMAGES_EXT, 16#806B).
-define(GL_PACK_IMAGE_HEIGHT_EXT, 16#806C).
-define(GL_UNPACK_SKIP_IMAGES_EXT, 16#806D).
-define(GL_UNPACK_IMAGE_HEIGHT_EXT, 16#806E).
-define(GL_TEXTURE_3D_EXT, 16#806F).
-define(GL_PROXY_TEXTURE_3D_EXT, 16#8070).
-define(GL_TEXTURE_DEPTH_EXT, 16#8071).
-define(GL_TEXTURE_WRAP_R_EXT, 16#8072).
-define(GL_MAX_3D_TEXTURE_SIZE_EXT, 16#8073).
-define(GL_TEXTURE_3D_BINDING_EXT, 16#806A).
% GL_EXT_paletted_texture 
-define(GL_TABLE_TOO_LARGE_EXT, 16#8031).
-define(GL_COLOR_TABLE_FORMAT_EXT, 16#80D8).
-define(GL_COLOR_TABLE_WIDTH_EXT, 16#80D9).
-define(GL_COLOR_TABLE_RED_SIZE_EXT, 16#80DA).
-define(GL_COLOR_TABLE_GREEN_SIZE_EXT, 16#80DB).
-define(GL_COLOR_TABLE_BLUE_SIZE_EXT, 16#80DC).
-define(GL_COLOR_TABLE_ALPHA_SIZE_EXT, 16#80DD).
-define(GL_COLOR_TABLE_LUMINANCE_SIZE_EXT, 16#80DE).
-define(GL_COLOR_TABLE_INTENSITY_SIZE_EXT, 16#80DF).
-define(GL_TEXTURE_INDEX_SIZE_EXT, 16#80ED).
-define(GL_COLOR_INDEX1_EXT, 16#80E2).
-define(GL_COLOR_INDEX2_EXT, 16#80E3).
-define(GL_COLOR_INDEX4_EXT, 16#80E4).
-define(GL_COLOR_INDEX8_EXT, 16#80E5).
-define(GL_COLOR_INDEX12_EXT, 16#80E6).
-define(GL_COLOR_INDEX16_EXT, 16#80E7).
% GL_EXT_shared_texture_palette 
-define(GL_SHARED_TEXTURE_PALETTE_EXT, 16#81FB).
% GL_EXT_point_parameters 
-define(GL_POINT_SIZE_MIN_EXT, 16#8126).
-define(GL_POINT_SIZE_MAX_EXT, 16#8127).
-define(GL_POINT_FADE_THRESHOLD_SIZE_EXT, 16#8128).
-define(GL_DISTANCE_ATTENUATION_EXT, 16#8129).
% GL_EXT_rescale_normal 
-define(GL_RESCALE_NORMAL_EXT, 16#803A).
% GL_EXT_abgr 
-define(GL_ABGR_EXT, 16#8000).
% GL_EXT_stencil_wrap 
-define(GL_INCR_WRAP_EXT, 16#8507).
-define(GL_DECR_WRAP_EXT, 16#8508).
% GL_SGIS_texture_edge_clamp 
-define(GL_CLAMP_TO_EDGE_SGIS, 16#812F).
% GL_INGR_blend_func_separate 
-define(GL_BLEND_DST_RGB_INGR, 16#80C8).
-define(GL_BLEND_SRC_RGB_INGR, 16#80C9).
-define(GL_BLEND_DST_ALPHA_INGR, 16#80CA).
-define(GL_BLEND_SRC_ALPHA_INGR, 16#80CB).
% OpenGL 1.2 
-define(GL_RESCALE_NORMAL, 16#803A).
-define(GL_CLAMP_TO_EDGE, 16#812F).
-define(GL_MAX_ELEMENTS_VERTICES, 16#80E8).
-define(GL_MAX_ELEMENTS_INDICES, 16#80E9).
-define(GL_BGR, 16#80E0).
-define(GL_BGRA, 16#80E1).
-define(GL_UNSIGNED_BYTE_3_3_2, 16#8032).
-define(GL_UNSIGNED_BYTE_2_3_3_REV, 16#8362).
-define(GL_UNSIGNED_SHORT_5_6_5, 16#8363).
-define(GL_UNSIGNED_SHORT_5_6_5_REV, 16#8364).
-define(GL_UNSIGNED_SHORT_4_4_4_4, 16#8033).
-define(GL_UNSIGNED_SHORT_4_4_4_4_REV, 16#8365).
-define(GL_UNSIGNED_SHORT_5_5_5_1, 16#8034).
-define(GL_UNSIGNED_SHORT_1_5_5_5_REV, 16#8366).
-define(GL_UNSIGNED_INT_8_8_8_8, 16#8035).
-define(GL_UNSIGNED_INT_8_8_8_8_REV, 16#8367).
-define(GL_UNSIGNED_INT_10_10_10_2, 16#8036).
-define(GL_UNSIGNED_INT_2_10_10_10_REV, 16#8368).
-define(GL_LIGHT_MODEL_COLOR_CONTROL, 16#81F8).
-define(GL_SINGLE_COLOR, 16#81F9).
-define(GL_SEPARATE_SPECULAR_COLOR, 16#81FA).
-define(GL_TEXTURE_MIN_LOD, 16#813A).
-define(GL_TEXTURE_MAX_LOD, 16#813B).
-define(GL_TEXTURE_BASE_LEVEL, 16#813C).
-define(GL_TEXTURE_MAX_LEVEL, 16#813D).
-define(GL_SMOOTH_POINT_SIZE_RANGE, 16#0B12).
-define(GL_SMOOTH_POINT_SIZE_GRANULARITY, 16#0B13).
-define(GL_SMOOTH_LINE_WIDTH_RANGE, 16#0B22).
-define(GL_SMOOTH_LINE_WIDTH_GRANULARITY, 16#0B23).
-define(GL_ALIASED_POINT_SIZE_RANGE, 16#846D).
-define(GL_ALIASED_LINE_WIDTH_RANGE, 16#846E).
% GL_ARB_multitexture 
-define(GL_TEXTURE0_ARB, 16#84C0).
-define(GL_TEXTURE1_ARB, 16#84C1).
-define(GL_TEXTURE2_ARB, 16#84C2).
-define(GL_TEXTURE3_ARB, 16#84C3).
-define(GL_TEXTURE4_ARB, 16#84C4).
-define(GL_TEXTURE5_ARB, 16#84C5).
-define(GL_TEXTURE6_ARB, 16#84C6).
-define(GL_TEXTURE7_ARB, 16#84C7).
-define(GL_TEXTURE8_ARB, 16#84C8).
-define(GL_TEXTURE9_ARB, 16#84C9).
-define(GL_TEXTURE10_ARB, 16#84CA).
-define(GL_TEXTURE11_ARB, 16#84CB).
-define(GL_TEXTURE12_ARB, 16#84CC).
-define(GL_TEXTURE13_ARB, 16#84CD).
-define(GL_TEXTURE14_ARB, 16#84CE).
-define(GL_TEXTURE15_ARB, 16#84CF).
-define(GL_TEXTURE16_ARB, 16#84D0).
-define(GL_TEXTURE17_ARB, 16#84D1).
-define(GL_TEXTURE18_ARB, 16#84D2).
-define(GL_TEXTURE19_ARB, 16#84D3).
-define(GL_TEXTURE20_ARB, 16#84D4).
-define(GL_TEXTURE21_ARB, 16#84D5).
-define(GL_TEXTURE22_ARB, 16#84D6).
-define(GL_TEXTURE23_ARB, 16#84D7).
-define(GL_TEXTURE24_ARB, 16#84D8).
-define(GL_TEXTURE25_ARB, 16#84D9).
-define(GL_TEXTURE26_ARB, 16#84DA).
-define(GL_TEXTURE27_ARB, 16#84DB).
-define(GL_TEXTURE28_ARB, 16#84DC).
-define(GL_TEXTURE29_ARB, 16#84DD).
-define(GL_TEXTURE30_ARB, 16#84DE).
-define(GL_TEXTURE31_ARB, 16#84DF).
-define(GL_ACTIVE_TEXTURE_ARB, 16#84E0).
-define(GL_CLIENT_ACTIVE_TEXTURE_ARB, 16#84E1).
-define(GL_MAX_TEXTURE_UNITS_ARB, 16#84E2).
% * OpenGL 1.2 imaging subset (NOT IMPLEMENTED BY MESA) 
% GL_EXT_color_table 
-define(GL_COLOR_TABLE, 16#80D0).
-define(GL_POST_CONVOLUTION_COLOR_TABLE, 16#80D1).
-define(GL_POST_COLOR_MATRIX_COLOR_TABLE, 16#80D2).
-define(GL_PROXY_COLOR_TABLE, 16#80D3).
-define(GL_PROXY_POST_CONVOLUTION_COLOR_TABLE, 16#80D4).
-define(GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE, 16#80D5).
-define(GL_COLOR_TABLE_SCALE, 16#80D6).
-define(GL_COLOR_TABLE_BIAS, 16#80D7).
-define(GL_COLOR_TABLE_FORMAT, 16#80D8).
-define(GL_COLOR_TABLE_WIDTH, 16#80D9).
-define(GL_COLOR_TABLE_RED_SIZE, 16#80DA).
-define(GL_COLOR_TABLE_GREEN_SIZE, 16#80DB).
-define(GL_COLOR_TABLE_BLUE_SIZE, 16#80DC).
-define(GL_COLOR_TABLE_ALPHA_SIZE, 16#80DD).
-define(GL_COLOR_TABLE_LUMINANCE_SIZE, 16#80DE).
-define(GL_COLOR_TABLE_INTENSITY_SIZE, 16#80DF).
% GL_EXT_convolution and GL_HP_convolution_border_modes 
-define(GL_CONVOLUTION_1D, 16#8010).
-define(GL_CONVOLUTION_2D, 16#8011).
-define(GL_SEPARABLE_2D, 16#8012).
-define(GL_CONVOLUTION_BORDER_MODE, 16#8013).
-define(GL_CONVOLUTION_FILTER_SCALE, 16#8014).
-define(GL_CONVOLUTION_FILTER_BIAS, 16#8015).
-define(GL_REDUCE, 16#8016).
-define(GL_CONVOLUTION_FORMAT, 16#8017).
-define(GL_CONVOLUTION_WIDTH, 16#8018).
-define(GL_CONVOLUTION_HEIGHT, 16#8019).
-define(GL_MAX_CONVOLUTION_WIDTH, 16#801A).
-define(GL_MAX_CONVOLUTION_HEIGHT, 16#801B).
-define(GL_POST_CONVOLUTION_RED_SCALE, 16#801C).
-define(GL_POST_CONVOLUTION_GREEN_SCALE, 16#801D).
-define(GL_POST_CONVOLUTION_BLUE_SCALE, 16#801E).
-define(GL_POST_CONVOLUTION_ALPHA_SCALE, 16#801F).
-define(GL_POST_CONVOLUTION_RED_BIAS, 16#8020).
-define(GL_POST_CONVOLUTION_GREEN_BIAS, 16#8021).
-define(GL_POST_CONVOLUTION_BLUE_BIAS, 16#8022).
-define(GL_POST_CONVOLUTION_ALPHA_BIAS, 16#8023).
-define(GL_CONSTANT_BORDER, 16#8151).
-define(GL_REPLICATE_BORDER, 16#8153).
-define(GL_CONVOLUTION_BORDER_COLOR, 16#8154).
% GL_SGI_color_matrix 
-define(GL_COLOR_MATRIX, 16#80B1).
-define(GL_COLOR_MATRIX_STACK_DEPTH, 16#80B2).
-define(GL_MAX_COLOR_MATRIX_STACK_DEPTH, 16#80B3).
-define(GL_POST_COLOR_MATRIX_RED_SCALE, 16#80B4).
-define(GL_POST_COLOR_MATRIX_GREEN_SCALE, 16#80B5).
-define(GL_POST_COLOR_MATRIX_BLUE_SCALE, 16#80B6).
-define(GL_POST_COLOR_MATRIX_ALPHA_SCALE, 16#80B7).
-define(GL_POST_COLOR_MATRIX_RED_BIAS, 16#80B8).
-define(GL_POST_COLOR_MATRIX_GREEN_BIAS, 16#80B9).
-define(GL_POST_COLOR_MATRIX_BLUE_BIAS, 16#80BA).
-define(GL_POST_COLOR_MATRIX_ALPHA_BIAS, 16#80BB).
% GL_EXT_histogram 
-define(GL_HISTOGRAM, 16#8024).
-define(GL_PROXY_HISTOGRAM, 16#8025).
-define(GL_HISTOGRAM_WIDTH, 16#8026).
-define(GL_HISTOGRAM_FORMAT, 16#8027).
-define(GL_HISTOGRAM_RED_SIZE, 16#8028).
-define(GL_HISTOGRAM_GREEN_SIZE, 16#8029).
-define(GL_HISTOGRAM_BLUE_SIZE, 16#802A).
-define(GL_HISTOGRAM_ALPHA_SIZE, 16#802B).
-define(GL_HISTOGRAM_LUMINANCE_SIZE, 16#802C).
-define(GL_HISTOGRAM_SINK, 16#802D).
-define(GL_MINMAX, 16#802E).
-define(GL_MINMAX_FORMAT, 16#802F).
-define(GL_MINMAX_SINK, 16#8030).
-define(GL_TABLE_TOO_LARGE, 16#8031).
% GL_EXT_blend_color GL_EXT_blend_minmax 
-define(GL_BLEND_EQUATION, 16#8009).
-define(GL_MIN, 16#8007).
-define(GL_MAX, 16#8008).
-define(GL_FUNC_ADD, 16#8006).
-define(GL_FUNC_SUBTRACT, 16#800A).
-define(GL_FUNC_REVERSE_SUBTRACT, 16#800B).
-define(GL_BLEND_COLOR, 16#8005).
% GL_NV_texgen_reflection (nVidia) 
-define(GL_NORMAL_MAP_NV, 16#8511).
-define(GL_REFLECTION_MAP_NV, 16#8512).
% GL_PGI_misc_hints 
-define(GL_PREFER_DOUBLEBUFFER_HINT_PGI, 107000).
-define(GL_STRICT_DEPTHFUNC_HINT_PGI, 107030).
-define(GL_STRICT_LIGHTING_HINT_PGI, 107031).
-define(GL_STRICT_SCISSOR_HINT_PGI, 107032).
-define(GL_FULL_STIPPLE_HINT_PGI, 107033).
-define(GL_NATIVE_GRAPHICS_BEGIN_HINT_PGI, 107011).
-define(GL_NATIVE_GRAPHICS_END_HINT_PGI, 107012).
-define(GL_CONSERVE_MEMORY_HINT_PGI, 107005).
-define(GL_RECLAIM_MEMORY_HINT_PGI, 107006).
-define(GL_ALWAYS_FAST_HINT_PGI, 107020).
-define(GL_ALWAYS_SOFT_HINT_PGI, 107021).
-define(GL_ALLOW_DRAW_OBJ_HINT_PGI, 107022).
-define(GL_ALLOW_DRAW_WIN_HINT_PGI, 107023).
-define(GL_ALLOW_DRAW_FRG_HINT_PGI, 107024).
-define(GL_ALLOW_DRAW_SPN_HINT_PGI, 107024).
-define(GL_ALLOW_DRAW_MEM_HINT_PGI, 107025).
-define(GL_CLIP_NEAR_HINT_PGI, 107040).
-define(GL_CLIP_FAR_HINT_PGI, 107041).
-define(GL_WIDE_LINE_HINT_PGI, 107042).
-define(GL_BACK_NORMALS_HINT_PGI, 107043).
-define(GL_NATIVE_GRAPHICS_HANDLE_PGI, 107010).
% GL_EXT_compiled_vertex_array 
-define(GL_ARRAY_ELEMENT_LOCK_FIRST_EXT, 16#81A8).
-define(GL_ARRAY_ELEMENT_LOCK_COUNT_EXT, 16#81A9).
% GL_EXT_clip_volume_hint 
-define(GL_CLIP_VOLUME_CLIPPING_HINT_EXT, 16#80F0).
-define(GL_CURRENT_BIT, 16#00000001).
-define(GL_POINT_BIT, 16#00000002).
-define(GL_LINE_BIT, 16#00000004).
-define(GL_POLYGON_BIT, 16#00000008).
-define(GL_POLYGON_STIPPLE_BIT, 16#00000010).
-define(GL_PIXEL_MODE_BIT, 16#00000020).
-define(GL_LIGHTING_BIT, 16#00000040).
-define(GL_FOG_BIT, 16#00000080).
-define(GL_DEPTH_BUFFER_BIT, 16#00000100).
-define(GL_ACCUM_BUFFER_BIT, 16#00000200).
-define(GL_STENCIL_BUFFER_BIT, 16#00000400).
-define(GL_VIEWPORT_BIT, 16#00000800).
-define(GL_TRANSFORM_BIT, 16#00001000).
-define(GL_ENABLE_BIT, 16#00002000).
-define(GL_COLOR_BUFFER_BIT, 16#00004000).
-define(GL_HINT_BIT, 16#00008000).
-define(GL_EVAL_BIT, 16#00010000).
-define(GL_LIST_BIT, 16#00020000).
-define(GL_TEXTURE_BIT, 16#00040000).
-define(GL_SCISSOR_BIT, 16#00080000).
-define(GL_ALL_ATTRIB_BITS, 16#000FFFFF).
-define(GL_CLIENT_PIXEL_STORE_BIT, 16#00000001).
-define(GL_CLIENT_VERTEX_ARRAY_BIT, 16#00000002).
-define(GL_ALL_CLIENT_ATTRIB_BITS, 16#FFFFFFFF).
