%%  Copyright (c) 2001 Dan Gudmundsson
%%
%%  See the file "license.terms" for information on usage and redistribution
%%  of this file, and for a DISCLAIMER OF ALL WARRANTIES.
%% 
%%     $Id: sdl_active.erl,v 1.3 2003/01/13 14:37:14 dgud Exp $
%%
%%%----------------------------------------------------------------------
%%% File    : sdl_active.erl
%%% Author  : Dan Gudmundsson <dgud@erix.ericsson.se>
%%% Purpose : 
%%% Created : 12 Jul 2000 by Dan Gudmundsson <dgud@erix.ericsson.se>
%%%----------------------------------------------------------------------

-module(sdl_active).
-author('dgud@erix.ericsson.se').

-include("sdl_events.hrl").
-include("esdl.hrl").

%%-compile(export_all).
-export([
	 %% Activity Related
	 getAppState/0, 
	 %% Quit Functions
	 quitRequested/0
	]).

-define(SDL_GetAppState, ?SDL_ACTIVE_HRL+1).

-import(sdl, [call/1  %%, cast/2
	     ]).

%% Func:  quitRequested
%% Args:  none
%% Returns:  true | false
%% C-API func: SDL_QuitRequested()
quitRequested() ->
    sdl_events:pumpEvents(),
    case sdl_events:peepEvents(0, ?SDL_PEEKEVENT, ?SDL_QUITMASK) of
	{0, _} ->
	    false;
	_  ->
	    true
    end.

%% Func:  getAppState
%% Args:  none
%% Returns:  State (bitmask)
%% C-API func: Uint8 SDL_GetAppState(void);
getAppState() ->
    <<Res:8>> = call(<<(?SDL_GetAppState):16>>),
    Res.
